<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
		/js/alternativelistcheckboxqueryadmin.js
	</xsl:variable>

	<xsl:template match="Document">	
		
		<div id="AlternativeListCheckboxQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateAlternativeListCheckboxQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateAlternativeListCheckboxQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="AlternativeListCheckboxQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateAlternativeListCheckboxQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				
				<div class="floatleft full bigmarginbottom" id="exportIDDiv" style="display:none">
					<div class="floatleft full">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'exportAlternativeID'" />
							<xsl:with-param name="name" select="'exportAlternativeID'" />
							<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
						</xsl:call-template>
							
						<label for="exportAlternativeID">
							<xsl:value-of select="$i18n.exportAlternativeID" />
						</label>						
				    </div>
				    <div class="floatleft fifty">
						<span class="tiny"><xsl:value-of select="$i18n.exportAlternativeIDInformation" /></span>
					</div>
				</div>
				

				<label for="listName">
					<xsl:value-of select="$i18n.ListName" />
				</label>

				<div class="floatleft full">
				
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'listName'"/>
						<xsl:with-param name="name" select="'listName'"/>
						<xsl:with-param name="element" select="Lists/List"/>
						<xsl:with-param name="labelElementName" select="'Name'"/>
						<xsl:with-param name="valueElementName" select="'ID'"/>
						<xsl:with-param name="selectedValue" select="CurrentList"/>
						<xsl:with-param name="class" select="'full'"/>
					</xsl:call-template>
				
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="emptyListDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.EmptyListDescription" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'emptyListDescription'" />
						<xsl:with-param name="name" select="'emptyListDescription'" />
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
						<xsl:with-param name="rows">4</xsl:with-param>
					</xsl:call-template>
				</div>
			</div>
			
			<label for="useFreeTextAlternative" class="floatleft clearboth"><xsl:value-of select="$i18n.FreeTextAlternative" /></label>
				
			<div class="clearboth floatleft marginbottom"><xsl:value-of select="$i18n.FreeTextAlternativeDescription" /></div>
			
			<div class="floatleft full marginbottom">
				<xsl:text>&#160;</xsl:text>
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'useFreeTextAlternative'" />
					<xsl:with-param name="name" select="'useFreeTextAlternative'" />
					<xsl:with-param name="title" select="$i18n.FreeTextAlternative" />
					<xsl:with-param name="checked">
						<xsl:if test="AlternativeListCheckboxQuery/freeTextAlternative">true</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				
				<xsl:text>&#160;</xsl:text>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'freeTextAlternative'"/>
					<xsl:with-param name="name" select="'freeTextAlternative'"/>
					<xsl:with-param name="title" select="$i18n.FreeTextAlternative"/>
					<xsl:with-param name="value" select="name"/>
					<xsl:with-param name="width" select="'89%'"/>
					<xsl:with-param name="value" select="AlternativeListCheckboxQuery/freeTextAlternative"/>
					<xsl:with-param name="disabled" select="'disabled'"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'requireAllChecked'" />
						<xsl:with-param name="name" select="'requireAllChecked'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
					</xsl:call-template>
					
					<label for="requireAllChecked">
						<xsl:value-of select="$i18n.Query.requireAllChecked" />
					</label>
				</div>

			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="minChecked" class="floatleft"><xsl:value-of select="$i18n.MinChecked" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'minChecked'"/>
						<xsl:with-param name="name" select="'minChecked'"/>
						<xsl:with-param name="title" select="$i18n.MinChecked"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="maxChecked" class="floatleft"><xsl:value-of select="$i18n.MaxChecked" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'maxChecked'"/>
						<xsl:with-param name="name" select="'maxChecked'"/>
						<xsl:with-param name="title" select="$i18n.MaxChecked"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
					</xsl:call-template>
			    </div>
			</div>
			
			<xsl:variable name="options">
				<option>
					<name><xsl:value-of select="$i18n.Columns.One"/></name>
					<value>ONE</value>
				</option>
				<option>
					<name><xsl:value-of select="$i18n.Columns.Two"/></name>
					<value>TWO</value>
				</option>
				<option>
					<name><xsl:value-of select="$i18n.Columns.Three"/></name>
					<value>THREE</value>
				</option>
			</xsl:variable>
				
			<div class="floatleft full bigmarginbottom">
				<label for="columnType" class="floatleft clearboth"><xsl:value-of select="$i18n.Columns" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'columns'"/>
						<xsl:with-param name="name" select="'columns'"/>
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'value'" />
						<xsl:with-param name="element" select="exsl:node-set($options)/option" />
						<xsl:with-param name="selectedValue" select="AlternativeListCheckboxQuery/columns" />
					</xsl:call-template>
		    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideTitle'" />
						<xsl:with-param name="name" select="'hideTitle'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
					</xsl:call-template>
					
					<label for="hideTitle">
						<xsl:value-of select="$i18n.HideTitle" />
					</label>
				</div>

			</div>
			
			<h2 class="floatleft full bigmargintop"><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="AlternativeListCheckboxQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'MinCheckedBiggerThanMaxChecked']">
		
		<p class="error">
			<xsl:value-of select="$i18n.MinCheckedBiggerThanMaxChecked" />
		</p>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedAlternativeListCheckboxQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.AlternativeListCheckboxQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'listName'">
				<xsl:value-of select="$i18n.ListName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minChecked'">
				<xsl:value-of select="$i18n.minChecked" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxChecked'">
				<xsl:value-of select="$i18n.maxChecked" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'columns'">
				<xsl:value-of select="$i18n.Columns" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>