package com.nordicpeak.flowengine.biznodevehiclealternativelist.biznoderesponse;

import java.util.stream.Stream;

//Fordonsslagskod och Fordonsslag alltid satt?, Fordonsslagsklass ibland, FordonskategoriEu ibland.

// Fordonsslag (Fordonsslagskod)
// PB (=01), LB (=02), BUSS (=03), SLP (=04), MC (=05), TR (=06), MRED (=07), TGV (=08), TGSK (=09), TGSL (=10), MOPED (=13), TGSN (=14), TGHJUL (=15)
// PB = Personbil, LB = Lastbil, MC = Motorcykel, TR = Traktor, MRED = Motoredskap, TGV = Terrngvang, TGSK = Terrngskoter, 
// TGSL = Terrgnslp, MOPED = Moped klass 1, TGSN = Snskoter, TGHJUL = Terrnghjuling

public enum VehicleType {
	PB("01","Personbil"), LB("02","Lastbil"), BUSS ("03","Buss"), SLAP("04","Slpvagn"), MC ("05","Motorcykel"), 
	TR ("06","Traktor"), MRED ("07","Motorredskap"), TGV ("08","Terrngvagn"), 
	TGSK ("09","Terrngskoter"), TGSL ("10","Terrngslp"), MOPED ("13","Moped"), TGSNO ("14","Snskoter"), TGHJUL ("15","Terrnghjuling");
	
	private final String code;
	private final String description;
	
	
	VehicleType(String code, String description)
	{
		this.code = code;
		this.description = description;
	}
	
	public String getCode()
	{
		return code;
	}
	
	public String getDescription()
	{
		return description;
	}
	
	public static VehicleType getType(String code)
	{
		return Stream.of(values()).filter(e -> e.getCode().equals(code)).findFirst().orElse(null);
	}

}
