<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:import href="classpath://com/nordicpeak/flowengine/Message.sv.xsl"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/usergrouplist/UserGroupList.sv.xsl"/>
	<xsl:include href="BookingCommon.sv.xsl"/>
	<xsl:include href="BookingSlotAdminModuleTemplates.xsl"/>
	
	<xsl:variable name="java.bookingSlotNotBookableTextOpens">ppnar fr bokning via e-tjnst: $bookingSlot.bookableStart</xsl:variable>
	<xsl:variable name="java.bookingSlotNotBookableTextClosed">Stngt fr bokning via e-tjnst sen: $bookingSlot.bookableEnd</xsl:variable>
	<xsl:variable name="java.bookingSlotNotBookableTextBetween">ppet fr bokning via e-tjnst: $bookingSlot.bookableStart - $bookingSlot.bookableEnd</xsl:variable>
	
	<xsl:variable name="i18n.Add">Lgg till</xsl:variable>
	
	<xsl:variable name="i18n.ListBookingSlots.title">Visa bokningstillfllen</xsl:variable>
	<xsl:variable name="i18n.NoBookingSlots">Inga bokningstillfllen hittades</xsl:variable>
	<xsl:variable name="i18n.NoOtherBookingSlots">Inga andra bokningstillfllen hittades</xsl:variable>
	<xsl:variable name="i18n.validationError.BookingSlotNotFound">Det begrda bokningstillfllet hittades inte</xsl:variable>
	
	<xsl:variable name="i18n.ListBookings.title">Visa bokningar</xsl:variable>
	<xsl:variable name="i18n.ListArchivedBookings.title">Visa avbokade bokningar</xsl:variable>
	<xsl:variable name="i18n.NoBookings">Inga bokningar hittades</xsl:variable>
	<xsl:variable name="i18n.validationError.BookingNotFound">Den begrda bokningen hittades inte</xsl:variable>
	
	<xsl:variable name="i18n.AddBookingSlot">Lgg till bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.UpdateBookingSlot">ndra bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.ShowBookingSlot">Visa bokningstillflle</xsl:variable>
	
	<xsl:variable name="i18n.BookingSlot.StartTime">Starttid</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.EndTime">Sluttid</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.Duration">Passlngd (minuter)</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.BookableRestricted">Begrnsa nr tillfllet r bokningsbart frn e-tjnsten/mina sidor</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.BookableStartDate">Bokningsbar startdatum</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.BookableStartTime">Bokningsbar starttid</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.BookableEndDate">Bokningsbar slutdatum</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.BookableEndTime">Bokningsbar sluttid</xsl:variable>
	
	<xsl:variable name="i18n.Booking.FlowInstanceID">rende nr.</xsl:variable>
	
	<xsl:variable name="i18n.DownloadFlowInstancePDF">Ladda ner rende</xsl:variable>
	<xsl:variable name="i18n.ShowFlowInstance">Visa rende</xsl:variable>
	
	<xsl:variable name="i18n.Contact.CitizenIdentifier">Personnummer</xsl:variable>
	<xsl:variable name="i18n.Contact.CitizenIdentifier.placeholder">MMDD-XXXX</xsl:variable>
	
	<xsl:variable name="i18n.DeleteBooking">Ta bort bokning</xsl:variable>
	<xsl:variable name="i18n.DeleteBookingConfirm">r du sker p att du vill ta bort bokning</xsl:variable>
	
	<xsl:variable name="i18n.ArchiveBooking">Avboka</xsl:variable>
	<xsl:variable name="i18n.UnArchiveBooking">terstll bokning</xsl:variable>
	<xsl:variable name="i18n.ArchiveBooking.Title">Avboka</xsl:variable>
	<xsl:variable name="i18n.UnArchiveBooking.Title">terstll bokning</xsl:variable>
	<xsl:variable name="i18n.ArchiveBooking.Description">Lmna en kommentar till avbokningen, kommentaren kommer att skickas som ett internt meddelande till klienten p tidbokningen.</xsl:variable>
	<xsl:variable name="i18n.ArchiveBooking.Description.Analog">Lmna en kommentar till avbokningen, kommentaren kommer att sparas som en intern notering p tidbokningen.</xsl:variable>
	<xsl:variable name="i18n.UnArchiveBooking.Description">Lmna en kommentar till avbokningen, kommentaren kommer att skickas som ett internt meddelande till klienten p tidbokningen.</xsl:variable>
	<xsl:variable name="i18n.UnArchiveBooking.Description.Analog">Lmna en kommentar till avbokningen, kommentaren kommer att sparas som en intern notering p tidbokningen.</xsl:variable>
	
	<xsl:variable name="i18n.ShowBookingSlot.title">Bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.Bookings">Bokningar</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.Repeating.1">terkommande frn</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.Repeating.2">till</xsl:variable>
	<xsl:variable name="i18n.DeleteBookingSlot">Ta bort bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.DeleteBookingSlotConfirm.1">r du sker p att du vill ta bort bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.DeleteBookingSlotConfirm.2">och alla tillhrande bokningar</xsl:variable>

	<xsl:variable name="i18n.DeleteRepeating">Ta bort terkommande grupp</xsl:variable>
	<xsl:variable name="i18n.DeleteRepeatingConfirm">r du sker p att du vill ta bort alla bokningstillfllen (utan bokningar, framt i tiden) som tillhr samma terkommande grupp</xsl:variable>
	<xsl:variable name="i18n.UpdateRepeating">ndra terkommande grupp</xsl:variable>
	
	<xsl:variable name="i18n.AddBooking">Lgg till bokning</xsl:variable>
	<xsl:variable name="i18n.ArchiveAllBookings">Avboka alla</xsl:variable>
	<xsl:variable name="i18n.ArchiveAllBookingsDisabled">Finns inga bokningar att avboka</xsl:variable>
	<xsl:variable name="i18n.AddBookingDisabled">Du kan inte lgga till en bokning d tiden har passerat</xsl:variable>
	<xsl:variable name="i18n.AddBookingDisabledFull">Du kan inte lgga till en bokning d tillfllet r fullt</xsl:variable>
	<xsl:variable name="i18n.UpdateBooking">ndra bokning</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.Title">Bekrfta bokningar fr</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.Confirm">Bekrfta</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.Cancel">Avbryt</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.UnknownBooking">Oknd beskare</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.Description">Bokningsbekrftelse kommer att skickas via</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.Email">e-post</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.SMS">SMS</xsl:variable>
	<xsl:variable name="i18n.AddBooking.Confirm.And">och</xsl:variable>

	<xsl:variable name="i18n.validationError.HasPassed">Du kan inte lgga till en bokning p en tid som har passerat</xsl:variable>
	<xsl:variable name="i18n.validationError.NoFreeSlots">Tiden har inte lngre ngra lediga platser</xsl:variable>
	<xsl:variable name="i18n.validationError.NotEnoughFreeSlots">Tiden har inte lngre nog mnga lediga platser</xsl:variable>
	<xsl:variable name="i18n.validationError.NotAllowedToSelectSize">Du har valt fr mnga platser</xsl:variable>

	<xsl:variable name="i18n.ShowBooking.title">Bokad tid</xsl:variable>
	<xsl:variable name="i18n.ShowBooking.Archived.title">Avbokad tid</xsl:variable>
	<xsl:variable name="i18n.PrimaryContact">Uppgifter vid bokning</xsl:variable>
	<xsl:variable name="i18n.UserContact">Uppgifter frn Mina sidor</xsl:variable>
	<xsl:variable name="i18n.ManualContact">Manuellt uppdaterade uppgifter</xsl:variable>
	
	<xsl:variable name="i18n.Contact.Name">Namn</xsl:variable>
	<xsl:variable name="i18n.Contact.Email">E-post</xsl:variable>
	<xsl:variable name="i18n.Contact.Phone">Telefon</xsl:variable>
	<xsl:variable name="i18n.Contact.MobilePhone">Mobiltelefon</xsl:variable>
	<xsl:variable name="i18n.Contact.Address">Adress</xsl:variable>
	<xsl:variable name="i18n.Contact.PostalCode">Postnummer</xsl:variable>
	<xsl:variable name="i18n.Contact.PostalAddress">Ort</xsl:variable>
	<xsl:variable name="i18n.Contact.FirstName">Frnamn</xsl:variable>
	<xsl:variable name="i18n.Contact.LastName">Efternamn</xsl:variable>
	
	<xsl:variable name="i18n.NotPayed">Ej betald</xsl:variable>
	
	<xsl:variable name="i18n.ShowCalendar">Visa kalender</xsl:variable>
	<xsl:variable name="i18n.ShowBooking">Visa bokning</xsl:variable>
	
	<xsl:variable name="i18n.validationError.PaymentDateInFuture">Betalningsdatumet fr inte vara i framtiden</xsl:variable>
	<xsl:variable name="i18n.validationError.ErrorImportingCitizen">Ingen person hittades med det aktuella personnumret, kontrollera att personnummret stmmer eller frsk igen senare</xsl:variable>
	<xsl:variable name="i18n.validationError.PersonAlreadyInCalendar">Personen har redan en aktiv bokning i den hr kalendern</xsl:variable>
	<xsl:variable name="i18n.validationError.PersonAlreadyInBookingSlot">Personen har redan en bokad plats i det hr bokningstillfllet</xsl:variable>
	<xsl:variable name="i18n.validationError.DateInPast">Datumet mste ligga framt i tiden</xsl:variable>
	<xsl:variable name="i18n.validationError.BookableStartOrEndRequired">Du mste antingen vlja bokningsbar startdatum eller slutdatum</xsl:variable>
	<xsl:variable name="i18n.validationError.BookableDateAfterDate">Ett tillflle kan inte vara bokningsbart efter tillfllets starttid</xsl:variable>
	<xsl:variable name="i18n.validationError.BookableStartAfterBookableEnd">Bokningsbar startdatum mste vara innan bokningsbar slutdatum</xsl:variable>
	<xsl:variable name="i18n.validationError.RepetitionToDateBeforeFromDate">Slutdatum mste vara efter startdatum!</xsl:variable>
	<xsl:variable name="i18n.validationError.RepetitionPeriodLessThanOneWeek">Repitionsperioden r mindre n 1 vecka!</xsl:variable>
	<xsl:variable name="i18n.validationError.RepetitionToDateBeforeOldToDate">Slutdatum kan bara flyttas framt i tiden!</xsl:variable>
	<xsl:variable name="i18n.validationError.TooManyBooking">Du har angett fr mnga bokningar i frhllande till antal platser</xsl:variable>
	<xsl:variable name="i18n.validationError.BookingSlotHasPassed">Bokningstillfllet har passerat</xsl:variable>
	
	<xsl:variable name="i18n.UpdateContact">ndra kontakt</xsl:variable>
	
	<xsl:variable name="i18n.ShowBookings">Visa bokningar</xsl:variable>
	<xsl:variable name="i18n.ExportToExcel">Exportera till Excel</xsl:variable>
	<xsl:variable name="i18n.Export.description">Skriv in ett datum filter om nskat och klicka p exportera.</xsl:variable>
	<xsl:variable name="i18n.Export.fromDate">Frn</xsl:variable>
	<xsl:variable name="i18n.Export.toDate">Till</xsl:variable>
	
	<xsl:variable name="i18n.InvalidFileExtension.Part1">Filen</xsl:variable>
	<xsl:variable name="i18n.InvalidFileExtension.Part2">r av en felaktig filtyp.</xsl:variable>
	<xsl:variable name="i18n.InvalidFileExtension.Part3">Fljande filtyper r tilltna:</xsl:variable>
	
	<xsl:variable name="i18n.UnableToParseFile.part1">Den gick inte att tolka innehllet i filen </xsl:variable>
	<xsl:variable name="i18n.UnableToParseFile.part2">.</xsl:variable>
	
	<xsl:variable name="i18n.validationError.ErrorImportingExcel">Ett fel uppstod vid import av bokningstillflle</xsl:variable>
	
	<xsl:variable name="i18n.SendMessageTitle.Calendar">Skapa utskick fr kalender</xsl:variable>
	<xsl:variable name="i18n.SendMessageTitle.BookingSlot">Skapa utskick fr bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.SendMessage.toDigital">Skicka till digitala anvndare</xsl:variable>
	<xsl:variable name="i18n.SendMessage.toAnalogWithEmail">Skicka till analoga anvndare med e-post</xsl:variable>
	<xsl:variable name="i18n.SendMessage.pending">Kommande bokningar</xsl:variable>
	<xsl:variable name="i18n.SendMessage.archived">Arkiverade bokningar</xsl:variable>
	<xsl:variable name="i18n.SendMessage.EmailsSent">E-postmeddelande skickat till</xsl:variable>
	<xsl:variable name="i18n.SendMessage.Recipients">anvndare</xsl:variable>
	<xsl:variable name="i18n.SendMessage.Email">E-post</xsl:variable>
	<xsl:variable name="i18n.SendMessage.Subject">Rubrik</xsl:variable>
	<xsl:variable name="i18n.SendMessage.Message">Meddelande</xsl:variable>
	<xsl:variable name="i18n.emailSenderName">e-post avsndarnamn</xsl:variable>
	<xsl:variable name="i18n.emailSenderAddress">e-post avsndaradress</xsl:variable>
	<xsl:variable name="i18n.emailSubject">e-post rubrik</xsl:variable>
	<xsl:variable name="i18n.emailMessage">e-postmeddelande</xsl:variable>
	<xsl:variable name="i18n.SendMessage.SubmitMessage">Skicka meddelande</xsl:variable>
	<xsl:variable name="i18n.SendMessage.SubmittingMessage">Skickar meddelande</xsl:variable>
	<xsl:variable name="i18n.Back">Tillbaka</xsl:variable>
	<xsl:variable name="i18n.SendMessages">Skapa utskick</xsl:variable>
	<xsl:variable name="i18n.SendMessage.recipientType.title">Vlj mottagare</xsl:variable>
	<xsl:variable name="i18n.SendMessage.recipientType.description">Vlj vilka mottagare som ska f utskicket baserat p vilken typ av digital status de har. Siffran inom parantes visar antalet bokningar av den typen.</xsl:variable>
	<xsl:variable name="i18n.SendMessage.recipientType.description2">Vlj vilka mottagare som ska f utskicket baserat p bokningens status. Siffran inom parantes visar antalet bokningar av den typen.</xsl:variable>
	<xsl:variable name="i18n.NoRecipientTypesSelected">Du mste vlja minst en typ av anvndare att skicka till.</xsl:variable>
	<xsl:variable name="i18n.NoRecipientStateSelected">Du mste vlja minst en bokningsstatus att skicka till.</xsl:variable>
	<xsl:variable name="i18n.EmailSenderNotSet">Du mste stlla in e-post avsndare p kalendern fr att kunna anvnda den hr funktionen.</xsl:variable>
	
	<xsl:variable name="i18n.InvalidRecipientEmail.1">Det gick inte att skicka e-post till bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.InvalidRecipientEmail.2">fr den har den ogiltiga e-post adressen</xsl:variable>
	<xsl:variable name="i18n.InvalidRecipientPhoneNumber.1">Det gick inte att skicka SMS till bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.InvalidRecipientPhoneNumber.2">fr den har det ogiltiga telefonnumret</xsl:variable>
	
	<xsl:variable name="i18n.ErrorSendingToRecipientViaEmail.1">Det gick inte att skicka till bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.ErrorSendingToRecipientViaEmail.2">via e-post till adressen</xsl:variable>
	<xsl:variable name="i18n.ErrorSendingToRecipientViaSMS.1">Det gick inte att skicka till bokningstillflle</xsl:variable>
	<xsl:variable name="i18n.ErrorSendingToRecipientViaSMS.2">via SMS till telefonnumret</xsl:variable>
	
	<xsl:variable name="i18n.UserTagsTable.description">Fljande taggar kan anvndas i rubrik och meddelande</xsl:variable>
	<xsl:variable name="i18n.Tag">Tagg</xsl:variable>
	<xsl:variable name="i18n.Description">Beskrivning</xsl:variable>
	<xsl:variable name="i18n.CalendarNameTag">Kalendernamn</xsl:variable>
	<xsl:variable name="i18n.BookingURLTag">Adress till bokningen (krver inloggning fr att anvndas)</xsl:variable>
	<xsl:variable name="i18n.PosterFirstnameTag">Kontaktpersonens frnamn</xsl:variable>
	<xsl:variable name="i18n.PosterLastnameTag">Kontaktpersonens efternamn</xsl:variable>
	<xsl:variable name="i18n.BookingSlotStartTag">Bokningens startdatum och tid</xsl:variable>
	<xsl:variable name="i18n.BookingSlotEndTag">Bokningens slutdatum och tid</xsl:variable>
	
	<xsl:variable name="i18n.Error.NoPersonProvider">Det saknas en vg att hmta personuppgifter p, kontakta administratren.</xsl:variable>
	
	<xsl:variable name="i18n.FilterManagers">Handlggare</xsl:variable>
	<xsl:variable name="i18n.FilterManagers.NoFilter">Alla</xsl:variable>
	<xsl:variable name="i18n.ViewAsList">Visa som lista</xsl:variable>
	<xsl:variable name="i18n.ViewAsCalendar">Visa som kalender</xsl:variable>
	
	<xsl:variable name="i18n.NewMessage.NoNotificationWay">Anvndaren har inte angett e-post eller mobiltelefon och kommer inte bli notifierad om nytt meddelande.</xsl:variable>
	<xsl:variable name="i18n.SearchBookings">Sk bland bokningar</xsl:variable>
	<xsl:variable name="i18n.FilterList">Filtrera i listan</xsl:variable>
	<xsl:variable name="i18n.SearchComplete">Skningen r klar.</xsl:variable>
	<xsl:variable name="i18n.Gave">gav</xsl:variable>
	<xsl:variable name="i18n.Hits">trffar</xsl:variable>
	
	<xsl:variable name="i18n.Name">Skande</xsl:variable>
	<xsl:variable name="i18n.SlotDate">Tillfllets datum</xsl:variable>
	<xsl:variable name="i18n.Added">Anskningsdatum</xsl:variable>
	<xsl:variable name="i18n.BookedVia">Bokad av</xsl:variable>
	<xsl:variable name="i18n.Archived">Avbokad</xsl:variable>
	<xsl:variable name="i18n.Flow">E-tjnst</xsl:variable>
	<xsl:variable name="i18n.Manager">Handlggare</xsl:variable>
	<xsl:variable name="i18n.NoHits">Skningen gav inte trff p ngra bokningar</xsl:variable>
	<xsl:variable name="i18n.Show">Visa</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.AddBookings">Boka in beskare</xsl:variable>
	<xsl:variable name="i18n.Booking.TypeSSN">Ange personnummer (MMDD-XXXX) och tryck enter fr att lgga till bokning</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.Clients">Bokningar</xsl:variable>
	<xsl:variable name="i18n.RemoveClient">Ta bort bokningen</xsl:variable>
	<xsl:variable name="i18n.MobilePhone">Mobiltelefonnummer</xsl:variable>
	<xsl:variable name="i18n.InvalidSSN">Ogiltigt personnummer</xsl:variable>
	<xsl:variable name="i18n.BookingDuplicate">Personnumret r redan tillagt</xsl:variable>
	<xsl:variable name="i18n.VerifySSN">Verifiera personnummer</xsl:variable>
	<xsl:variable name="i18n.ResendConfirm">Vill du verkligen skicka en pminnelse</xsl:variable>
	<xsl:variable name="i18n.Resend">Skicka pminnelse</xsl:variable>
	
	<xsl:variable name="i18n.BookingSlot.PassedBookingSlots">Passerade bokningstillfllen</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.ShowPassedBookingSlots">Visa passerade bokningstillfllen</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.CurrentBookingSlots">Aktiva bokningstillfllen</xsl:variable>
	<xsl:variable name="i18n.BookingSlot.ShowCurrentBookingSlots">Visa aktiva bokningstillfllen</xsl:variable>
	
	<xsl:variable name="i18n.Repeating">Repetion</xsl:variable>
	<xsl:variable name="i18n.Repeating.RepetitionInterval">Repetionsintervall</xsl:variable>
	<xsl:variable name="i18n.Repeating.RepetitionInterval.Weekly">Varje vecka</xsl:variable>
	<xsl:variable name="i18n.Repeating.RepetitionInterval.BiWeekly">Varannan vecka</xsl:variable>
	<xsl:variable name="i18n.Repeating.RepetitionInterval.UseCustom">Valfritt intervall</xsl:variable>
	<xsl:variable name="i18n.Repeating.RepetitionInterval.Custom">Intervall i antal veckor</xsl:variable>
	<xsl:variable name="i18n.Repeating.ToDate">Slutdatum</xsl:variable>
		
	<xsl:variable name="i18n.WeekView">Veckovy</xsl:variable>
	<xsl:variable name="i18n.MonthView">Mnadsvy</xsl:variable>
	<xsl:variable name="i18n.Week">Vecka</xsl:variable>
	<xsl:variable name="i18n.GoToToday">G till idag</xsl:variable>
	
	<xsl:variable name="i18n.BookingSlot.NotBookable">Ej bokningsbar</xsl:variable>
	
	<xsl:variable name="i18n.ExtensionErrors">Ett valideringsfel har uppsttt i ett tillgg, kolla lngre ner efter vad som r fel.</xsl:variable>
	
</xsl:stylesheet>
