package com.nordicpeak.flowengine.booking.beans;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.contactdetailquery.ContactDetailQueryInstance;

@Table(name = "bookings_manual_contacts")
@XMLElement
public class ManualContact extends BaseContact {

	private static final long serialVersionUID = 7634780772195411125L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer bookingID;

	@DAOManaged
	@OneToOne
	@XMLElement
	private Booking booking;

	public ManualContact() {}

	public ManualContact(User user) {

		super(user);
	}

	public ManualContact(ContactDetailQueryInstance contactDetailQueryInstance) {

		super(contactDetailQueryInstance);
	}

	public Integer getBookingID() {

		return bookingID;
	}

	public void setBookingID(Integer bookingSlotID) {

		this.bookingID = bookingSlotID;
	}

	public boolean isEmpty() {

		return StringUtils.isEmpty(firstname, lastname, email, phone, mobilePhone, address, zipCode, postalAddress);
	}

}
