package com.nordicpeak.flowengine.booking.interfaces;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.ViewFragment;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.booking.beans.BookingCalendar;
import com.nordicpeak.flowengine.booking.beans.BookingSlot;
import com.nordicpeak.flowengine.booking.beans.Repeating;

public interface BookingSlotFormExtensionProvider {

	String getProviderID();

	ViewFragment getBookingSlotFormViewFragment(BookingCalendar calendar, BookingSlot bookingSlot, HttpServletRequest req, User user, URIParser uriParser, ValidationException validationException) throws Exception;

	ViewFragment getRepeatingFormViewFragment(Repeating repeating, HttpServletRequest req, User user, URIParser uriParser, ValidationException validationException) throws Exception;

	void processBookingSlotFormRequest(BookingSlot bookingSlot, HttpServletRequest req, User user, URIParser uriParser) throws Exception;

	void processBookingSlotAddOrUpdate(BookingSlot bookingSlot, HttpServletRequest req, User user, URIParser uriParser, boolean processBookings) throws Exception;
}
