package com.nordicpeak.flowengine.booking.populators;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import se.unlogic.standardutils.annotations.UnsupportedFieldTypeException;
import se.unlogic.standardutils.populators.BeanStringPopulator;
import se.unlogic.standardutils.populators.annotated.AnnotatedResultSetPopulator;
import se.unlogic.standardutils.populators.annotated.BeanResultSetPopulationException;

import com.nordicpeak.flowengine.booking.beans.BookingSlot;

public class BookingSlotWithCountPopulator extends AnnotatedResultSetPopulator<BookingSlot> {

	public BookingSlotWithCountPopulator(List<? extends BeanStringPopulator<?>> typePopulators) throws UnsupportedFieldTypeException {

		super(BookingSlot.class, typePopulators);
	}

	@Override
	public BookingSlot populate(ResultSet rs) throws SQLException, BeanResultSetPopulationException {

		BookingSlot bookingSlot = super.populate(rs);

		bookingSlot.setBookingsCount(rs.getInt("bookingsCount"));

		return bookingSlot;
	}

}
