var SendMessageFormi18n = {
	SubmittingMessage: "not set",
}

var SearchResultsi18n = {
	Yes: "not set",
	No: "not set",
	Flow: "not set",
	Manager: "not set",
}

$(function() {
	
	var delay = (function() {
		
		var timer = 0;

		return function(callback, ms) {
			
			clearTimeout(timer);
			timer = setTimeout(callback, ms);
		};
	})();

	var $calendarSearch = $("#calendar-search");
	var $bookingSearchResults = $("#booking-search-results");
	var viewMode = 'CALENDAR';

	$("#view-toggler").on("click", function(e) {
		
		e.preventDefault();

		toggleViewMode();
	});

	if (Cookies.get('bookingSlotAdminModule.viewMode') === 'LIST') {

		toggleViewMode();
	}

	function toggleViewMode() {

		$('#calendar-view, #table-wrapper').toggle();
		$("#view-toggler").children().toggle();

		viewMode = viewMode === 'CALENDAR' ? 'LIST' : 'CALENDAR';
	}

	$(window).on("unload", function() {

		Cookies.set('bookingSlotAdminModule.viewMode', viewMode);
	});

	var search = (function(query) {
		
		delay(function() {
			
			if (query) {
				
				$.ajax({
					url: $calendarSearch.data("url") + "&q=" + encodeURIComponent(query),
					cache: false,
					success: function(data, textStatus, jqXHR) {

						var result = data.data;
						var hits;

						if (result != undefined && result.length > 0) {
							
							var rows = "";

							for (var i = 0; i < result.length; i++) {
								
								var booking = result[i];

								var row = '<tr onclick="location.href=\'' + $bookingSearchResults.data("showurl") + booking.id + '\'">';
								row += '<td></td>'; // icon?
								row += '<td>' + booking.name + '</td>';
								row += '<td>' + booking.added + '</td>';
								row += '<td>' + booking.slotDate + '</td>';
								row += '<td>' + (booking.flowInstanceID ? SearchResultsi18n.Flow : SearchResultsi18n.Manager) + '</td>';
								row += '<td>' + (booking.archived ? SearchResultsi18n.Yes : SearchResultsi18n.No) + '</td>';
								row += '<td class="link"><a href="' + $bookingSearchResults.data("showurl") + booking.id + '" class="btn btn-dark btn-inline">' + $bookingSearchResults.data("show") + '</a></td>';
								row += '</tr>';

								rows += row;
							}

							$bookingSearchResults.find(".oep-table tbody").html(rows);

							hits = result.length;
							
						} else {

							$bookingSearchResults.find(".oep-table tbody").html('<tr><td colspan="5">' + $bookingSearchResults.data("nohits") + '</td></tr>');
							hits = 0;
						}

						$bookingSearchResults.find(".hits").html(hits);
						$bookingSearchResults.find(".title").html(query);

						$bookingSearchResults.show();
					}
				});
				
			} else {
				
				$bookingSearchResults.hide();
			}
		}, 200);
	});

	$calendarSearch.on("keyup", function() {
		
		search($calendarSearch.val());
	});

	$calendarSearch.on("click", "button", function(e) {
		
		e.preventDefault();

		search($calendarSearch.val());
	});

	$bookingSearchResults.on("click", ".close", function(e) {
		
		e.preventDefault();

		$bookingSearchResults.hide();
	});

	$("#showPassedBookingSlots, #showCurrentBookingSlots").on("click", function(e) {
		
		e.preventDefault();

		$("#currentBookingSlots, #passedBookingSlots").toggle();
	});

	$('#sendMessageForm').on("submit", function() {

		var $submitButton = $(this).find('input[type="submit"]');

		$submitButton.parent().addClass('spinning');
		$submitButton.prop({
			disabled: true,
			value: SendMessageFormi18n.SubmittingMessage
		});
	});

	$('#bookableRestricted').on("change", function() {

		$('#bookableContainer').toggle(this.checked);

	}).trigger("change");
});

function commentModal(event, button, formname) {
	
	event.preventDefault();
	event.stopPropagation();

	var form = $(formname);

	var modal = form.find(".comment-modal");

	var message = form.find("input[name='comment']");

	var config = {
		otherClose: '.close',

		beforeOpen: function() {
			
			modal.find("textarea[name = 'message']").val(message.val());
		},

		afterContent: function() {
			
			var feather = this;
			feather.$content.removeClass("no-sections");

			feather.$content.find("input.close").on("click", function() {
				feather.$content.addClass("submit");
			});
		},

		beforeClose: function() {
			
			var feather = this;
			message.val(feather.$content.find("textarea[name = 'message']").val());
		},

		afterClose: function() {
			
			var feather = this;

			if (feather.$content.hasClass('submit')) {

				form.trigger("submit");
			}
		},
	};

	$.featherlight(modal, config);
}

var Calendari18n = {
	OneSlot: "not set",
	MultipleSlots: "not set",
	DescriptionTitle: "not set",
	ManagersTitle: "not set",
};

function bookingQueryUpdateManagerFilter(event, dropdown2){

	var dropdown = $(dropdown2);
	var managerID = dropdown.val();
	
	$.ajax({
		url: dropdown.data("url") + "?m=" + managerID,
		cache: false,
		
	}).done(function(data, textStatus, jqXHR){
		
		if (data.titleEvents != undefined && data.detailedEvents != undefined) {
		
			reloadBookingQueryCalendar(managerID, data.titleEvents, data.detailedEvents)
			
		} else {
			
			if (console != undefined){
				console.error("no calendar events: " + textStatus + ", " + data);
			}
			
			alert("Gick inte att hämta kalenderhändelser"); //showErrorDialog();
		}
		
	}).fail(function(jqXHR, textStatus, errorThrown){
		
		if (console != undefined){
			console.error("failed to get calendar events: " + textStatus + ", " + errorThrown);
		}
		
		alert("Gick inte att hämta kalenderhändelser"); //showErrorDialog();
	});
}

var bookingslotadminCalendar;
var bookingslotadminCalendarManager;
var bookingslotadminCalendarDetailedEvents;

function reloadBookingQueryCalendar(managerID, titleEvents, detailedEvents){
	
	bookingslotadminCalendarDetailedEvents = detailedEvents;
	
	var calendar = bookingslotadminCalendar;
	calendar.setEvents(titleEvents);
	
	var calendarElement = $('.calendar');
	calendarElement.find(".managerfilter").val(managerID);
	bookingslotadminCalendarManager = managerID;
}

function initBookingSlotAdminCalendar(container){
	
	var calendarElement = container.find('.calendar');
	var calendarTemplate = Handlebars.compile(container.find('.calendar-template').html());
	var dayTemplate = Handlebars.compile(container.find('.calendar-day-template').html());
	bookingslotadminCalendarDetailedEvents = JSON.parse(container.find(".events-json").text());
	var titleEvents = JSON.parse(container.find(".events-title-json").text());
	
	var openDay = function (dayElement, events, parent, date) {
    	
        var data = {};

        data.events = events;
        data.day = date.format('D MMMM YYYY');
        data.date = date.format('YYYY-MM-DD');
        data.showDuration = calendarElement.data("showduration");
        data.showURL = calendarElement.data("showurl");

        var day = $(dayTemplate(data));

        day.insertAfter(parent).find('h2 span').text(dayElement.find('> span').text());
        day.slideDown(300);

        $('body, html').animate({
            scrollTop: (day.parent().offset().top) + 'px'
        }, 0);
    }
	
	var lastDate = Cookies.get('bookingSlotAdminModule.lastDate');
	
	var adjacentMonthDay = undefined;
	
    var cal = calendarElement.clndr({
        startWithMonth: moment(lastDate).isValid() ? lastDate : moment(),
        daysOfTheWeek: ['Må<span class="hide-mobile">ndag</span>', 'Ti<span class="hide-mobile">sdag</span>', 'On<span class="hide-mobile">sdag</span>', 'To<span class="hide-mobile">rsdag</span>', 'Fr<span class="hide-mobile">edag</span>', 'Lö<span class="hide-mobile">rdag</span>', 'Sö<span class="hide-mobile">ndag</span>'],
        dateParameter: "start",
        events: titleEvents,
        render: function(data) {
            return calendarTemplate(data);
        },
        adjacentDaysChangeMonth: true,
        clickEvents: {
            click: function(target) {
            	
            	if (this.options.extras.weekView) return;
            	
                var dayElement = $(target.element),
                    events = bookingslotadminCalendarDetailedEvents[target.date.format('YYYY-MM-DD')],
                    parent = dayElement.closest('.calendar-row');

                if(dayElement.hasClass('adjacent-month')) {
                	adjacentMonthDay = dayElement;
                	adjacentMonthDay.removeClass("adjacent-month next-month");
                }
                
                if (dayElement.hasClass('disabled') || dayElement.hasClass('adjacent-month')) {
                    return;
                }

                if (dayElement.hasClass('active')) {
                    dayElement.removeClass('active');
                    calendarElement.find(".calendar-day").slideUp(300);
                    return;
                }
                
                calendarElement.find('.calendar-row a.active').removeClass('active');
                dayElement.addClass('active');
                
                var calendarDay = calendarElement.find(".calendar-day");

                if (calendarDay.length > 0) {
                	
                	calendarDay.slideUp(300, function() {
                		calendarDay.remove();
                        openDay(dayElement, events, parent, target.date);
                    });
                    
                } else {
                    openDay(dayElement, events, parent, target.date);
                }
                
                this.options.extras.lastDate = dayElement.data('date');
            },
            onMonthChange: function(month) {

            	if (this.options.extras.weekView) return;
				
            	calendarElement.find('.calendar-month').html(month.format('MMMM YYYY').toUcFirst());
            	calendarElement.find(".managerfilter").val(bookingslotadminCalendarManager);
            }
        },
        extras: {
        	weekView: false,
        	lastDate: lastDate
        },
        doneRendering: function() {

        	if(adjacentMonthDay) {
        		adjacentMonthDay.trigger("click");
        		adjacentMonthDay = undefined;
        	}
        	
        	if (this.options.extras.weekView) showWeekView();
        }
    });
    
    bookingslotadminCalendar = cal;
    
    calendarElement.on("click", "a.clndr-previous-button, a.clndr-next-button, .calendar-row a", function(e) {
    	
    	if (!cal.options.extras.weekView) e.preventDefault();
	});
    
	$(window).on("unload", function(){
		
    	if (cal) {

			updateCalendarLastDate();
			
			Cookies.set('bookingSlotAdminModule.weekView', cal.options.extras.weekView);
			Cookies.set('bookingSlotAdminModule.lastDate', cal.options.extras.lastDate);
    	}
	});
    
    function updateCalendarLastDate() {
   		
		var currentDateIsVisible = $('.calendar a[data-date="' + cal.options.extras.lastDate + '"].day:visible').length;
		var firstDateOfCurrentMonthOrWeek;

    	if (!currentDateIsVisible && (firstDateOfCurrentMonthOrWeek = $('.calendar .day:visible:not(.last-month)').first().data('date'))) {
    		
			cal.options.extras.lastDate = firstDateOfCurrentMonthOrWeek;
    	}   		
    }
    
    if (Cookies.get('bookingSlotAdminModule.weekView') === "true") {
		
    	if (Cookies.get('bookingSlotAdminModule.viewMode') !== 'LIST') {
    	
    		toggleWeek();
    	}
	};
    
	$('#week-toggler').on("click", function(){

	   toggleWeek();
    });

   	function toggleWeek() {
	   
	   $('#week-toggler').children().toggle();
	   
	   $('.calendar').toggleClass('week-view');
	   
	   cal.options.extras.weekView = !cal.options.extras.weekView;
	   
	   cal.render();
	}

	$('#go-to-today').on("click", function(){

		var today = moment();

		cal.options.extras.lastDate = today.format('YYYY-MM-DD');

		cal.setYear(today.year());

		cal.setMonth(today.month());
	});

	function showWeekView() {

		var calendarRowSelector = ".calendar-row:not(.calendar-row-header)",
			$calendarWeekRows = $(calendarRowSelector)

			var $rowWithLastDate = $calendarWeekRows.has('a[data-date="' + cal.options.extras.lastDate + '"].day'),
			$rowWithActiveDay = $calendarWeekRows.has('.active'),
			$rowWithToday = $calendarWeekRows.has('.today');

		var $currentWeekRow = $rowWithActiveDay.length ? $rowWithActiveDay : 
							  $rowWithLastDate.length ? $rowWithLastDate : 
							  $rowWithToday.length ? $rowWithToday : 
							  $calendarWeekRows.first();

		$calendarWeekRows.not($currentWeekRow).hide();

		$('.calendar a.btn').toggleClass('hidden');

		function renderDetails() {

			$('.calendar .calendar-month').html(Calendari18n.Week + ' ' + $('.calendar .calendar-week:visible').html())

			$('.calendar .day:visible').each(function() {

				var date = this.dataset.date;
				var	events = bookingslotadminCalendarDetailedEvents[date];

				var data = {};

				data.events = events;
				data.day = moment(date).format('D MMMM YYYY');
				data.date = date;
				data.showDuration = calendarElement.data("showduration");
				data.showURL = calendarElement.data("showurl");

				var $day = $(dayTemplate(data));

				// Add booking plus sign
				// $day.find('a.btn').html('').prop('class', 'icon-plus');

				//TODO Until we know what to do about the add booking button
				$day.find('a.btn').remove();

				var columnNumber = +$(this).index() + 1;

				var $header = $('.calendar .calendar-row-header').children('div:nth-child( ' + columnNumber + ')');

				$header.find('.week-mode-date').html('<br>' + $day.find('.calendar-day-header h2').html());

				$header.toggleClass('today', $(this).hasClass('today'));

				this.innerHTML = $day.html();
			});
		}

		renderDetails();

		$('#previous-week-button').on("click", function() {

			var $currentWeekRow = $(calendarRowSelector).filter(':visible');
			var	$previousWeekRow = $currentWeekRow.prev(calendarRowSelector);

			if (!$previousWeekRow.length) {

				bookingslotadminCalendar.previous();

				$previousWeekRow = $(calendarRowSelector).last();

				if ($previousWeekRow.find('.calendar-week').text() === $currentWeekRow.find('.calendar-week').text()) {

					$previousWeekRow = $previousWeekRow.prev();
				}
			}

			$(calendarRowSelector).not($previousWeekRow).hide();

			$previousWeekRow.show();

			renderDetails();
		});

		$('#next-week-button').on("click", function() {

			var $currentWeekRow = $(calendarRowSelector).filter(':visible');
			var	$nextWeekRow = $currentWeekRow.next(calendarRowSelector);

			if (!$nextWeekRow.length) {

				bookingslotadminCalendar.next();

				$nextWeekRow = $(calendarRowSelector).first();

				if ($nextWeekRow.find('.calendar-week').text() === $currentWeekRow.find('.calendar-week').text()) {

					$nextWeekRow = $nextWeekRow.next();
				}
			}

			$(calendarRowSelector).not($nextWeekRow).hide();

			$nextWeekRow.show();

			renderDetails();
		});

		updateCalendarLastDate();
	}
}

Handlebars.registerHelper('BookingQuery-Week', function(items, options) {

	var x = 0;
	var out = '<div class="calendar-row">';

	for (var i = 0, il = items.length; i < il; i++) {

		var data = items[i];

		if (x === 0) {
			
			if (i !== 0) {
				
				out += '<div class="calendar-row">';
			}
			
			out += '<div><span class="calendar-week">' + new Date(data.date._d).getWeekNumber() + '</<span></div>';
		}

		if (data.events.length > 0) {
			
			data.classes += ' activities';
		}

		out += '<a data-date="' + data.date.format('YYYY-MM-DD') + '" class="' + data.classes + '" href="#"><span>' + data.day + '</span>'
		
		if (data.events.length > 0) {
			
			out += BookingQueryGetEventHtml(data.events);
		}
		
		out += '</a>';

		if (x === 6) {
			
			out += '</div>';
			x = 0;
			
		} else {
			
			x++;
		}
	}

	return out + '</div>';
});

function BookingQueryGetEventHtml(events) {

	var response = '<ul>';

	var eventsToShow = Math.min(events.length, events.length > 5 ? 4 : 5);

	for (var i = 0; i < eventsToShow; i++) {

		var event = events[i];

		var activeClass = "";

		if (!event.passed) {

			if (!event.bookable) {

				activeClass = "not-bookable";

			} else {

				activeClass = event.freeSlots <= 0 ? "slot-inactive" : "slot-active";
			}
		}

		response += '<li class="' + activeClass + '">';
		response += '<span>';

		if (event.showFreeSlotsAsBoolean) {

			response += event.freeSlots > 0 ? Calendari18n.Free : Calendari18n.Booked;

		} else {

			response += event.freeSlots + ' ' + (event.freeSlots == 1 ? Calendari18n.OneSlot : Calendari18n.MultipleSlots);
		}

		response += '</span>';
		response += '<h5>' + event.startTime + '</h5>';
		response += '</li>';
	}

	if (events.length > 5) {

		response += '<li>';
		response += '<h5 class="morevents">' + '...' + '</h5>';
		response += '</li>';
	}

	return response + '</ul>';
}

// Detailed view
Handlebars.registerHelper('BookingQuery-Day', function(events, options) {

	var out = '<ul class="event-list list-style-type-none">';
	var bookingsToShow = 2;

	if (events != undefined) {
		
		for (var i = 0, il = events.length; i < il; i++) {

			var event = events[i];

			var activeClass = "paddingbottom paddingtop";

			if (!event.passed) {

				if (!event.bookable) {

					activeClass = "detail-not-bookable";

				} else {

					activeClass = event.freeSlots <= 0 ? "detail-slot-inactive" : "detail-slot-active";
				}
			}

			out += '<li class="' + activeClass + '">';
			out += '<a href="' + options.data.root.showURL + event.id + '" data-slotid="' + event.id + '">';

			out += '<div>'

			out += '<span>';

			if (options.data.root.showDuration) {

				out += event.startTime + " " + event.duration + 'min';

			} else {
				
				out += event.startTime + " - " + event.endTime;
			}

			out += ' (';

			if (event.title) {

				out += event.title + ', ';
			}

			if (event.showFreeSlotsAsBoolean) {

				out += (event.freeSlots > 0 ? Calendari18n.Free : Calendari18n.Booked) + ')';

			} else {

				out += event.freeSlots + ' ' + (event.freeSlots == 1 ? Calendari18n.OneSlot : Calendari18n.MultipleSlots) + ')';
			}

			out += '</span>';

			if (event.description || event.managers || event.location || event.bookings) {

				out += '<p class="meta-line">';

				if (event.managers) {

					out += "<strong>" + Calendari18n.ManagersTitle + ": </strong>";

					$.each(event.managers, function(index, manager) {

						if (index > 0) {
							out += ', ';
						}

						out += Handlebars.escapeExpression(manager.name);
					});

					out += '<br>';
				}

				if (event.description) {

					out += "<strong>" + Calendari18n.DescriptionTitle + "</strong>";

					var descriptionRows = Handlebars.escapeExpression(event.description).split('\r');

					$.each(descriptionRows, function(index, text) {
						
						out += '<br>' + text;
					});

					out += '<br>';
				}

				if (event.location) {

					out += "<strong>" + Calendari18n.LocationTitle + ": </strong>";

					out += Handlebars.escapeExpression(event.location);

					out += '<br>';
				}

				if (event.bookings) {

					out += "<strong>" + Calendari18n.BookingsTitle + ": </strong>";

					$.each(event.bookings, function(index, booking) {

						if (index < bookingsToShow) {

							if (index > 0) {
								
								out += ', ';
							}

							out += Handlebars.escapeExpression(booking.firstname) + ' ' + Handlebars.escapeExpression(booking.lastname);
						}
					});

					if (event.bookings.length > bookingsToShow) {

						out += ' ' + Calendari18n.And + ' ' + (event.bookings.length - bookingsToShow) + ' ' + Calendari18n.XMore;
					}

					out += '<br>';
				}

				out += '</p>';
			}

			out += '</div>';

			out += '</a>';
			out += '</li>';
		}
	}

	return out + '</ul>';
});

Handlebars.registerHelper('bookingQuerySafe_string', function(context) {
	
	var html = context;
	// context variable is the HTML you will pass into the helper
	// Strip the script tags from the html, and return it as a Handlebars.SafeString
	return new Handlebars.SafeString(html);
});

Date.prototype.getWeekNumber = function() {
	
	return moment.unix(this.getTime() / 1000).format('W');
}

String.prototype.toUcFirst = function() {
	
	return this.charAt(0).toUpperCase() + this.slice(1);
}
