$(function(){
	
	$('.notification-email-toggle').on("change", function(){
		
		$(this).closest('.notification-email').find('.notification-email-text').toggle(this.checked);
		
	}).trigger("change");	
	
	$('#addAttachmentsSeparately').on("change", function(){
		
		$('#attachmentTypeMappingContainer').toggle(this.checked);
		
	}).trigger("change");
	
	
	var $caseStatusName = $('#caseStatusName');
	
	$('#createCaseOnSpecificStatus').on("change", function(){
		
		$caseStatusName.parent().toggle(this.checked);
		
	}).trigger("change");
	
	var url = $caseStatusName.parent().data("connectorUrl");
	
	$caseStatusName.autocomplete({
		source: function(request, response) {
			return getStatuses(response, url, $caseStatusName);
		},
		select: function( event, ui ) {
			
			$caseStatusName.val(ui.item.value);
			return false;
		},
		focus: function(event, ui) {
			event.preventDefault();
		}
	});
	
	$caseStatusName.on("focus", function(){
			
		$(this).autocomplete("search", " ");
	});
	
	$(".toggle-fields").on("click", function(){
		
		$(this).siblings(".fields").toggleClass("hidden");
		
	});
	
});

function addAttachmentTypeMapping(){
	
	var clone = $("#attachmentTypeMapping-template").clone();
	
	var attachmentTypeMappingID = generateUUID();
	
	clone.attr("id", "attachmentTypeMapping-" + generateUUID());
	
	clone.find("input[name='queryName']").attr("name", "queryName-" + attachmentTypeMappingID);
	clone.find("input[name='attachmentTypeID']").attr("name", "attachmentTypeID-" + attachmentTypeMappingID);
	clone.find("input[name='attachmentTypeMappingID']").val(attachmentTypeMappingID);
	
	$("#attachmentTypeMappingTable").find('tbody').append(clone);
	
	return false;
	
}

function deleteAttachmentTypeMapping(source){
	
	$(source).parents("tr").first().remove();
	
	return false;
}

function generateUUID() {
	var chars = '0123456789abcdef'.split('');
	var uuid = [], rnd = Math.random;
	var r;
	uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
	uuid[14] = '4';
	for (var i = 0; i < 36; i++) {
		if (!uuid[i]) {
			r = 0 | rnd()*16;
			uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r & 0xf];
		}
	}
	return uuid.join('');
}

function getStatuses(response, searchURL, searchInput) {
	
	searchInput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : searchURL,
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		success : function(data) {
			
			if (data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item,
						value : item,
					}
				}));
			} else {
				response(null);
			}
			
			searchInput.removeClass("ui-autocomplete-loading");
			
		},
		error : function() {
			
			searchInput.removeClass("ui-autocomplete-loading");
		}
	});
}