<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />
	
	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateChangePosterEvaluator" />
			
		</div>

	</xsl:template>

	<xsl:template match="UpdateChangePosterEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="ChangePosterEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="ChangePosterEvaluator" />
			</xsl:call-template>

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showInLog'" />
						<xsl:with-param name="name" select="'showInLog'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="ChangePosterEvaluator" />
					</xsl:call-template>
	
					<label for="showInLog">
						<xsl:value-of select="$i18n.ShowInLog" />
					</label>
				</div>
			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>
	
</xsl:stylesheet>