package com.nordicpeak.flowengine.evaluators.childquery.childcount;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class ChildCountWeightEvaluatorCRUD extends BaseEvaluatorCRUD<ChildCountWeightEvaluator, ChildCountWeightEvaluationProviderModule> {

	private static final BeanRequestPopulator<ChildCountWeightEvaluator> POPULATOR = new AnnotatedRequestPopulator<>(ChildCountWeightEvaluator.class);

	public ChildCountWeightEvaluatorCRUD(Class<ChildCountWeightEvaluator> beanClass, AnnotatedDAOWrapper<ChildCountWeightEvaluator, Integer> evaluatorDAO, ChildCountWeightEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "ChildCountWeightEvaluator", "child count weight evaluator", null, callback);
	}

	@Override
	protected void validateUpdatePopulation(ChildCountWeightEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		List<ValidationError> errors = new ArrayList<>();

		if (bean.getFromValue() != null && bean.getToValue() != null && bean.getFromValue() > bean.getToValue()) {

			errors.add(new ValidationError("FromBiggerThanTo"));
		}

		if (bean.getFromValue() != null && bean.getFromValue() < 0) {
			errors.add(new ValidationError("FromIsLesserThanZero"));
		}

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}

		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
	}

}
