package com.nordicpeak.flowengine.evaluators.citizenidgroupmembershipquerystateevaluator;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.NoDuplicates;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "citizenid_group_query_state_evaluators")
@XMLElement
public class CitizenIDGroupMembershipQueryStateEvaluator extends BaseQueryStateEvaluator {

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean invert;

	@DAOManaged
	@OneToMany(autoGet = true, autoAdd = true, autoUpdate = true)
	@SimplifiedRelation(table = "citizenid_group_query_state_evaluator_groups", remoteValueColumnName = "groupID")
	@NoDuplicates
	@WebPopulate(paramName = "group")
	@XMLElement(fixCase = true, childName = "groupID")
	private List<Integer> groupIDs;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);

		List<ValidationError> errors = new ArrayList<ValidationError>(1);

		invert = xmlParser.getPrimitiveBoolean("invert");
		groupIDs = xmlParser.getIntegers("GroupIDs/groupID");

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	public boolean isInverted() {
		return invert;
	}

	public void setInvert(boolean invert) {
		this.invert = invert;
	}

	public List<Integer> getGroupIDs() {
		return groupIDs;
	}

	public void setGroupIDs(List<Integer> groupIDs) {
		this.groupIDs = groupIDs;
	}

}
