
$(document).on("initTable", function(event, initData) {
	
	var panel = initData.panel;
	var tableElement = initData.tableElement;
	var table = initData.table;
	
	var coloredTagButton = panel.find(".colored-tag-btn");
	
	var isValidColoredTagSelection = function() {
		
		var validSelection = true;
		
		var rows = table.rows({ selected: true });
		
		if (rows.any()) {
			
			var rowsArray = rows.toArray()[0];
		
			{
				var familyCells = table.cells(rowsArray, "familyID:name");
				var data = familyCells.data();
				var uniqueData = data.unique();
				
				if (uniqueData.count() > 1) {
					validSelection = false;
				}
			}
			
			if (validSelection && !table.isInternalSelection(rows)) {
				validSelection = false;
			}
		}
		
		return validSelection;
		
	};
	
	var updateColoredTagButton = function() {
		
		if (isValidColoredTagSelection()) {
		
			coloredTagButton.removeClass("disabled");
		
		} else {
		
			coloredTagButton.addClass("disabled");
		}
	}
	
	table.on('select.dt', function() {
		updateColoredTagButton();
	});
	
	table.on('deselect.dt', function() {
		updateColoredTagButton();
	});
	
	table.on('search.dt', function() {
		coloredTagButton.removeClass("disabled");
	});
	
	coloredTagButton.on("click", function() {
		
		var rows = table.rows({ selected: true });
		
		if (!rows.any()) {

			alert(FlowInstanceAdmin2.i18n.nothingSelected);
		
		} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !table.isInternalSelection()) {
			
			alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
		
		} else if (!isValidColoredTagSelection()) {
				
			alert(FlowInstanceAdmin2.i18n.multipleFlowFamiliesSelected);
			
		} else {
		
			var cells = table.cells(rows.toArray()[0], "instanceID:name");
			var selectedIDs = cells.data().toArray();
			
			submitSelection(selectedIDs, coloredTagButton.data("url"));
		}
	});
});