var i18n = {
		ConfirmDeletePart1: "not set",
		ConfirmDeletePart2Single: "not set",
		ConfirmDeletePart2Multiple: "not set",
}

$(function() {
	
	$('#enabled').on("change", function() {

		$('#tag-container').toggle(this.checked);

	}).trigger("change");
	
	if (!$('form input[name="tagID"]').length) {
		
		addTag();
	}
	
	$('form input.color-picker').minicolors();

	$(".colortags-wrapper .colortag input").on("change", function() {

		var $this = $(this);
		var $label = $this.parent().find("label");
		
		$(".colortags-wrapper .colortag label").css({"border-color": "#FFFFFF"}).removeClass("selected");
		
		if($this.is(":checked")) {
			$label.css({"border-color": $label.attr("data-color")}).addClass("selected");
		}
		
	}).trigger("change");
	
});

function addTag() {

	var clone = $("#tag-template").clone();

	var tagID = generateUUID();

	clone.attr("id", "tag-" + generateUUID());

	clone.find("input[name='name']").attr("name", "name-" + tagID);
	clone.find("input[name='hexColor']").attr("name", "hexColor-" + tagID).minicolors();
	clone.find("input[name='tagID']").attr("value", tagID);

	$("#tag-table").find('tbody').append(clone);

	return false;
}

function deleteTag(source) {
	
	var mappingCount = source.dataset.mappingCount;
	
	var confirmDeleteTagMessage = i18n.ConfirmDeletePart1 + mappingCount + (mappingCount > 1 ? i18n.ConfirmDeletePart2Multiple : i18n.ConfirmDeletePart2Single);
	
	if (mappingCount > 0 && !confirm(confirmDeleteTagMessage)) {
		
		return;
	}

	$(source).parents("tr").first().remove();

	return;
}

function generateUUID() {
	var chars = '0123456789abcdef'.split('');
	var uuid = [], rnd = Math.random;
	var r;
	uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
	uuid[14] = '4';
	for (var i = 0; i < 36; i++) {
		if (!uuid[i]) {
			r = 0 | rnd() * 16;
			uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r & 0xf];
		}
	}
	return uuid.join('');
}