<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>
	
	<xsl:template match="Document">

		<div id="ConstructionPermitQueryProvider" class="contentitem">

			<xsl:apply-templates select="validationError" />
			<xsl:apply-templates select="UpdateConstructionPermitQuery" />

		</div>

	</xsl:template>

	<xsl:template match="UpdateConstructionPermitQuery">

		<h1>
			<xsl:value-of select="$i18n.UpdateQuery" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="ConstructionPermitQuery/QueryDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form id="updateConstructionPermitQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="ConstructionPermitQuery" />
			</xsl:call-template>
			
			<h2 class="floatleft full bigmargintop"><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="ConstructionPermitQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="ConstructionPermitQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template name="appendCreateCommonFieldsFormConterAfterName">
	
		<div class="floatleft full bigmarginbottom">
			
			<label for="modelID">
				<xsl:value-of select="$i18n.Model" />
			</label>
	
			<br/>
	
			<xsl:call-template name="createDropdown">
				<xsl:with-param name="id" select="'modelID'" />
				<xsl:with-param name="name" select="'modelID'" />
				<xsl:with-param name="selectedValue" select="ConstructionPermitQuery/Model/modelID" />
				<xsl:with-param name="labelElementName" select="'name'" />
				<xsl:with-param name="valueElementName" select="'modelID'" />
				<xsl:with-param name="addEmptyOption" select="$i18n.SelectModel" />
				<xsl:with-param name="element" select="Models/Model" />					
			</xsl:call-template>
		</div>	
	
	</xsl:template>

	<xsl:template name="appendCreateCommonFieldsFormConterAfterDescription">
	
		<div class="floatleft full bigmarginbottom">
			<label for="selectPermitsDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.SelectPermitsDescription" /></label>
			<div class="floatleft full">

				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'selectPermitsDescription'" />
					<xsl:with-param name="name" select="'selectPermitsDescription'" />
					<xsl:with-param name="title" select="$i18n.SelectPermitsDescription"/>
					<xsl:with-param name="class" select="'common-ckeditor'" />
					<xsl:with-param name="element" select="ConstructionPermitQuery" />
				</xsl:call-template>
				
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<label for="permitsSelectedDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.PermitsSelectedDescription" /></label>
			<div class="floatleft full">

				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'permitsSelectedDescription'" />
					<xsl:with-param name="name" select="'permitsSelectedDescription'" />
					<xsl:with-param name="title" select="$i18n.PermitsSelectedDescription"/>
					<xsl:with-param name="class" select="'common-ckeditor'" />
					<xsl:with-param name="element" select="ConstructionPermitQuery" />
				</xsl:call-template>
				
		    </div>
		</div>		
	
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedConstructionPermitQueryNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.QueryNotFound" />
		</p>

	</xsl:template>

	<xsl:template match="validationError[messageKey = 'SelectedModelNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.SelectedModelNotFound" />
		</p>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'NoModelSelected']">

		<p class="error">
			<xsl:value-of select="$i18n.NoModelSelected" />
		</p>

	</xsl:template>

</xsl:stylesheet>