<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			
			<a name="query{ConstructionPermitQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="ConstructionPermitQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<xsl:choose>
					<xsl:when test="isHTMLDescription = 'true'">
						<xsl:value-of select="Description" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<p>
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</p>
					</xsl:otherwise>
				</xsl:choose>
				
			</xsl:if>
			
			<xsl:apply-templates select="ConstructionPermitQueryInstance/Values/PermitNodeValue" mode="show"/>
			
			<div class="clearboth"/>
			
		</div>	
		
	</xsl:template>
	
	<xsl:template match="PermitNodeValue" mode="show">
	
		<div class="full border bigmarginbottom padding border-radius-small floatleft border-box">
		
			<strong>
			
				<xsl:choose>
					<xsl:when test="PermitNode/longTitle">
						<xsl:value-of select="PermitNode/longTitle"/>
					</xsl:when>
					<xsl:otherwise>
							<xsl:value-of select="PermitNode/title"/>
					</xsl:otherwise>
				</xsl:choose>
			</strong>
	
			
			<div class="floatright">
			
				<xsl:if test="PermitNode/requiresCount = 'true'">
			
					<xsl:value-of select="$i18n.Count"/>
					<xsl:text>: </xsl:text>
					<xsl:value-of select="count"/>
				
				</xsl:if>

			</div>			
			
			<xsl:if test="PermitNode/requiresDescription = 'true'">
			
				<div class="floatleft full">
				
					<label>
						<xsl:value-of select="$i18n.Description"/>
						<xsl:text>: </xsl:text>
					</label>
				
					<xsl:value-of select="description"/>
				</div>
			
			</xsl:if>
			
			<xsl:if test="PermitNode/requiresFromToDescription = 'true'">
			
				<div class="full floatleft">

					<div class="floatleft fifty">
										
						<label>
							<xsl:value-of select="$i18n.From"/>
							<xsl:text>: </xsl:text>
						</label>
					
						<xsl:value-of select="fromDescription"/>
					</div>
					
					
					<div class="floatleft fifty">
					
						<label>
							<xsl:value-of select="$i18n.To"/>
							<xsl:text> :</xsl:text>
						</label>
					
						<xsl:value-of select="toDescription"/>
						
					</div>
				
				</div>
				
			</xsl:if>
		
		</div>	
	
	</xsl:template>

</xsl:stylesheet>