package com.nordicpeak.flowengine.queries.constructionpermit.beans;

import java.io.Serializable;
import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@Table(name = "construction_permit_node_values")
@XMLElement
public class PermitNodeValue extends GeneratedElementable implements Serializable, ImmutableAlternative{

	private static final long serialVersionUID = -730999632407516058L;
	
	public static final Field PERMIT_NODE_RELATION = ReflectionUtils.getField(PermitNodeValue.class, "permitNode");
	
	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer nodeValueID;

	@DAOManaged(columnName = "permitNodeID")
	@ManyToOne
	@XMLElement
	private PermitNode permitNode;

	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private ConstructionPermitQueryInstance queryInstance;

	@DAOManaged
	@XMLElement
	private String description;

	@DAOManaged
	@XMLElement
	private Integer count;

	@DAOManaged
	@XMLElement
	private String fromDescription;

	@DAOManaged
	@XMLElement
	private String toDescription;

	public Integer getNodeValueID() {

		return nodeValueID;
	}

	public void setNodeValueID(Integer nodeValueID) {

		this.nodeValueID = nodeValueID;
	}

	public PermitNode getPermitNode() {

		return permitNode;
	}

	public void setPermitNode(PermitNode permitNode) {

		this.permitNode = permitNode;
	}

	public ConstructionPermitQueryInstance getQueryInstance() {

		return queryInstance;
	}

	public void setQueryInstance(ConstructionPermitQueryInstance queryInstance) {

		this.queryInstance = queryInstance;
	}

	public String getDescription() {

		return description;
	}

	public void setDescription(String description) {

		this.description = description;
	}

	public Integer getCount() {

		return count;
	}

	public void setCount(Integer count) {

		this.count = count;
	}

	public String getFromDescription() {

		return fromDescription;
	}

	public void setFromDescription(String fromDescription) {

		this.fromDescription = fromDescription;
	}

	public String getToDescription() {

		return toDescription;
	}

	public void setToDescription(String toDescription) {

		this.toDescription = toDescription;
	}

	@Override
	public Integer getAlternativeID() {

		return permitNode.getAlternativeID();
	}

	@Override
	public String getName() {

		return permitNode.getName();
	}

	public Integer getSortIndex() {

		return permitNode.getSortIndex();
	}

	@Override
	public String getExportXMLValue() {

		return permitNode.getExportXMLValue();
	}

	@Override
	public String toString(){
		
		return StringUtils.toString(permitNode);
	}

	@Override
	public String getAttributeValue() {
		
		return permitNode.getAttributeValue();
	}
}
