package com.nordicpeak.flowengine.culling.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Timestamp;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.date.DateTimeStringyfier;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flowengine_deleted_flow_instances")
@XMLElement
public class DeletedFlowInstance extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -2881372784113729471L;

	public static final Field ID_FIELD = ReflectionUtils.getField(DeletedFlowInstance.class, "flowInstanceID");

	public static final Field COMMENT = ReflectionUtils.getField(DeletedFlowInstance.class, "comment");

	@Key
	@DAOManaged
	@XMLElement
	private Integer flowInstanceID;

	@DAOManaged
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@XMLElement
	private Integer flowID;

	@DAOManaged
	@XMLElement
	private Timestamp added;

	@DAOManaged
	@XMLElement
	private Timestamp firstSubmitted;

	@DAOManaged
	@XMLElement
	private String flowName;

	@DAOManaged
	@XMLElement
	private Integer deletedBy;

	@DAOManaged
	@XMLElement
	private String deletedByName;

	@DAOManaged
	@XMLElement(valueFormatter = DateTimeStringyfier.class)
	private Timestamp deleted;
	
	@DAOManaged(autoGenerated = true)
	@XMLElement
	private Integer cullingID;
	
	@DAOManaged(columnName = "commentID", dontUpdateIfNull = true)
	@ManyToOne
	@XMLElement
	private CullingComment comment;
	
	@Override
	public String toString() {
		
		return flowInstanceID.toString();
	}

	public Integer getFlowInstanceID() {

		return flowInstanceID;
	}

	public void setFlowInstanceID(Integer flowInstanceID) {

		this.flowInstanceID = flowInstanceID;
	}

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public Integer getFlowID() {

		return flowID;
	}

	public void setFlowID(Integer flowID) {

		this.flowID = flowID;
	}

	public Timestamp getAdded() {

		return added;
	}

	public void setAdded(Timestamp added) {

		this.added = added;
	}

	public Timestamp getFirstSubmitted() {

		return firstSubmitted;
	}

	public void setFirstSubmitted(Timestamp firstSubmitted) {

		this.firstSubmitted = firstSubmitted;
	}

	public String getFlowName() {

		return flowName;
	}

	public void setFlowName(String flowName) {

		this.flowName = flowName;
	}

	public Integer getDeletedBy() {

		return deletedBy;
	}

	public void setDeletedBy(Integer deletedBy) {

		this.deletedBy = deletedBy;
	}

	public String getDeletedByName() {

		return deletedByName;
	}

	public void setDeletedByName(String deletedByName) {

		this.deletedByName = deletedByName;
	}

	public Timestamp getDeleted() {

		return deleted;
	}

	public void setDeleted(Timestamp deleted) {

		this.deleted = deleted;
	}

	
	public CullingComment getComment() {
	
		return comment;
	}

	
	public void setComment(CullingComment comment) {
	
		this.comment = comment;
	}
}