<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/tablesorter/js/jquery.tablesorter.min.js
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/jquery.ui.touch.min.js
		/js/jquery.blockui.js
		/js/flowengine.tablesorter.js
		/js/flowinstanceadminmodule.js?v=1
		/js/flowengine.helpdialog.js
	</xsl:variable>

	<xsl:variable name="links">
		/css/flowengine.css
		/css/flowfinder.css
	</xsl:variable>

	<xsl:template match="Document">		
		
		<div id="FlowInstanceAdminModule" class="contentitem">
		
			<xsl:apply-templates select="SearchFlowInstance" />
			<xsl:apply-templates select="ShowFlowInstanceOverview"/>
			
		</div>

	</xsl:template>
	
	<xsl:template match="SearchFlowInstance">
		
		<section>
 				
			<div class="section-full padtop pull-left">
							
				<script type="text/javascript">
					flowInstanceAdminURI = '<xsl:value-of select="/Document/requestinfo/currentURI" />/<xsl:value-of select="/Document/module/alias" />';
					i18nChooseFlowInstance = '<xsl:value-of select="$i18n.Choose" />';
					i18nFlow = '<xsl:value-of select="$i18n.Flow" />';
					i18nFlowInstanceID = '<xsl:value-of select="$i18n.FlowInstanceID" />';
					i18nFlowInstanceStatus = '<xsl:value-of select="$i18n.Status" />';
					i18nFlowInstanceAdded = '<xsl:value-of select="$i18n.Date" />';
					i18nFlowInstancePoster = '<xsl:value-of select="$i18n.Poster" />';
					showSearchDecriptionColumn = false;
				</script>
				
				<div class="split-right search-wrapper">
					
					<div class="inner">
						
						<xsl:if test="ExtensionLink">
							
							<div class="floatright">
								<xsl:apply-templates select="ExtensionLink"/>							
							</div>
							
						</xsl:if>
						
						<h2 class="h1"><xsl:value-of select="$i18n.SearchFlowInstance" /></h2>
						
						<div class="search">
							<form action="javascript:void(0);" method="post">
							
								<span class="italic"><xsl:value-of select="$i18n.SearchFlowInstanceDescription" />.</span>
								<div class="input-wrapper">
									<input type="text" placeholder="{$i18n.SearchFormTitle}" name="search" class="noborder" id="search" />
		
									<input type="button" value="s" class="btn btn-search" onclick="searchFlowInstance()" />
								</div>
								
							</form>
						</div>
						
					</div>
					
				</div>
				
			</div>
			
  			<div class="section-full search-results" style="display: none;">
  				
  				<div class="info">
  					<span class="message"><i>c</i><xsl:value-of select="$i18n.SearchDone" />.</span>
  					<span class="close"><a href="#"><xsl:value-of select="$i18n.close" /><xsl:text>&#160;</xsl:text><i>x</i></a></span>
  				</div>
  				
  				<h2 class="h1 search-results-title"><span class="title" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part1" /><xsl:text>&#160;</xsl:text><span class="hits" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part2" /></h2>
  				<div class="errands-wrapper" style="display: none">
  					<table class="oep-table">
  						<thead>
  							<tr>
  								<th class="icon no-sort"></th>
  								<th class="service active"><span data-icon-after="_"><xsl:value-of select="$i18n.Flow" /></span></th>
  								<th class="errando"><span data-icon-after="_"><xsl:value-of select="$i18n.FlowInstanceID" /></span></th>
  								<th class="status"><span data-icon-after="_"><xsl:value-of select="$i18n.Status" /></span></th>
  								<th class="date default-sort"><span data-icon-after="_"><xsl:value-of select="$i18n.Date" /></span></th>
  								<th class="poster default-sort"><span data-icon-after="_"><xsl:value-of select="$i18n.Poster" /></span></th>
  								<th class="link no-sort"></th>
  							</tr>
  						</thead>
  						<tbody />
  					</table>
  				</div>
  				
			</div>
 				  		
  		</section>
	
	</xsl:template>
	
	<xsl:template match="ExtensionLink">
	
		<div class="extensionlink floatright clearboth">
			
			<a href="{url}">

				<xsl:value-of select="name"/>
	
				<xsl:if test="icon">
					<xsl:text> </xsl:text>
					<img src="{icon}"/>
				</xsl:if>
			
			</a>
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowFlowInstanceOverview">
	
		<xsl:apply-templates select="FlowInstance" mode="overview" />
	
	</xsl:template>
	
	<xsl:template match="FlowInstance" mode="overview">
		
		<section class="child">
			<div class="section-inside">
  				<div class="heading-wrapper">
  					<div class="inner">
	  					<figure>
		  					<img src="{/Document/requestinfo/currentURI}/{/Document/module/alias}/icon/{Flow/flowID}" alt="" />
		  				</figure>
		  				<div class="heading">
	  						<h1 class="xl"><xsl:value-of select="Flow/name" /></h1>
	  						<span class="errandno hide-mobile"><xsl:value-of select="$i18n.FlowInstanceID" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="flowInstanceID" /></span>
						</div>
					</div>
  				</div>
  			</div>
  			<div class="section-inside header-full no-pad-top">
  				<div class="description">
  					
  					<xsl:variable name="submittedEvents" select="events/FlowInstanceEvent[eventType='SUBMITTED']" />
  					  					
  					<p>
  						<strong class="overview"><xsl:value-of select="$i18n.Status" /><xsl:text>:&#160;</xsl:text></strong><xsl:value-of select="Status/name" />
  					</p>
  					
  					<p>
  						<strong class="overview"><xsl:value-of select="$i18n.FirstSubmitted" /><xsl:text>:&#160;</xsl:text></strong>
  						<xsl:value-of select="firstSubmitted" /><xsl:text>&#160;</xsl:text>
  						<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
  						
  						<xsl:call-template name="PrintPostedBy">
  							<xsl:with-param name="poster" select="$submittedEvents[position() = 1]/poster/user"/>
  							<xsl:with-param name="flowInstanceAttributes" select="Attributes"/>
  						</xsl:call-template>
  						
						<xsl:if test="not(poster)">
							
							<span class="overview">
								<xsl:value-of select="$i18n.PosterWasNotLoggedIn" />
							</span>
						</xsl:if>
  					</p>
  					
  					<xsl:if test="count($submittedEvents) > 1">
  						<p>
  							<xsl:variable name="lastSubmit" select="$submittedEvents[position() = last()]" />
  							
  							<strong class="overview"><xsl:value-of select="$i18n.LastSubmitted" /><xsl:text>:&#160;</xsl:text></strong>
  							
  							<xsl:value-of select="$lastSubmit/added" /><xsl:text>&#160;</xsl:text>
	  						<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
	  						
	  						<xsl:call-template name="printUser">
	  							<xsl:with-param name="user" select="$lastSubmit/poster/user" />
	  						</xsl:call-template>
  						</p>
  					</xsl:if>
  					<xsl:if test="updated">
	  					<p>
	  						<strong class="overview"><xsl:value-of select="$i18n.LastChanged" /><xsl:text>:&#160;</xsl:text></strong>
	  						
	  						<xsl:value-of select="updated" /><xsl:text>&#160;</xsl:text>
	  						<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
	  						
	  						<xsl:call-template name="printUser">
	  							<xsl:with-param name="user" select="editor/user" />
	  						</xsl:call-template>
	  					</p>
  					</xsl:if>
  					<p>
  						<strong class="overview"><xsl:value-of select="$i18n.Managers" /><xsl:text>:&#160;</xsl:text></strong>
  						<xsl:choose>
  							<xsl:when test="managers/user or managerGroups/group">
  								<xsl:apply-templates select="managers/user" mode="manager" />
  								<xsl:if test="managers/user and managerGroups/group">
  									<xsl:text>,&#160;</xsl:text>
  								</xsl:if>
  								<xsl:apply-templates select="managerGroups/group" mode="manager" />
  							</xsl:when>
  							<xsl:otherwise>
  								<xsl:value-of select="$i18n.NoManager" />
  							</xsl:otherwise>
  						</xsl:choose>
  					</p>
  				</div>
  				
  				<xsl:if test="managers/user">
  					<xsl:apply-templates select="managers/user" mode="manager-info" />
  				</xsl:if>
  				
				<div class="description">
	 					<a class="btn btn-light btn-inline btn-readmore">LS MER</a>
	 					<xsl:choose>
	 						<xsl:when test="longDescription"><xsl:value-of select="longDescription" disable-output-escaping="yes" /></xsl:when>
	 						<xsl:otherwise><xsl:value-of select="shortDescription" disable-output-escaping="yes" /></xsl:otherwise>
	 					</xsl:choose>
	 					<xsl:if test="Flow/FlowFamily/contactName or Flow/FlowFamily/ownerName">
						<div class="about-flow">
							<xsl:if test="Flow/FlowFamily/contactName">
								<div class="inner">
									<h2 class="h1"><xsl:value-of select="$i18n.Questions" /></h2>
									<xsl:value-of select="Flow/FlowFamily/contactName" />
									<xsl:if test="Flow/FlowFamily/contactEmail">
										<br/><a href="mailto:{FlowFamily/contactEmail}" title="{$i18n.SendMailTo}: {FlowFamily/contactEmail}"><xsl:value-of select="Flow/FlowFamily/contactEmail" /></a>
									</xsl:if>
									<xsl:if test="Flow/FlowFamily/contactPhone">
										<br /><a href="tel:{Flow/FlowFamily/contactPhone}" title="{$i18n.CallNumber}: {Flow/FlowFamily/contactPhone}"><xsl:value-of select="Flow/FlowFamily/contactPhone" /></a>
									</xsl:if>
								</div>
							</xsl:if>
							<xsl:if test="Flow/FlowFamily/ownerName">
								<div class="inner">
									<h2 class="h1"><xsl:value-of select="$i18n.Responsible" /></h2>
									<xsl:value-of select="Flow/FlowFamily/ownerName" />
									<xsl:if test="Flow/FlowFamily/ownerEmail">
										<br /><a href="mailto:{FlowFamily/ownerEmail}" title="{$i18n.SendMailTo}: {FlowFamily/ownerEmail}"><xsl:value-of select="Flow/FlowFamily/ownerEmail" /></a>
									</xsl:if>
								</div>
							</xsl:if>
						</div>
					</xsl:if>
	 			</div>  				
  			</div>
			
		</section>
	
	</xsl:template>	
	
	<xsl:template match="user" mode="manager">
		
		<a class="open-help" href="#" data-icon-before="p" data-help-box="helpdialog_{userID}"><span><xsl:value-of select="firstname" /><xsl:text>&#160;</xsl:text><xsl:value-of select="lastname" /></span></a>
		
		<xsl:if test="position() != last()"><xsl:text>,&#160;</xsl:text></xsl:if>
		
	</xsl:template>
	
	<xsl:template match="group" mode="manager">
		
		<img class="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/group.png" alt="" />
		
		<span><xsl:value-of select="name" /></span>
		
		<xsl:if test="position() != last()"><xsl:text>,&#160;</xsl:text></xsl:if>
		
	</xsl:template>
	
	<xsl:template match="user" mode="manager-info">
		
		<div class="help-box" data-help-box="helpdialog_{userID}">
			<div>
	  			<div> 
	  				<a class="close" href="#" data-icon-after="x"></a>
	  				<h2>
	  					<xsl:value-of select="firstname" /><xsl:text>&#160;</xsl:text><xsl:value-of select="lastname" />
	  				</h2>
	  				
	  				 <xsl:variable name="title" select="Attributes/Attribute[Name='title']/Value"/>
	  				
	  				<xsl:if test="$title">
		  				<p>
		  					<xsl:value-of select="$title"/>
		  				</p>	  				
	  				</xsl:if>
	  				
	  				 <xsl:variable name="department" select="Attributes/Attribute[Name='department']/Value"/>
	  				
	  				<xsl:if test="$department">
		  				<p>
		  					<xsl:value-of select="$department"/>
		  				</p>	  				
	  				</xsl:if>	  				
	  				
	  				<xsl:if test="email">
	  				<p>
	  					<a href="mailto:{email}"><xsl:value-of select="email"/></a>
	  				</p>
	  				</xsl:if>
	  				
	  				<xsl:variable name="mobilePhone" select="Attributes/Attribute[Name='mobilePhone']/Value"/>
	  				
	  				<xsl:if test="$mobilePhone">
		  				<p>
		  					<a href="tel:{$mobilePhone}"><xsl:value-of select="$mobilePhone"/></a>
		  				</p>	  				
	  				</xsl:if>
	  			</div> 
			</div>
		</div>
		
		<div class="help-backdrop" data-help-box="helpdialog_{userID}" />		
		
	</xsl:template>	
	
	<xsl:template name="PrintPostedBy">
		<xsl:param name="poster"/>
		<xsl:param name="flowInstanceAttributes"/>
		
		<xsl:choose>
		
			<xsl:when test="$flowInstanceAttributes/Attribute[Name = 'organizationName']">
				<xsl:value-of select="$flowInstanceAttributes/Attribute[Name = 'organizationName']/Value" />
				
				<xsl:choose>
					<xsl:when test="$poster">
						<xsl:text>&#160;(</xsl:text>
						<xsl:call-template name="printUser">
							<xsl:with-param name="user" select="$poster" />
						</xsl:call-template>
						<xsl:text>)</xsl:text>
					</xsl:when>
					
					<xsl:when test="$flowInstanceAttributes/Attribute[Name = 'firstname']">
						<xsl:text>&#160;(</xsl:text>
						<xsl:value-of select="$flowInstanceAttributes/Attribute[Name = 'firstname']/Value" />
						<xsl:text>&#160;</xsl:text>
						<xsl:value-of select="$flowInstanceAttributes/Attribute[Name = 'lastname']/Value" />
						<xsl:text>)</xsl:text>
					</xsl:when>	
				</xsl:choose>
				
			</xsl:when>
			
			<xsl:otherwise>
				<xsl:call-template name="PrintPostedByNoOrg">
					<xsl:with-param name="poster" select="$poster"/>
					<xsl:with-param name="flowInstanceAttributes" select="$flowInstanceAttributes"/>
				</xsl:call-template>
			</xsl:otherwise>
			
		</xsl:choose>
	
	</xsl:template>
	
	<xsl:template name="PrintPostedByNoOrg">
		<xsl:param name="poster"/>
		<xsl:param name="flowInstanceAttributes"/>
		
		<xsl:choose>
		
			<xsl:when test="$poster">
				<xsl:call-template name="printUser">
					<xsl:with-param name="user" select="$poster" />
				</xsl:call-template>
			</xsl:when>
				
			<xsl:when test="$flowInstanceAttributes/Attribute[Name = 'firstname']">
				<xsl:value-of select="$flowInstanceAttributes/Attribute[Name = 'firstname']/Value" />
				<xsl:text>&#160;</xsl:text>
				<xsl:value-of select="$flowInstanceAttributes/Attribute[Name = 'lastname']/Value" />
			</xsl:when>
			
			<xsl:otherwise>
				<xsl:value-of select="$i18n.AnonymousUser" />
			</xsl:otherwise>
			
		</xsl:choose>
	
	</xsl:template>
	
	<xsl:template name="printUser">
		<xsl:param name="user" />
		
		<xsl:value-of select="$user/firstname" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$user/lastname" />
		
	</xsl:template>
	
</xsl:stylesheet>