<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="DateTimeQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{DateTimeQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<xsl:if test="DateTimeQueryInstance/DateTimeQuery/hideTitle = 'false'">
				<h2>
					<xsl:value-of select="DateTimeQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
				</h2>
			</xsl:if>			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<div class="full display-table bigmarginbottom">
			
				<xsl:variable name="useMultiDate"  select="DateTimeQueryInstance/DateTimeQuery/useMultiDate = 'true'" />
				<xsl:variable name="useMultiTime"  select="DateTimeQueryInstance/DateTimeQuery/useMultiTime = 'true'" />
			
				<xsl:if test="DateTimeQueryInstance/startDate">
					
					<xsl:variable name="width">
						<xsl:choose>
							<xsl:when test="DateTimeQueryInstance/startTime">fifty</xsl:when>
							<xsl:otherwise>full</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					
					<div class="floatleft {$width} bigmarginbottom">
						
						<xsl:variable name="label">
							<xsl:value-of select="$i18n.Date"/>
							<xsl:if test="$useMultiDate">
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$i18n.from" />
							</xsl:if>
						</xsl:variable>
						
						<strong>
							<xsl:value-of select="$label" />
						</strong>
						<br/>
						<xsl:value-of select="DateTimeQueryInstance/startDate" />
													
					</div>
					
				</xsl:if>
						
				<xsl:if test="DateTimeQueryInstance/startTime">
					
					<xsl:variable name="width">
						<xsl:choose>
							<xsl:when test="DateTimeQueryInstance/startDate">fifty</xsl:when>
							<xsl:otherwise>full</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					
					<div class="floatleft {$width} bigmarginbottom">
						
						<xsl:variable name="label">
							<xsl:value-of select="$i18n.Time"/>
							<xsl:if test="$useMultiTime">
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$i18n.from" />
							</xsl:if>
						</xsl:variable>
					
						<strong>
							<xsl:value-of select="$label" />
						</strong>
						<br/>
						<xsl:value-of select="DateTimeQueryInstance/startTime" />
						
					</div>
					
				</xsl:if>
			
				<xsl:if test="DateTimeQueryInstance/endDate">
			
					<div class="floatleft fifty bigmarginbottom">
						
						<xsl:variable name="label">
							<xsl:value-of select="$i18n.Date"/>
							<xsl:text>&#160;</xsl:text>
							<xsl:value-of select="$i18n.to" />
						</xsl:variable>
						
						<strong>
							<xsl:value-of select="$label"/>
						</strong>
						<br/>
						<xsl:value-of select="DateTimeQueryInstance/endDate" />
					
					</div>
				
				</xsl:if>
				
				<xsl:if test="DateTimeQueryInstance/endTime">
					
					<xsl:variable name="alignment">
						<xsl:choose>
							<xsl:when test="DateTimeQueryInstance/endDate">floatleft</xsl:when>
							<xsl:when test="not(DateTimeQueryInstance/startDate) and not(DateTimeQueryInstance/endDate)">floatleft</xsl:when>
							<xsl:otherwise>floatright</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					
					<div class="{$alignment} fifty bigmarginbottom">
						
						<xsl:variable name="label">
							<xsl:value-of select="$i18n.Time"/>
							<xsl:text>&#160;</xsl:text>
							<xsl:value-of select="$i18n.to" />
						</xsl:variable>
					
						<strong>
							<xsl:value-of select="$label"/>
						</strong>
						<br/>
						<xsl:value-of select="DateTimeQueryInstance/endTime" />
					
					</div>
					
				</xsl:if>
			
			</div>
			
		</div>
		
	</xsl:template>

</xsl:stylesheet>