package com.nordicpeak.flowengine.queries.validationerrors;

import java.sql.Time;

import se.unlogic.standardutils.time.TimeStringyfier;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name="validationError")
public class TimeNotMultipleOfInterval extends ValidationError {

	private static final long serialVersionUID = -2522498393546333011L;

	@XMLElement
	private int interval;
	
	@XMLElement(valueFormatter = TimeStringyfier.class)
	private Time originalTime;
	
	@XMLElement(valueFormatter = TimeStringyfier.class)
	private Time alteredTime;
	
	public TimeNotMultipleOfInterval(String fieldName, int interval, Time originalTime, Time alteredTime) {
		super("TimeNotMultipleOfInterval", "", fieldName);
		
		this.interval = interval;
		this.originalTime = originalTime;
		this.alteredTime = alteredTime;
	}
}
