package com.nordicpeak.flowengine.evaluators.eidas;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "eidas_query_state_evaluators")
@XMLElement
public class EIDASQueryStateEvaluator extends BaseQueryStateEvaluator{

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean inclusive;
	
	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>(1);
		
		inclusive = xmlParser.getPrimitiveBoolean("inclusive");
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
	}
	
	public boolean isInclusive() {
		
		return inclusive;
	}
	
	public void setInclusive(boolean inclusive) {
		
		this.inclusive = inclusive;
	}
	
	@Override
	public boolean requiresInitialization() {
		
		return true;
	}
}
