package com.nordicpeak.flowengine.integration.evolution;
import java.util.HashSet;
import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

public class WSAddressHandler implements SOAPHandler<SOAPMessageContext> {

	private final String url;
	
	public WSAddressHandler(String url) {

		super();
		this.url = url;
	}

	@Override
	public boolean handleMessage(SOAPMessageContext context) {

		System.out.println("ActionAddingHandler.handleMessage");
		
		boolean outbound = (boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
		
		if(outbound) {
			
			try {
				SOAPHeader soapHeader = context.getMessage().getSOAPHeader();
				
				SOAPElement toElement = soapHeader.addChildElement("To", "","http://www.w3.org/2005/08/addressing");
				toElement.setValue(url);

				SOAPElement actionElement = soapHeader.addChildElement("Action", "","http://www.w3.org/2005/08/addressing");
				actionElement.setValue("http://tempuri.org/IEService/" + context.getMessage().getSOAPBody().getFirstChild().getLocalName());				
				
			} catch (SOAPException e) {

				throw new RuntimeException(e);
			}
		}

		return true;
	}

	@Override
	public boolean handleFault(SOAPMessageContext context) {	

		return true;
	}

	@Override
	public void close(MessageContext context) {}


    @Override
    public Set<QName> getHeaders() {
    	
        Set<QName> set = new HashSet<QName>();
        
        // Make sure the '[{http://www.w3.org/2005/08/addressing}]Action' header 
        // is handled in case the device set the 'MustUnderstand' attribute to '1'
        set.add(new QName("http://www.w3.org/2005/08/addressing", "Action"));
        
        return set;
    }   
}
