<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="FixedTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{FixedTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<xsl:if test="not(FixedTableQueryInstance/FixedTableQuery/hideTitle = 'true')">
				<h2>
					<xsl:value-of select="FixedTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
				</h2>
			</xsl:if>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<xsl:variable name="showRowLabels" select="not(FixedTableQueryInstance/FixedTableQuery/hideRowLabels = 'true')"/>
			
			<table class="full bigmarginbottom">
				
					<thead>
					
						<xsl:if test="$showRowLabels">
							<th class="paddingright">
								<xsl:value-of select="FixedTableQueryInstance/FixedTableQuery/rowsLabel"/>
							</th>
						</xsl:if>
						
						<xsl:apply-templates select="FixedTableQueryInstance/FixedTableQuery/Columns/Column" mode="thead-show" />
						
					</thead>
					
					<tbody>
					
						<xsl:apply-templates select="FixedTableQueryInstance/FixedTableQuery/Rows/Row" mode="tbody-show" />
						
					</tbody>
					
					<tfoot>
					
						<xsl:if test="FixedTableQueryInstance/FixedTableQuery/Columns/Column[summarise = 'true']">
							<tr>
								
								<xsl:if test="$showRowLabels">
									<td class="paddingright"><strong><xsl:value-of select="$i18n.Summary"/></strong></td>
								</xsl:if>
								
								<xsl:for-each select="FixedTableQueryInstance/FixedTableQuery/Columns/Column">
									
									<xsl:variable name="columnIndex"><xsl:number/></xsl:variable>
									
									<xsl:choose>
										<xsl:when test="$columnIndex = 1 and not($showRowLabels)">
										
											<td class="padding">
												<strong class="floatleft"><xsl:value-of select="$i18n.Summary"/></strong>
												
												<xsl:if test="summarise = 'true'">
													<span class="floatright paddingright">
														<xsl:value-of select="sum"/>
													</span>
												</xsl:if>
											</td>
										
										</xsl:when>
										<xsl:otherwise>
										
											<td class="padding">
												<xsl:if test="summarise = 'true'">
													<span class="floatright paddingright">
														<xsl:value-of select="sum"/>
													</span>
												</xsl:if>
											</td>
											
										</xsl:otherwise>
									</xsl:choose>
									
								</xsl:for-each>
								
							</tr>
						</xsl:if>
					
					</tfoot>
					
				</table>
				
		</div>
		
	</xsl:template>
	
	<xsl:template match="Row" mode="tbody-show">
	
		<tr>
		
			<xsl:if test="not(../../hideRowLabels = 'true')">
				<td class="paddingright"><xsl:value-of select="label"/></td>
			</xsl:if>
			
			<xsl:apply-templates select="../../Columns/Column" mode="tbody-show" >
				<xsl:with-param name="rowID" select="rowID"/>
			</xsl:apply-templates>
			
		</tr>
	
	</xsl:template>
	
</xsl:stylesheet>