<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:variable name="imgPath"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/pics</xsl:variable>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/plugins/jquery.qloader.js
		/featherlight/js/featherlight.min.js
		/js/confirmpost.js
		/tablesorter/js/jquery.tablesorter.min.js
	</xsl:variable>
	
	<xsl:variable name="globallinks">
		/featherlight/css/featherlight.min.css?v=1
		/css/openhierarchy-jquery-ui.css
	</xsl:variable>	
	
	<xsl:variable name="scripts">
		/js/mentionable/bootstrap-typeahead.js
		/js/mentionable/mentionable.js
		/js/jquery.ui.touch.min.js
		/js/jquery.blockui.js
		/js/flowengine.helpdialog.js
		/js/flowengine.js?v=1
		/js/flowengine.step-navigator.js
		/js/flowengine.tablesorter.js
		/js/flowinstanceadminmodule.js?v=1
		/js/jquery.qloader-init.js
		/js/datatables.min.js
		/js/flowinstanceadmin2.js?v=29
		/js/UserGroupList.js
		/js/js.cookie-2.0.4.min.js
		/js/messages.js?v=4
		/js/formsubmitprogresstracker.js
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/flowengine.css
		/js/mentionable/mentionable.css
		/css/datatables.css
		/css/flowinstanceadmin2.css?v=14
		/css/UserGroupList.css?v=1
		/css/messages.css?v=1
		/css/formsubmitprogresstracker.css
	</xsl:variable>

	<xsl:template match="Document">
	
		<xsl:choose>
			<xsl:when test="UpdateFlowInstanceStatuses or AddFlowInstanceManagers">
			
				<div class="contentitem errands-wrapper">
					<xsl:apply-templates select="UpdateFlowInstanceStatuses" />
					<xsl:apply-templates select="AddFlowInstanceManagers" />
				</div>
			
			</xsl:when>
			<xsl:otherwise>
			
				<div id="FlowInstanceAdminModule" class="contentitem">
				
					<xsl:apply-templates select="OverviewElement" />
					<xsl:apply-templates select="ShowFlowInstanceOverview"/>
		<!-- 			<xsl:apply-templates select="ImmutableFlowInstanceManagerPreview"/> -->
					<xsl:apply-templates select="FlowInstanceManagerForm"/>
					<xsl:apply-templates select="FlowInstanceManagerPreview"/>
					<xsl:apply-templates select="FlowInstanceManagerSubmitted"/>
					<xsl:apply-templates select="UpdateInstanceStatus"/>
					<xsl:apply-templates select="UpdateStatusSigning"/>
					<xsl:apply-templates select="UpdateInstanceManagers"/>
					<xsl:apply-templates select="SigningForm"/>
			
				</div>
			
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template name="showManagerFlowInstanceControlPanel">
		<xsl:param name="flowInstance" />
		<xsl:param name="view" />
		<xsl:param name="bookmarked" select="Bookmarked" />
		<xsl:param name="deleteAccessOverride" select="null" />
<!-- 		The normal control panel will not be shown -->
	</xsl:template>

	<xsl:template match="OverviewElement">
		
		<section class="flowinstanceadmin-overview">
 				
			<xsl:variable name="prioritizedInstancesCount" select="PrioritizedInstanceCount" />
			<xsl:variable name="userAssignedInstancesCount" select="UserAssignedInstanceCount" />
			<xsl:variable name="bookmarkedInstancesCount" select="BookmarkedInstanceCount" />
			<xsl:variable name="activeInstancesCount" select="ActiveInstanceCount" />
			<xsl:variable name="unassignedInstancesCount" select="UnassignedInstanceCount" />
 				
			<div class="section-full padtop pull-left">
				
				<div class="split-left search-wrapper">
					
					<div class="inner">
						
<!-- 						<h2 class="h1"><xsl:value-of select="$i18n.SearchFlowInstance" /></h2> -->
						
						<div class="search">
							<form action="javascript:void(0);" method="post">
							
<!-- 								<span class="italic"><xsl:value-of select="$i18n.SearchFlowInstanceDescription" /></span> -->
								<div class="input-wrapper">
									<input type="text" placeholder="{$i18n.SearchFormTitle}" name="search" class="noborder" id="search" />
		
									<input type="button" value="s" class="btn btn-search" onclick="searchFlowInstance()" />
								</div>
								
							</form>
						</div>
						
					</div>
					
				</div>
				
				<div class="split-right">
					<div class="inner">

						<div class="split-left"/>
						
						<div class="split-right">
							<xsl:call-template name="CreateShortcutMenu"/>
						</div>
						
					</div>
				</div>
				
				<script type="text/javascript">
					flowInstanceAdminURI = '<xsl:value-of select="/Document/requestinfo/currentURI" />/<xsl:value-of select="/Document/module/alias" />';
					i18nChooseFlowInstance = '<xsl:value-of select="$i18n.Choose" />';
					i18nFlow = '<xsl:value-of select="$i18n.Flow" />';
					i18nFlowInstanceID = '<xsl:value-of select="$i18n.FlowInstanceID.short" />';
					i18nFlowInstanceStatus = '<xsl:value-of select="$i18n.Status" />';
					i18nFlowInstanceDescription = '<xsl:value-of select="$i18n.Description" />';
					i18nFlowInstanceFirstSubmitted = '<xsl:value-of select="$i18n.FirstSubmitted" />';
					i18nFlowInstancePoster = '<xsl:value-of select="$i18n.Column.Poster" />';
				</script>
				
			</div>
			
 			<div class="section-full search-results" style="display: none;">
 				
 				<div class="info">
 					<span class="message"><i>c</i><xsl:value-of select="$i18n.SearchDone" />.</span>
 					<span class="close"><a href="#"><xsl:value-of select="$i18n.close" /><xsl:text>&#160;</xsl:text><i>x</i></a></span>
 				</div>
 				
 				<h2 class="h1 search-results-title"><span class="title" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part1" /><xsl:text>&#160;</xsl:text><span class="hits" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part2" /></h2>
 				<div class="errands-wrapper" style="display: none">
 					<table class="oep-table flowinstance-table">
 						<thead>
 							<tr>
 								<th class="icon no-sort"></th>
 								<th class="service active"><span data-icon-after="_"><xsl:value-of select="$i18n.Flow" /></span></th>
 								<th class="errando"><span data-icon-after="_"><xsl:value-of select="$i18n.FlowInstanceID.short" /></span></th>
 								<th class="status"><span data-icon-after="_"><xsl:value-of select="$i18n.Status" /></span></th>
 								<th class="description"><span data-icon-after="_"><xsl:value-of select="$i18n.Description" /></span></th>
 								<th class="date default-sort"><span data-icon-after="_"><xsl:value-of select="$i18n.FirstSubmitted" /></span></th>
 								<th class="poster default-sort"><span data-icon-after="_"><xsl:value-of select="$i18n.Column.Poster" /></span></th>
 								<th class="link no-sort"></th>
 							</tr>
 						</thead>
 						<tbody />
 					</table>
 				</div>
  				
			</div>
 			
 			<xsl:apply-templates select="validationError"/>
 			
			<div class="section-full">
				
 				<div id="tabs" class="dashboardTabs">
 				
  				<ul class="tabs pull-left">
  					<a class="floatright btn btn-light" href="#" onclick="openTableSettingsModal(this, event)" title="{$i18n.EditTableSettings}" >
	 						<span data-icon-before="W">
	 							<xsl:value-of select="$i18n.TableSettings"/>
	 						</span>
	 					</a>
  					<li>
  						<a href="#unassigned">
	  						<div class="text-align-center flow-instance-count spinner-wrapper"><xsl:value-of select="$unassignedInstancesCount" /></div>
	  						<span class="tab-text"><xsl:value-of select="$i18n.UnAssignedTab" /></span>
  						</a>
  					</li>
  					<li class="prioritized">
  					
  						<xsl:if test="$prioritizedInstancesCount = 0">
  							<xsl:attribute name="class">prioritized empty</xsl:attribute>
  						</xsl:if>
  						
 							<a href="#prioritized">
 								<div class="text-align-center flow-instance-count spinner-wrapper"><xsl:value-of select="$prioritizedInstancesCount" /></div>
 								<span><xsl:value-of select="$i18n.EmergencyTab" /></span>
 							</a>
  					</li>
  					<li class="owned">
  						<a href="#mine">
  							<div class="text-align-center flow-instance-count spinner-wrapper"><xsl:value-of select="$userAssignedInstancesCount" /></div>
  							<span class="tab-text"><xsl:value-of select="$i18n.OwnedTab" /></span>
  						</a>
  					</li>
  					<li class="owned">
  						<a href="#bookmarked">
  							<div class="text-align-center flow-instance-count spinner-wrapper"><xsl:value-of select="$bookmarkedInstancesCount" /></div>
  							<span class="tab-text"><xsl:value-of select="$i18n.FlaggedTab" /></span>
  						</a>
  					</li>
  					<li>
  						<a href="#active">
  							<div class="text-align-center flow-instance-count spinner-wrapper"><xsl:value-of select="$activeInstancesCount" /></div>
  							<span class="tab-text"><xsl:value-of select="$i18n.ActiveTab" /></span>
  						</a>
  					</li>
  					<li>
  						<a href="#all">
  							<div class="text-align-center spinner-wrapper">&#160;</div>
  							<span class="tab-text"><xsl:value-of select="$i18n.AllTab" /></span>
  						</a>
  					</li>
  				</ul>
  				
  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'unassigned'" />
  				</xsl:call-template>
  				
  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'prioritized'" />
  				</xsl:call-template>
  				
  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'mine'" />
  				</xsl:call-template>
  				
  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'bookmarked'" />
  				</xsl:call-template>
  				
  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'active'" />
  				</xsl:call-template>

  				<xsl:call-template name="createFlowInstanceList">
  					<xsl:with-param name="flowInstanceFilter" select="'all'" />
  				</xsl:call-template>
  				
  			</div>
  			
  			<script type="text/javascript">
  					
  					openMode = "<xsl:value-of select="FlowInstanceAdminUserSettings/openMode" />";
  					managerDisplayMode = "<xsl:value-of select="FlowInstanceAdminUserSettings/managerDisplayMode" />";
  					dateInterval = "<xsl:value-of select="FlowInstanceAdminUserSettings/dateInterval" />";
  					fromDate = "<xsl:value-of select="FlowInstanceAdminUserSettings/fromDate" />";
  					toDate = "<xsl:value-of select="FlowInstanceAdminUserSettings/toDate" />";
  			
	 				FlowInstanceAdmin2 = {
	 					imgPath: "<xsl:value-of select="$imgPath"/>",
	 					pageLength: <xsl:value-of select="PageSize"/>,
	 					saveSettingsURL: "<xsl:value-of select="ServerURL"/><xsl:value-of select="/Document/requestinfo/contextpath"/><xsl:value-of select="/Document/fullAlias"/>/saveusersettings",
	 					showURL: "<xsl:value-of select="ServerURL"/><xsl:value-of select="/Document/requestinfo/contextpath"/><xsl:value-of select="/Document/fullAlias"/>/overview/",
	 					stealFlowInstanceURL: "<xsl:value-of select="ServerURL"/><xsl:value-of select="/Document/requestinfo/contextpath"/><xsl:value-of select="/Document/fullAlias"/>/stealmultiple/",
	 					updateStatusURL: "<xsl:value-of select="ServerURL"/><xsl:value-of select="/Document/requestinfo/contextpath"/><xsl:value-of select="/Document/fullAlias"/>/updatestatuses/",
	 					addManagersURL: "<xsl:value-of select="ServerURL"/><xsl:value-of select="/Document/requestinfo/contextpath"/><xsl:value-of select="/Document/fullAlias"/>/addmanagers/",
	 					i18n: {
				 			"decimal":        "<xsl:value-of select="$i18n.DataTable.decimal"/>",
							"emptyTable":     "<xsl:value-of select="$i18n.DataTable.emptyTable"/>",
							"info":           "<xsl:value-of select="$i18n.DataTable.info"/>",
							"infoEmpty":      "<xsl:value-of select="$i18n.DataTable.infoEmpty"/>",
							"infoFiltered":   "<xsl:value-of select="$i18n.DataTable.infoFiltered"/>",
							"infoPostFix":    "<xsl:value-of select="$i18n.DataTable.infoPostFix"/>",
							"thousands":      "<xsl:value-of select="$i18n.DataTable.thousands"/>",
							"lengthMenu":     "<xsl:value-of select="$i18n.DataTable.lengthMenu"/>",
							"loadingRecords": "<xsl:value-of select="$i18n.DataTable.loadingRecords"/>",
							"processing":     "<xsl:value-of select="$i18n.DataTable.processing"/>",
							"search":         "<xsl:value-of select="$i18n.DataTable.search"/>",
							"zeroRecords":    "<xsl:value-of select="$i18n.DataTable.zeroRecords"/>",
							"fetchError":     "<xsl:value-of select="$i18n.DataTable.fetchError"/>",
							paginate: {
								"first":      "<xsl:value-of select="$i18n.DataTable.paginate.first"/>",
								"last":       "<xsl:value-of select="$i18n.DataTable.paginate.last"/>",
								"next":       "<xsl:value-of select="$i18n.DataTable.paginate.next"/>",
								"previous":   "<xsl:value-of select="$i18n.DataTable.paginate.previous"/>"
							},
							aria: {
								"sortAscending":  "<xsl:value-of select="$i18n.DataTable.aria.sortAscending"/>",
								"sortDescending": "<xsl:value-of select="$i18n.DataTable.aria.sortDescending"/>"
							},
							select: {
								rows: {
									many: "<xsl:value-of select="$i18n.DataTable.selection.many"/>",
									none: "<xsl:value-of select="$i18n.DataTable.selection.none"/>",
									one: "<xsl:value-of select="$i18n.DataTable.selection.one"/>"
								}
							},
							nothingSelected: "<xsl:value-of select="$i18n.NothingSelected"/>",
							reloadTab: "<xsl:value-of select="$i18n.ReloadTab"/>",
							multipleFlowsSelected: "<xsl:value-of select="$i18n.Validation.MultipleFlowsSelected"/>",
							multipleFlowFamiliesSelected: "<xsl:value-of select="$i18n.Validation.MultipleFlowFamiliesSelected"/>",
							multipleFlowFamiliesOrProfilesSelected: "<xsl:value-of select="$i18n.Validation.MultipleFlowFamiliesOrProfilesSelected"/>",
							requiresInternalSelection:  "<xsl:value-of select="$i18n.Validation.RequiresInternalSelection"/>",
							steal: "<xsl:value-of select="$i18n.Validation.Steal"/>",
							stealExistingManagers: "<xsl:value-of select="$i18n.Validation.StealExistingManagers"/>",
							fromDate: "<xsl:value-of select="$i18n.Filter.Date.From"/>",
							toDate: "<xsl:value-of select="$i18n.Filter.Date.To"/>",
							saveDate: "<xsl:value-of select="$i18n.Filter.Date.Save"/>",
							dateNotSet: "<xsl:value-of select="$i18n.Filter.Date.NotSet"/>",
							dateFormat: "<xsl:value-of select="$i18n.Filter.Date.DateFormat"/>",
						},
						
						lastSavedTable: "<xsl:value-of select="FlowInstanceAdminUserSettings/lastSavedTable"/>",
						
						TableSettings: {
							<xsl:if test="FlowInstanceAdminUserSettings">
								<xsl:if test="FlowInstanceAdminUserSettings/tableUnassigned">
									unassigned: '<xsl:value-of select="FlowInstanceAdminUserSettings/tableUnassigned"/>',
								</xsl:if>
								
								<xsl:if test="FlowInstanceAdminUserSettings/tablePrioritized">
									prioritized: '<xsl:value-of select="FlowInstanceAdminUserSettings/tablePrioritized"/>',
								</xsl:if>
								
								<xsl:if test="FlowInstanceAdminUserSettings/tableMine">
									mine: '<xsl:value-of select="FlowInstanceAdminUserSettings/tableMine"/>',
								</xsl:if>
								
								<xsl:if test="FlowInstanceAdminUserSettings/tableBookmarked">
									bookmarked: '<xsl:value-of select="FlowInstanceAdminUserSettings/tableBookmarked"/>',
								</xsl:if>
								
								<xsl:if test="FlowInstanceAdminUserSettings/tableActive">
									active: '<xsl:value-of select="FlowInstanceAdminUserSettings/tableActive"/>',
								</xsl:if>
								
								<xsl:if test="FlowInstanceAdminUserSettings/tableAll">
									all: '<xsl:value-of select="FlowInstanceAdminUserSettings/tableAll"/>',
								</xsl:if>
							</xsl:if>
						},
						
						<xsl:if test="SiteProfiles">
							enableSiteProfileColumn: true,
						</xsl:if>
							
						<xsl:if test="EnableDescriptionColumn">
							enableDescriptionColumn: true,
						</xsl:if>
						
						<xsl:if test="EnableExternalIDColumn">
							enableExternalIDColumn: true,
						</xsl:if>
						
						<xsl:if test="UseHistoryTabAsDefaultTab">
	 						useHistoryTabAsDefaultTab: true,
	 					</xsl:if>
	 					
	 					<xsl:if test="AdminFlowInstanceProviders">
	 						adminFlowInstanceProviders: true,
	 					</xsl:if>
	 					
	 					<xsl:if test="ColoredTagProvider">
	 						coloredTagProvider: true,
	 					</xsl:if>
					};
					
					<xsl:if test="FlowInstanceAdminUserSettings and FlowInstanceAdminUserSettings/columnOrder">
						try {
							userColumnOrder = JSON.parse('<xsl:value-of select="FlowInstanceAdminUserSettings/columnOrder"/>');
							userColumnVisible = JSON.parse('<xsl:value-of select="FlowInstanceAdminUserSettings/columnVisibility"/>');
								
						} catch(error){
						
							if (console != undefined) {
								console.warn("Invalid user settings, using default instead. " + error);
							}
						}
					</xsl:if>
				</script>
  			
  			<div style="display: none;">
					
					<form id="dummyForm" method="POST">
						<xsl:call-template name="createHiddenField">
							<xsl:with-param name="name" select="'directFromInstanceList'"/>
							<xsl:with-param name="value" select="true"/>
						</xsl:call-template>
					</form>
					
					<div id="profiles">
						<xsl:for-each select="SiteProfiles/Profile">
							<div data-profileid="{profileID}">
								<xsl:value-of select="name"/>
							</div>
						</xsl:for-each>
					</div>
					
				</div>
				
				<div style="display: none;">
			
					<div id="table-settings-modal" class="table-settings-modal contentitem">
						<div class="modal-content">
						
							<div class="modal-header bigmarginbottom">
								<h1>
									<xsl:value-of select="$i18n.TableSettings.Title"/>
								</h1>
							</div>
							
							<div class="modal-body">
							
								<p class="tiny full">
							  	<xsl:value-of select="$i18n.TableSettings.Description" />
							  </p>
								  
								<div class="full bigmarginbottom sortable">
								
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">instanceID</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.InstanceID" />
									</xsl:call-template>
									
									<xsl:if test="EnableExternalIDColumn">
										<xsl:call-template name="createTableSettingRow">
											<xsl:with-param name="columnID">externalID</xsl:with-param>
											<xsl:with-param name="name" select="$i18n.Column.ExternalID" />
										</xsl:call-template>
									</xsl:if>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">events</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Events" />
									</xsl:call-template>
								
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">select</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Select" />
									</xsl:call-template>
									
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">status</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Status" />
									</xsl:call-template>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">submitted</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.SubmittedDate" />
									</xsl:call-template>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">poster</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Poster" />
									</xsl:call-template>
									
									<xsl:if test="EnableDescriptionColumn">
										<xsl:call-template name="createTableSettingRow">
											<xsl:with-param name="columnID">description</xsl:with-param>
											<xsl:with-param name="name" select="$i18n.Column.Description" />
										</xsl:call-template>
									</xsl:if>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">flowName</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.FlowName" />
									</xsl:call-template>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">version</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Version" />
									</xsl:call-template>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">category</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Category" />
									</xsl:call-template>
									
									<xsl:if test="SiteProfiles">
										<xsl:call-template name="createTableSettingRow">
											<xsl:with-param name="columnID">siteProfile</xsl:with-param>
											<xsl:with-param name="name" select="$i18n.Column.SiteProfile" />
										</xsl:call-template>
									</xsl:if>
									
									<xsl:call-template name="createTableSettingRow">
										<xsl:with-param name="columnID">managers</xsl:with-param>
										<xsl:with-param name="name" select="$i18n.Column.Managers" />
									</xsl:call-template>
									
									<xsl:if test="ColoredTagProvider">
										<xsl:call-template name="createTableSettingRow">
											<xsl:with-param name="columnID" select="ColoredTagProvider/ColumnID" />
											<xsl:with-param name="name" select="ColoredTagProvider/ColumnName" />
										</xsl:call-template>
									</xsl:if>
									
								</div>
								
								<div class="clearboth"></div>
								
								<div class="full paddingtop paddingbottom bigpaddingleft bigmarginbottom lightbackground">
									
									<p class="tiny full">
										<xsl:value-of select="$i18n.TableSettings.OpenInstanceDescription" />
									</p>

									<div class="opensetting full margintop">
										<xsl:call-template name="createRadio">
											<xsl:with-param name="id" select="'openModeNewTab'"/>
											<xsl:with-param name="name" select="'openMode'"/>
											<xsl:with-param name="value" select="'NEW_TAB'" />
											<xsl:with-param name="class" select="'bigmarginright'" />
											<xsl:with-param name="element" select="FlowInstanceAdminUserSettings" />
										</xsl:call-template>
										
										<label class="nomargin" for="openModeNewTab">
											<xsl:value-of select="$i18n.TableSettings.OpenInNewTab" />
										</label>
									</div>
									
									<div class="opensetting full">
										<xsl:call-template name="createRadio">
											<xsl:with-param name="id" select="'openModeCurrentTab'"/>
											<xsl:with-param name="name" select="'openMode'"/>
											<xsl:with-param name="value" select="'CURRENT_TAB'" />
											<xsl:with-param name="class" select="'bigmarginright'" />
											<xsl:with-param name="element" select="FlowInstanceAdminUserSettings" />
										</xsl:call-template>
										
										<label class="nomargin" for="openModeCurrentTab">
											<xsl:value-of select="$i18n.TableSettings.OpenInCurrentTab" />
										</label>
									</div>
								</div>
								
								<div class="full paddingtop paddingbottom bigpaddingleft bigmarginbottom lightbackground">
									
									<p class="tiny full">
										<xsl:value-of select="$i18n.TableSettings.DisplayManagerDescription" />
									</p>

									<div class="full margintop">
										<xsl:call-template name="createRadio">
											<xsl:with-param name="id" select="'managerDisplayModeFullName'"/>
											<xsl:with-param name="name" select="'managerDisplayMode'"/>
											<xsl:with-param name="value" select="'FULL_NAME'" />
											<xsl:with-param name="class" select="'bigmarginright'" />
											<xsl:with-param name="element" select="FlowInstanceAdminUserSettings" />
										</xsl:call-template>
										
										<label class="nomargin" for="managerDisplayModeFullName">
											<xsl:value-of select="$i18n.TableSettings.DisplayManagersFullName" />
										</label>
									</div>
									
									<div class="opensetting full">
										<xsl:call-template name="createRadio">
											<xsl:with-param name="id" select="'managerDisplayModeUsername'"/>
											<xsl:with-param name="name" select="'managerDisplayMode'"/>
											<xsl:with-param name="value" select="'USERNAME'" />
											<xsl:with-param name="class" select="'bigmarginright'" />
											<xsl:with-param name="element" select="FlowInstanceAdminUserSettings" />
										</xsl:call-template>
										
										<label class="nomargin" for="managerDisplayModeUsername">
											<xsl:value-of select="$i18n.TableSettings.DisplayManagersUsername" />
										</label>
									</div>
								</div>
																
								<input class="save bigmargintop floatright btn btn-blue" type="button" value="{$i18n.TableSettings.Save}" />
								<input class="reset bigmargintop bigmarginright floatright btn btn-blue" type="button" value="{$i18n.TableSettings.Reset}" />
								
							</div>
							
						</div>
					</div>
				
				</div>
				
  		</div>
 		</section>
	
		<div class="hidden">
			<select id="flowFilter-template" data-type="flowName" class="column-filter">
				<option value=""><xsl:value-of select="$i18n.Filter.Flow.Select" /></option>
			</select>
		</div>
	
		<div class="hidden">
			<select id="statusFilter-template" data-type="status" data-parent-type="flowName" class="column-filter hidden">
				<option value=""><xsl:value-of select="$i18n.Filter.Status.Select" /></option>
			</select>
		</div>
	
		<xsl:if test="ColoredTagProvider">
		
			<div class="hidden">
				<div id="coloredTagFilter-template" data-type="coloredTag" class="column-filter colored-tag-menu flowinstanceadmin-menu dd">
					<a>
						<div id="selectedColor" class="color"></div>
						<span id="selectedTag" data-color-id=""><xsl:value-of select="ColoredTagProvider/NoFilterText"/></span>
					</a>
					
					<div class="submenu">
						<ul class="column-filter-entry-container">
							<li>
								<a data-color-id="" data-name="{ColoredTagProvider/NoFilterText}" data-hex-color="">
									<div class="color"></div>
									<span><xsl:value-of select="ColoredTagProvider/NoFilterText"/></span>
								</a>
							</li>
						</ul>
					</div>
				</div>
			</div>
			
		</xsl:if>
	
		<div class="hidden">
			<select id="dateFilter-template" class="date-filter">
				<option value="ALL"><xsl:value-of select="$i18n.Filter.Date.All" /></option>
				<option value="ONE_MONTH_BACK"><xsl:value-of select="$i18n.Filter.Date.OneMonthBack" /></option>
				<option value="THREE_MONTHS_BACK"><xsl:value-of select="$i18n.Filter.Date.ThreeMonthsBack" /></option>
				<option value="SIX_MONTHS_BACK"><xsl:value-of select="$i18n.Filter.Date.SixMonthsBack" /></option>
				<option value="SELECT_CUSTOM"><xsl:value-of select="$i18n.Filter.Date.CustomInterval" /></option>
			</select>
		</div>
	
	</xsl:template>
	
	<xsl:template name="createFlowInstanceList">
	
		<xsl:param name="flowInstanceFilter" />
		
		<div id="{$flowInstanceFilter}" class="tab">
			
			<div class="tabs-content official">
				
				<xsl:variable name="ajaxURL">
					<xsl:value-of select="/Document/requestinfo/currentURI"/>
					<xsl:text>/</xsl:text>
					<xsl:value-of select="/Document/module/alias"/>
					<xsl:text>/instancedata/</xsl:text>
					<xsl:value-of select="$flowInstanceFilter"/>
				</xsl:variable>
				
				<table id="flowinstances-{$flowInstanceFilter}" class="stripe display flowinstance-table" data-url="{$ajaxURL}">
					<thead>
						<tr>
							<th><xsl:value-of select="$i18n.Column.InstanceID" /></th>
							<th/> <!-- flowID -->
							<th/> <!-- familyID -->
							<th><xsl:value-of select="$i18n.Column.Status" /></th>
							<th><xsl:value-of select="$i18n.Column.FlowName" /></th>
							<th><xsl:value-of select="$i18n.Column.Version.Short" /></th>
							<th><xsl:value-of select="$i18n.Column.Category" /></th>
							<th><xsl:value-of select="$i18n.Column.SubmittedDate" /></th>
							<th><xsl:value-of select="$i18n.Column.Poster" /></th>
							<th><xsl:value-of select="$i18n.Column.Managers" /></th>
							<th><xsl:value-of select="$i18n.Column.Events" /></th>
							
							<xsl:if test="SiteProfiles">
								<th><xsl:value-of select="$i18n.Column.SiteProfile" /></th>
							</xsl:if>
							
							<xsl:if test="EnableDescriptionColumn">
								<th><xsl:value-of select="$i18n.Column.Description" /></th>
							</xsl:if>
							
							<xsl:if test="EnableExternalIDColumn">
								<th><xsl:value-of select="$i18n.Column.ExternalID" /></th>
							</xsl:if>
							
							<th/> <!-- search extra -->
							
							<xsl:if test="AdminFlowInstanceProviders">
								<th/> <!-- overviewURL -->
							</xsl:if>
							
							<xsl:if test="ColoredTagProvider">
								<th><xsl:value-of select="ColoredTagProvider/TableHeaderText" /></th>
							</xsl:if>
							
							<th>
								<div class="select-page"/>
							</th>
							<th/> <!-- responsive expand -->
						</tr>
					</thead>
				</table>
				
				<div class="floatright marginleft bigmargintop">
					
					<xsl:apply-templates select="ListButtonExtensions/ListOverviewButtonExtension" />
					
					<a class="stealflowinstance btn btn-blue btn-inline marginright" href="#" onclick="return false;" title="{$i18n.StealFlowInstance.Button}">
						<xsl:value-of select="$i18n.StealFlowInstance.Button"/>
					</a>
					
					<a class="changestatus btn btn-blue btn-inline marginright" href="#" onclick="return false;" title="{$i18n.UpdateFlowInstanceStatuses.Button}">
						<xsl:value-of select="$i18n.UpdateFlowInstanceStatuses.Button"/>
					</a>
					
					<a class="addmanagers btn btn-blue btn-inline marginright" href="#" onclick="return false;" title="{$i18n.AddFlowInstanceManagers.Button}">
						<xsl:value-of select="$i18n.AddFlowInstanceManagers.Button"/>
					</a>
					
				</div>
				
				<div class="clearboth" />
		
			</div>
			
		</div>
		
	</xsl:template>
	
	<xsl:template name="createTableSettingRow">
		
		<xsl:param name="columnID" />
		<xsl:param name="name" />
		
		<div class="setting full padding margintop marginbottom lightbackground">
			<img class="bigmarginright cursor-move" src="{$imgPath}/move.png" title="{$i18n.MoveColumnOrder}" style="vertical-align: sub" />
			
			<!-- TODO Use of //requestparameters below is very slow and needs to be replaced -->
			
			<xsl:call-template name="createHiddenField">
				<xsl:with-param name="id" select="concat('columnID_', $columnID)"/>
				<xsl:with-param name="name" select="'columnID'"/>
				<xsl:with-param name="value" select="$columnID"/>
				<xsl:with-param name="class" select="'columnid'" />
			</xsl:call-template>
			<xsl:call-template name="createHiddenField">
				<xsl:with-param name="id" select="concat('sortorder_', $columnID)" />
				<xsl:with-param name="name" select="concat('sortorder_', $columnID)" />
				<xsl:with-param name="value" select="''" />
				<xsl:with-param name="class" select="'sortorder'" />
				<xsl:with-param name="requestparameters" select="//requestparameters" />
			</xsl:call-template>
			
			<xsl:call-template name="createCheckbox">
				<xsl:with-param name="id" select="concat('enabled_', $columnID)"/>
				<xsl:with-param name="name" select="concat('enabled_', $columnID)"/>
				<xsl:with-param name="checked" select="'false'"/>
				<xsl:with-param name="class" select="'enable bigmarginright'" />
				<xsl:with-param name="requestparameters" select="//requestparameters" />
			</xsl:call-template>
			
			<label class="nomargin" for="{concat('enabled_', $columnID)}">
				<xsl:value-of select="$name"/>
			</label>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="ListOverviewButtonExtension">
		
		<a class="btn btn-blue btn-inline marginright {extraClasses}" href="#" onclick="return false;" title="{title}">
			<xsl:for-each select="DataAttributes/Attribute">
				<xsl:attribute name="data-{Name}">
					<xsl:value-of select="Value" />
				</xsl:attribute>
			</xsl:for-each>
			<xsl:value-of select="name"/>
		</a>
		
	</xsl:template>
	
	<xsl:template match="ShowFlowInstanceOverview">
	
		<xsl:apply-templates select="FlowInstance" mode="overview" />
	
	</xsl:template>
	
	<xsl:template match="FlowInstance" mode="overview">
		
		<xsl:call-template name="showManagerFlowInstanceControlPanel">
			<xsl:with-param name="flowInstance" select="." />
			<xsl:with-param name="view" select="'OVERVIEW'" />
			<xsl:with-param name="bookmarked" select="../Bookmarked" />
		</xsl:call-template>
		
		<section class="child">
		
			<div class="flowinstance-overview-header full border-box">
				
				<xsl:call-template name="CreateToolsMenu">
					<xsl:with-param name="flowInstance" select="." />
					<xsl:with-param name="view" select="'OVERVIEW'" />
					<xsl:with-param name="bookmarked" select="../Bookmarked" />
					<xsl:with-param name="hideUpdateManagers" select="../HideUpdateManagers"/>
					<xsl:with-param name="deleteAccess" select="../DeleteAccess"/>
				</xsl:call-template>
				
				<div class="heading full bigpaddingbottom paddingright">
				
					<figure>
						<img src="{/Document/requestinfo/currentURI}/{/Document/module/alias}/icon/{Flow/flowID}" alt="" />
					</figure>
					
					<div class="title">
						<h1 class="xl nopadding">
							<xsl:value-of select="Flow/name" /><b><xsl:text>&#160;</xsl:text>(<xsl:value-of select="Status/name" />)</b>
						</h1>
						
						<div class="title-subtext">
							<span class="errandno hide-mobile">
								<xsl:value-of select="$i18n.FlowInstanceID" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="flowInstanceID" />
								<xsl:call-template name="printExternalID"/>
							</span>
						</div>
						
						<div id="headingbookmarkicon" class="heading-icon floatleft">
							<a href="#" onclick="return toggleBookmark(event, this, '{/Document/requestinfo/currentURI}/{/Document/module/alias}/bookmark/{flowInstanceID}');">
								<xsl:choose>
									<xsl:when test="../Bookmarked">
										<xsl:attribute name="title"><xsl:value-of select="$i18n.BookmarkInstanceRemove" /></xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="title"><xsl:value-of select="$i18n.BookmarkInstance" /></xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
								<span data-icon-before="*">
									<xsl:choose>
										<xsl:when test="../Bookmarked">
											<xsl:attribute name="class"><xsl:text>active</xsl:text></xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="class"><xsl:text>inactive</xsl:text></xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</span>
							</a>
						</div>
						
						<xsl:if test="../ColoredTagProvider">
							
							<xsl:variable name="selectedTagID" select="../ColoredTagProvider/SelectedTagID"/>
							<xsl:variable name="selectedTag" select="../ColoredTagProvider/Tags/Tag[tagID = $selectedTagID]"/>
						
							<div id="coloredTagSelect" class="colored-tag-menu flowinstanceadmin-menu dd floatleft marginleft" data-url="{/Document/requestinfo/currentURI}/{/Document/module/alias}/coloredtag/{flowInstanceID}">
								<xsl:if test="$selectedTag/hexColor">
									<xsl:attribute name="style">background-color:<xsl:value-of select="$selectedTag/hexColor" />;</xsl:attribute>
								</xsl:if>
								<a>
									<div class="menu-arrow"><i>_</i></div>
									<span class="selected-tag">
										<xsl:if test="$selectedTag/name">
											<xsl:attribute name="class">selected-tag marginleft</xsl:attribute>
											<xsl:value-of select="$selectedTag/name" />
										</xsl:if>
									</span>
								</a>
								
								<div class="submenu">
									<ul>
									
										<li>
											<a>
												<div class="color"></div>
												<span><xsl:value-of select="../ColoredTagProvider/NoTagText"/></span>
											</a>
										</li>

										<xsl:for-each select="../ColoredTagProvider/Tags/Tag">
											<li>
												<a data-tag-id="{tagID}" data-hex-color="{hexColor}" data-name="{name}">
													<div class="color" style="background-color:{hexColor};"></div>
													<span><xsl:value-of select="name"/></span>
												</a>
											</li>
										</xsl:for-each>
										
									</ul>
								</div>
							</div>
						</xsl:if>
						
					</div>
					
				</div>
				
				<xsl:if test="../HeaderExtensions">
					<xsl:for-each select="../HeaderExtensions/ViewFragment">
						<xsl:value-of select="HTML" disable-output-escaping="yes"/>
					</xsl:for-each>
				</xsl:if>
				
				<div class="description">
				
					<div class="main-description bigpaddingright">
						<xsl:variable name="submittedEvents" select="events/FlowInstanceEvent[eventType='SUBMITTED']" />
						
						<p class="only-mobile">
							<strong class="overview"><xsl:value-of select="$i18n.FlowInstanceID" /><xsl:text>:&#160;</xsl:text></strong><xsl:value-of select="flowInstanceID" />
						</p>
						
						<xsl:if test="../Profile">
							<p>
								<strong class="overview"><xsl:value-of select="$i18n.SiteProfile" /><xsl:text>:&#160;</xsl:text></strong>
								<xsl:value-of select="../Profile/name" />
							</p>
						</xsl:if>
						
						<p>
							<strong class="overview"><xsl:value-of select="$i18n.FirstSubmitted" /><xsl:text>:&#160;</xsl:text></strong>
							<xsl:value-of select="firstSubmitted" /><xsl:text>&#160;</xsl:text>
							<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
							
							<xsl:call-template name="PrintPostedBy">
								<xsl:with-param name="poster" select="$submittedEvents[position() = 1]/poster/user"/>
								<xsl:with-param name="flowInstanceAttributes" select="Attributes"/>
							</xsl:call-template>
							
							<!-- TODO add citizen identifier -->
							
							<xsl:choose>
								<xsl:when test="Attributes/Attribute[Name = 'anonymized']/Value = 'true'">
									<div class="overview">
										<xsl:value-of select="$i18n.PosterAnonymized" />
									</div>
								</xsl:when>
								<xsl:when test="not(poster)">
									<div class="overview">
										<xsl:value-of select="$i18n.PosterWasNotLoggedIn" />
									</div>
								</xsl:when>
							</xsl:choose>
						</p>
						
						<xsl:if test="count(owners/user) > 1">
							<p>
								<strong class="overview"><xsl:value-of select="$i18n.Owners" /><xsl:text>:&#160;</xsl:text></strong>
								<xsl:apply-templates select="owners/user" mode="owner" />
							</p>
						</xsl:if>
	
						<!-- Show poster if different from submitter -->
						
						<xsl:if test="count($submittedEvents) > 1">
							<p>
								<xsl:variable name="lastSubmit" select="$submittedEvents[position() = last()]" />
								
								<strong class="overview"><xsl:value-of select="$i18n.LastSubmitted" /><xsl:text>:&#160;</xsl:text></strong>
								
								<xsl:value-of select="$lastSubmit/added" /><xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
								
								<xsl:call-template name="printUser">
									<xsl:with-param name="user" select="$lastSubmit/poster/user" />
								</xsl:call-template>
							</p>
						</xsl:if>
						
						<xsl:if test="updated">
							<p>
								<strong class="overview"><xsl:value-of select="$i18n.LastChanged" /><xsl:text>:&#160;</xsl:text></strong>
								
								<xsl:value-of select="updated" /><xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$i18n.by" /><xsl:text>&#160;</xsl:text>
								
								<xsl:choose>
									<xsl:when test="editor/user">
									
										<xsl:call-template name="printUser">
											<xsl:with-param name="user" select="editor/user" />
										</xsl:call-template>
										
									</xsl:when>
									<xsl:otherwise>
									
										<xsl:value-of select="$i18n.AnonymousUser" />
										
									</xsl:otherwise>
								</xsl:choose>
							</p>
						</xsl:if>
						
						<p>
							<strong class="overview"><xsl:value-of select="$i18n.Managers" /><xsl:text>:&#160;</xsl:text></strong>
							
							<xsl:choose>
								<xsl:when test="managers/user or managerGroups/group">
								
									<xsl:apply-templates select="managers/user" mode="manager" />
									<xsl:apply-templates select="managerGroups/group" mode="manager" />
									
								</xsl:when>
								<xsl:otherwise>
								
									<xsl:value-of select="$i18n.NoManager" />
									
								</xsl:otherwise>
							</xsl:choose>
	
							<xsl:variable name="userID" select="../user/userID"/>
	
							<xsl:if test="count(managers/user) &lt; 2 and not(managers/user/userID = $userID)">
								<xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/steal/{flowInstanceID}">
									<span title="{$i18n.StealHoverText}">[<xsl:value-of select="$i18n.StealFlowInstance" />]</span>
								</a>
							</xsl:if>
		
						</p>
					</div>
					
					<xsl:if test="../FlowOverviewAttributes/FlowOverviewAttribute">
					
						<div class="extra-description1">
							<xsl:if test="count(../FlowOverviewAttributes/FlowOverviewAttribute) > 3">
								<xsl:attribute name="class">extra-description1 bigpaddingright</xsl:attribute>
							</xsl:if>
							
							<table>
								<xsl:apply-templates select="../FlowOverviewAttributes/FlowOverviewAttribute[3 >= position()]" />
							</table>
						</div>
						
						<xsl:if test="count(../FlowOverviewAttributes/FlowOverviewAttribute) > 3">
							<div class="extra-description2">
								<table>
									<xsl:apply-templates select="../FlowOverviewAttributes/FlowOverviewAttribute[position() > 3]" />
								</table>
							</div>
						</xsl:if>
						
					</xsl:if>
					
					<xsl:if test="../DescriptionExtensions">
						<xsl:for-each select="../DescriptionExtensions/ViewFragment">
							<xsl:value-of select="HTML" disable-output-escaping="yes"/>
						</xsl:for-each>
					</xsl:if>
					
				</div>
				
			</div>
		
			<div id="tabs">
				<ul class="tabs">
					
					<li data-tabid="#showflow">
						<a data-icon-before="S" href="#showflow" title="{$i18n.ShowFlowInstance}"><xsl:value-of select="$i18n.ShowFlowInstance" /></a>
					</li>
					
					<li class="active" data-tabid="#history">
						<a data-icon-before="o" href="#history" title="{$i18n.FlowInstanceEvents}"><xsl:value-of select="$i18n.FlowInstanceEvents" /></a>
					</li>
					
 					<xsl:if test="not(hideExternalMessages)">
						<li data-tabid="#messages">
							<a data-icon-before="m" href="#messages" title="{$i18n.ExternalMessages}">
								<xsl:value-of select="$i18n.ExternalMessages" />
								<xsl:text>&#160;(</xsl:text>
								<xsl:value-of select="count(externalMessages/ExternalMessage)"/>
								<xsl:text>)</xsl:text>
								
								<!-- TODO count how many unread messages since last login -->
								<xsl:if test="false()">
									<span class="count">0</span>
								</xsl:if>
							</a>
						</li>
					</xsl:if>
					
					<xsl:if test="not(Flow/hideInternalMessages = 'true')">
						<li data-tabid="#notes" class="notes">
							<a data-icon-before="i" href="#notes" title="{$i18n.InternalMessages}">
								<xsl:value-of select="$i18n.InternalMessages" />
								<xsl:text>&#160;(</xsl:text>
								<xsl:value-of select="count(internalMessages/InternalMessage)"/>
								<xsl:text>)</xsl:text>
							</a>
						</li>
					</xsl:if>
					
					<xsl:apply-templates select="../TabHeaders/ExtensionLink" mode="tab-header"/>
				</ul>
				
				<div id="showflow" class="tabs-content">
					
					<xsl:if test="Status/isAdminMutable = 'true'">
						<div class="editbutton">
							<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/flowinstance/{Flow/flowID}/{flowInstanceID}" class="btn btn-light next"><i data-icon-before="W"></i><xsl:value-of select="$i18n.UpdateFlowInstance" /></a>
						</div>
					</xsl:if>
					
					<xsl:apply-templates select="../ImmutableFlowInstanceManagerPreview"/>
					
					<xsl:if test="PreviewError">
						<div class="heading-wrapper bigmargin"><h3><xsl:value-of select="$i18n.PreviewErrorMessage"/></h3></div>
					</xsl:if>
				
				</div>
				
 				<xsl:if test="not(hideExternalMessages)">
					<div id="messages">
						
						<div id="new-message" class="tabs-content">
							
							<div class="heading-wrapper">
								<h2><xsl:value-of select="$i18n.NewMessage" /></h2>
								<a href="#" class="btn btn-light btn-right close_message"><xsl:value-of select="$i18n.Close" /><i data-icon-after="x"></i></a>
								
								<xsl:apply-templates select="Flow" mode="messageTemplates">
									<xsl:with-param name="type" select="'EXTERNAL'"/>
								</xsl:apply-templates>
								
							</div>
							
							<form action="{/Document/requestinfo/uri}?externalmessage#messages" method="post" enctype="multipart/form-data">
							
								<xsl:apply-templates select="Flow" mode="externalMessage"/>
								
								<div class="floatright">
									<a href="#" class="btn btn-light btn-inline close_message marginright"><xsl:value-of select="$i18n.Cancel" /></a>
									<input type="submit" value="{$i18n.SubmitMessage}" name="externalmessage" class="btn btn-green btn-inline" />
								</div>
								
								<div class="clearboth"/>
								
							</form>
							
						</div>
						
						<div class="tabs-content">
							
							<div class="heading-wrapper">
								<h2 class="marginbottom"><xsl:value-of select="$i18n.ExternalMessages" /></h2>
								
								<p class="clearboth"><xsl:value-of select="$i18n.ExternalMessages.Description"/></p>
								
								<xsl:if test="not(hideSendExternalMessage)">
									<a href="#" class="btn btn-blue btn-right open_message"><i data-icon-before="+"></i><xsl:value-of select="$i18n.NewMessage" /></a>
								</xsl:if>
							</div>
							
							
							<xsl:choose>
								<xsl:when test="externalMessages/ExternalMessage">

									<xsl:call-template name="sortMessagesButton" />

									<ul class="messages">
										<xsl:apply-templates select="externalMessages/ExternalMessage" mode="admin" />
									</ul>

								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$i18n.NoExternalMessages" />
								</xsl:otherwise>	  					
							</xsl:choose>
							
						</div>
						
					</div>
					
					<xsl:if test="ExternalMessageVerifyAttachedFilesModal">
						
						<xsl:call-template name="createVerifyAttachedFilesModal" />
						
					</xsl:if>
					
				</xsl:if>
				
				<div id="history" class="tabs-content nopadding" >
					
					<div class="errands-wrapper">
						
						<xsl:for-each select="../HistoryExtensions/ViewFragment">
							<xsl:value-of select="HTML" disable-output-escaping="yes"/>
						</xsl:for-each>
						
						<div class="heading-wrapper">
							<h2><xsl:value-of select="$i18n.FlowInstanceEvents" /></h2>
						</div>
						
						<table class="oep-table">
							<thead class="errand">
								<tr>
									<xsl:if test="not(HideFlowInstanceHistoryIconColumn)">
										<th class="icon" style="width: 32px;" />
									</xsl:if>
									<th class="service active"><span><xsl:value-of select="$i18n.Action" /></span></th>
									<th class="details"><span><xsl:value-of select="$i18n.Details" /></span></th>
									<th class="date"><span><xsl:value-of select="$i18n.Date" /></span></th>
									<th class="person"><span><xsl:value-of select="$i18n.Person" /></span></th>
								</tr>
							</thead>
							<tbody>
								<xsl:choose>
									<xsl:when test="events/FlowInstanceEvent">
										<xsl:apply-templates select="events/FlowInstanceEvent" />
									</xsl:when>
									<xsl:otherwise>
										<tr><td /><td colspan="4"><xsl:value-of select="$i18n.NoEvents" /></td></tr>
									</xsl:otherwise>
								</xsl:choose>
							</tbody>
						</table>
						
					</div>
					
				</div>
				
				<xsl:if test="not(Flow/hideInternalMessages = 'true')">
					<div id="notes">
					
						<div id="new-note" class="tabs-content notes">
						
							<div class="heading-wrapper">
								<h2><xsl:value-of select="$i18n.NewInternalMessage" /></h2>
								<a href="#" class="btn btn-light btn-right close_message"><xsl:value-of select="$i18n.Close" /><i data-icon-after="x"></i></a>
								
								<xsl:apply-templates select="Flow" mode="messageTemplates">
									<xsl:with-param name="type" select="'INTERNAL'"/>
								</xsl:apply-templates>

							</div>
							
							<form action="{/Document/requestinfo/uri}?internalmessage#notes" method="post" enctype="multipart/form-data">
							
								<xsl:apply-templates select="Flow" mode="internalMessage"/>
								
								<div class="floatright">
									<a href="#" class="btn btn-light btn-inline close_message marginright"><xsl:value-of select="$i18n.Cancel" /></a>
									<input type="submit" value="{$i18n.SubmitInternalMessage}" name="internalmessage" class="btn btn-green btn-inline" />
								</div>
								
								<div class="clearboth"/>
								
							</form>
							
						</div>
						
						<div class="tabs-content notes">
							
							<div class="heading-wrapper">
								<h2 class="marginbottom"><xsl:value-of select="$i18n.InternalMessagesTitle" /></h2>
								<p class="clearboth"><xsl:value-of select="$i18n.InternalMessages.Description"/></p>
								<a href="#" class="btn btn-blue btn-right open_message"><i data-icon-before="+"></i><xsl:value-of select="$i18n.NewInternalMessage" /></a>
							</div>
							
							<xsl:choose>
								<xsl:when test="internalMessages/InternalMessage">
								
									<xsl:call-template name="sortMessagesButton">
										<xsl:with-param name="type" select="'internal'"/>
									</xsl:call-template>
								
									<ul class="messages show-mentions">
										<xsl:apply-templates select="internalMessages/InternalMessage" mode="admin" />
									</ul>

								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$i18n.NoInternalMessages" />
								</xsl:otherwise>
							</xsl:choose>
							
						</div>
						
					</div>
				</xsl:if>
				
				<xsl:for-each select="../TabContents/ViewFragment">
					<xsl:value-of select="HTML" disable-output-escaping="yes"/>
				</xsl:for-each>
			
			</div>
			
			<a id="backtotop" class="btn btn-dark" href="#" onclick="$(document).scrollTop(0); return false;">
				<span><xsl:value-of select="$i18n.ScrollToTop"/></span>
				<img class="marginleft" alt="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/baseline_arrow_upward_white_18dp.png" />
			</a>
			
			<script type="text/javascript">
				$(function() {
					
					var button = $("#backtotop");
					var doc = $(document);
					
					$(window).on("scroll", function(event){
						button.toggle(doc.scrollTop() > 100);
					});
				});
			</script>
			
		</section>
		
	</xsl:template>

	<xsl:template match="Flow" mode="messageTemplates">
		<xsl:param name="type" />
		
		<xsl:if test="FlowFamily/MessageTemplates/MessageTemplate[type=$type or type='ALL']">
			
			<select class="messageTemplates floatright bigmarginright">
	
				<option value="">
					<xsl:value-of select="$i18n.MessageTemplates.choose" />
				</option>
	
				<xsl:for-each select="FlowFamily/MessageTemplates/MessageTemplate[type=$type or type='ALL']">
					
						<option value="{message}" data-template-id="{templateID}">
		
							<xsl:value-of select="name" />
		
						</option>
						
				</xsl:for-each>
				
			</select>
			
		</xsl:if>
	
	</xsl:template>
	
	<xsl:template match="Flow" mode="externalMessage">
		<xsl:param name="noContactWay" select="../../NoContactWay" />
		<xsl:param name="validationErrors" select="../../validationError" />
		<xsl:param name="requestparameters" select="../../requestparameters" />
		<xsl:param name="formattedMaxFileSize" select="../../FormattedMaxFileSize" />
		<xsl:param name="allowedExternalMessageFileExtensions" select="../../AllowedExternalMessageFileExtensions" />
		
		<xsl:if test="$noContactWay">
			<span class="italic">
				<xsl:value-of select="$i18n.NewMessageWarningNoContactWay"/>
			</span>
		</xsl:if>
		
		<label class="required" for="message"><xsl:value-of select="$i18n.Message" /></label>
		<xsl:apply-templates select="$validationErrors[fieldName = 'externalmessage']" />
		<textarea id="message" name="externalmessage" data-requiredmessage="{$i18n.ValidationError.ExternalMessageRequired}"  class="full" rows="10">
			<xsl:value-of select="$requestparameters/parameter[name = 'externalmessage']/value" />
		</textarea>
		
		<xsl:if test="not(hideExternalMessageAttachments = 'true')">
		
			<div class="heading-wrapper">
				<label><xsl:value-of select="$i18n.AttachFiles" /></label>
			</div>
			
			<script>
				imagePath = '<xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/pics';
				deleteFile = '<xsl:value-of select="$i18n.DeleteFile" />';
			</script>
			
			<xsl:apply-templates select="$validationErrors[fieldName = 'externalmessage-attachments' and (messageKey = 'FileSizeLimitExceeded' or messageKey = 'UnableToParseRequest' or messageKey = 'InvalidFileExtension')]" />
			
			<div class="full">
				
				<div class="upload clearboth">
					<span class="btn btn-upload btn-blue">
						<xsl:value-of select="$i18n.ChooseFiles" />
						<input id="external-message" type="file" name="externalmessage-attachments" multiple="multiple" size="55" class="qloader externalmessages bigmarginbottom" />
					</span>
					<span><xsl:value-of select="$i18n.MaximumFileSize" />: <xsl:value-of select="$formattedMaxFileSize" /></span>
					
					<xsl:if test="$allowedExternalMessageFileExtensions">
						<span>
							<xsl:value-of select="$i18n.AllowedFilextentions" />
							<xsl:text>: </xsl:text>
							<xsl:apply-templates select="$allowedExternalMessageFileExtensions/FileExtension" mode="commaseparated"/>
						</span>
					</xsl:if>						
				</div>
				
				<ul id="external-message-qloader-filelist" class="files" />
				
			</div>
			
			<xsl:if test="readReceiptsEnabled = 'true'">
			
				<div class="full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'externalmessage-readreceiptenabled'"/>
						<xsl:with-param name="name" select="'externalmessage-readreceiptenabled'"/>
						<xsl:with-param name="checked" select="readReceiptsEnabledByDefault" />
						<xsl:with-param name="requestparameters" select="$requestparameters" />
					</xsl:call-template>
					
					<label class="checkbox" for="externalmessage-readreceiptenabled">
						<xsl:value-of select="$i18n.readReceiptsEnabled" />
					</label>
				</div>
				
			</xsl:if>
			
		</xsl:if>
	
	</xsl:template>
	
	<xsl:template match="Flow" mode="internalMessage">
		<xsl:param name="flowInstanceID" select="../flowInstanceID" />
		<xsl:param name="validationErrors" select="../../validationError" />
		<xsl:param name="requestparameters" select="../../requestparameters" />
		<xsl:param name="formattedMaxFileSize" select="../../FormattedMaxFileSize" />
		<xsl:param name="allowedInternalMessageFileExtensions" select="../../AllowedInternalMessageFileExtensions" />
		
		<label class="required" for="message"><xsl:value-of select="$i18n.InternalMessage" /></label>
		<xsl:apply-templates select="$validationErrors[fieldName = 'internalmessage']" />
		<textarea id="message" name="internalmessage" data-requiredmessage="{$i18n.ValidationError.InternalMessageRequired}"  class="full mentionable" rows="10">
		
			<xsl:if test="$flowInstanceID">
				<xsl:attribute name="data-mentionableendpoint">
					<xsl:value-of select="/Document/requestinfo/currentURI" />
					<xsl:text>/</xsl:text>
					<xsl:value-of select="/Document/module/alias" />
					<xsl:text>/getmentionusers/</xsl:text>
					<xsl:value-of select="$flowInstanceID" />
				</xsl:attribute>
			</xsl:if>
			
			<xsl:value-of select="$requestparameters/parameter[name = 'internalmessage']/value" />
			
		</textarea>
		
		<div class="heading-wrapper">
			<label><xsl:value-of select="$i18n.AttachFiles" /></label>
		</div>
		
		<script>
			imagePath = '<xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/pics';
			deleteFile = '<xsl:value-of select="$i18n.DeleteFile" />';
		</script>
		
		<xsl:apply-templates select="$validationErrors[fieldName = 'internalmessage-attachments' and (messageKey = 'FileSizeLimitExceeded' or messageKey = 'UnableToParseRequest' or messageKey = 'InvalidFileExtension')]" />
		
		<div class="full">
			
			<div class="upload clearboth">
				<span class="btn btn-upload btn-blue">
					<xsl:value-of select="$i18n.ChooseFiles" />
					<input id="internal-message" type="file" name="internalmessage-attachments" multiple="multiple" size="55" class="qloader internalmessages bigmarginbottom" />
				</span>
				<span><xsl:value-of select="$i18n.MaximumFileSize" />: <xsl:value-of select="$formattedMaxFileSize" /></span>
				
				<xsl:if test="$allowedInternalMessageFileExtensions">
					<span>
						<xsl:value-of select="$i18n.AllowedFilextentions" />
						<xsl:text>: </xsl:text>
						<xsl:apply-templates select="$allowedInternalMessageFileExtensions/FileExtension" mode="commaseparated"/>
					</span>
				</xsl:if>						
			</div>
			
			<ul id="internal-message-qloader-filelist" class="files" />
			
		</div>
	
	</xsl:template>
	
	<xsl:template match="FileExtension" mode="commaseparated">
	
		<xsl:value-of select="."/>
		
		<xsl:if test="position() != last()">
			<xsl:text>, </xsl:text>
		</xsl:if>
		
	</xsl:template>
	
	<xsl:template match="FlowOverviewAttribute">
		<tr>
			<td>
				<strong>
					<xsl:value-of select="name" />
					<xsl:text>:</xsl:text>
				</strong>
			</td>
			<td>
				<xsl:value-of select="formattedValue" />
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="FlowInstanceEvent">
		
		<xsl:variable name="odd" select="(position() mod 2) != 0" />
		
		<tr>
			<xsl:if test="$odd">
				<xsl:attribute name="class">odd</xsl:attribute>
			</xsl:if>
			
			<xsl:if test="not(../../HideFlowInstanceHistoryIconColumn)">
			
				<td class="icon">
					<xsl:if test="Attributes/Attribute[Name='pdf']/Value = 'true'">
						<xsl:choose>
							<xsl:when test="eventType = 'SIGNED' or eventType = 'SIGNING_SKIPPED'">
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/pdf/{../../flowInstanceID}/{eventID}" title="{$i18n.DownloadFlowInstanceSignPDF}">
									<img alt="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/pdf_lock.png" />
								</a>
							</xsl:when>
							<xsl:otherwise>
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/pdf/{../../flowInstanceID}/{eventID}" title="{$i18n.DownloadFlowInstancePDF}">
									<img alt="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/pdf.png" />
								</a>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					
					<xsl:if test="Attributes/Attribute[Name='xml']/Value = 'true'">
						<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/xml/{../../flowInstanceID}/{eventID}" title="{$i18n.DownloadFlowInstanceXML}">
							<img alt="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/xml.png" />
						</a>
					</xsl:if>
					
					<xsl:if test="Attributes/Attribute[Name='signingData']">
						<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/signature/{../../flowInstanceID}/{eventID}" title="{$i18n.DownloadSignature}">
							<img alt="" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/lock.png" />
						</a>
					</xsl:if>
				</td>
				
			</xsl:if>
			
			<td data-title="{$i18n.Action}" class="service">
				<xsl:call-template name="getEventTypeText" />
			</td>
			<td data-title="{$i18n.Details}">
				<xsl:choose>
					<xsl:when test="Attributes/Attribute[Name='externalMessageID']">
						<xsl:variable name="messageID" select="Attributes/Attribute[Name='externalMessageID']/Value"></xsl:variable>
						<a class="messagelink" href="#messages-{$messageID}">
							<xsl:value-of select="Attributes/Attribute[Name='externalMessageFragment']/Value"></xsl:value-of>
						</a>
					</xsl:when>
					<xsl:when test="eventType = 'STATUS_UPDATED'">
						<xsl:value-of select="status" />
					</xsl:when>
					<xsl:when test="details"><xsl:value-of select="details" /></xsl:when>
					<xsl:otherwise>-</xsl:otherwise>
				</xsl:choose>
			</td>
			<td data-title="{$i18n.Date}" class="date"><xsl:value-of select="added" /></td>
			<td data-title="{$i18n.Person}" class="person">
				<xsl:call-template name="printUser">
					<xsl:with-param name="user" select="poster/user" />
				</xsl:call-template>
			</td>
		</tr>
		
	</xsl:template>
	
	<xsl:template match="ExtensionLink">
	
			<li>

				<a href="{url}" title="{name}">
					
					<span class="icon arrow"><i data-icon-before=">"></i></span>
					<span><xsl:value-of select="name"/></span>
				
				</a>

			</li>
	
	</xsl:template>
	
	<xsl:template match="ExtensionLink" mode="tab-header">
		
		<li>
			<a href="{url}" title="{name}">

				<xsl:if test="icon">
					<xsl:text> </xsl:text>
					<img src="{icon}"/>
				</xsl:if>
				
				<xsl:value-of select="name"/>
			
			</a>
		</li>
	
	</xsl:template>

	<xsl:template name="CreateToolsMenu">
	
		<xsl:param name="flowInstance" />
		<xsl:param name="view" />
		<xsl:param name="bookmarked" select="Bookmarked" />
		<xsl:param name="hideUpdateManagers" select="null" />
		<xsl:param name="deleteAccessOverride" select="null" />
		<xsl:param name="deleteAccess" select="null" />
		
		<div id="tools-menu-container">
			
			<div id="tools-menu" class="flowinstanceadmin-menu dd">
				<a>
					<span>
						<xsl:value-of select="$i18n.Shortcuts"/>
					</span>
					<div class="menu-arrow"><i>_</i></div>
				</a>
				
				<div class="submenu">
					<ul>
					
						<li>
							<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/overview/{$flowInstance/flowInstanceID}">
								<span class="icon arrow"><i data-icon-before=">"></i></span>
								<span><xsl:value-of select="$i18n.overview"/></span>
								<span data-icon-before="L" class="menu-icon"/>
							</a>
						</li>
						
						<xsl:if test="$flowInstance/Status/isAdminMutable = 'true'">
							<li>
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/flowinstance/{$flowInstance/Flow/flowID}/{$flowInstance/flowInstanceID}">
									<span class="icon arrow"><i data-icon-before=">"></i></span>
									<span><xsl:value-of select="$i18n.updateInstance"/></span>
									<span data-icon-before="w" class="menu-icon"/>
								</a>
							</li>
						</xsl:if>
	
						<li>
							<a href="#" onclick="return toggleBookmark(event, this, '{/Document/requestinfo/currentURI}/{/Document/module/alias}/bookmark/{$flowInstance/flowInstanceID}');">
								<span class="icon arrow"><i data-icon-before=">"></i></span>
								<span id="menubookmarktext" data-bookmark="{$i18n.BookmarkInstance}" data-unbookmark="{$i18n.BookmarkInstanceRemove}">
									<xsl:choose>
										<xsl:when test="$bookmarked">
											<xsl:value-of select="$i18n.BookmarkInstanceRemove"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="$i18n.BookmarkInstance"/>
										</xsl:otherwise>
									</xsl:choose>
								</span>
								<span data-icon-before="*" class="menu-icon"/>
							</a>
						</li>
						
						<li>
							<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/status/{$flowInstance/flowInstanceID}">
								<span class="icon arrow"><i data-icon-before=">"></i></span>
								<span><xsl:value-of select="$i18n.updateStatus"/></span>
								<span data-icon-before="!" class="menu-icon"/>
							</a>
						</li>
						
						<xsl:if test="not($hideUpdateManagers)">
							<li>
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/managers/{$flowInstance/flowInstanceID}">
									<span class="icon arrow"><i data-icon-before=">"></i></span>
									<span><xsl:value-of select="$i18n.updateManagers"/></span>
									<span data-icon-before="u" class="menu-icon"/>
								</a>
							</li>
						</xsl:if>
	
						<xsl:if test="$deleteAccess or $deleteAccessOverride">
							<li>
								<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/delete/{$flowInstance/flowInstanceID}" onclick="return confirmHyperlinkPost(this);" title="{$i18n.DeleteFlowInstanceConfirm}: {$flowInstance/Flow/name} (#{$flowInstance/flowInstanceID})">
									<span class="icon arrow"><i data-icon-before=">"></i></span>
									<span><xsl:value-of select="$i18n.deleteInstance"/></span>
									<span data-icon-before="x" class="menu-icon"/>
								</a>
							</li>
						</xsl:if>
						
					</ul>
				</div>
			</div>
			
		</div>
		
	</xsl:template>

	<xsl:template name="CreateShortcutMenu">
	
		<xsl:variable name="extensionLinks" select="ExtensionLink[slot='top-right']"/>
	
		<div id="shortcut-menu" class="flowinstanceadmin-menu dd">
			<a>
				<span>
					<xsl:value-of select="$i18n.Shortcuts"/>
				</span>
				<div class="menu-arrow"><i>_</i></div>
			</a>
			<div class="submenu">
				<ul>
					<li>
						<xsl:apply-templates select="$extensionLinks"/>
					</li>
				</ul>
			</div>
		</div>
	</xsl:template>
	
	<xsl:template match="UpdateInstanceStatus">
		
		<section class="child">
			<div class="section-full header-full">
				<div class="heading-wrapper full">
					<figure>
						<img src="{/Document/requestinfo/currentURI}/{/Document/module/alias}/icon/{FlowInstance/Flow/flowID}?{FlowInstance/Flow/IconLastModified}" alt="" />
					</figure>
					<div class="heading">
						<h1 class="xl"><xsl:value-of select="FlowInstance/Flow/name" /><xsl:text>&#160;</xsl:text><b>(<xsl:value-of select="FlowInstance/Status/name" />)</b></h1>
						<span class="errandno"><xsl:value-of select="$i18n.FlowInstanceID" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="FlowInstance/flowInstanceID" /></span>
						<span class="errandno">
							<xsl:value-of select="$i18n.SubmittedBy" /><xsl:text>:&#160;</xsl:text>
							<xsl:value-of select="FlowInstance/poster/user/firstname" /><xsl:text>&#160;</xsl:text>
							<xsl:value-of select="FlowInstance/poster/user/lastname" />
						</span>
					</div>
				</div>
			</div>
			<div class="divider errands" />
			
			<xsl:if test="validationError[fieldName != 'externalmessage' and fieldName != 'externalmessage-attachments' and fieldName != 'internalmessage' and fieldName != 'internalmessage-attachments']">
				<div class="section-full">
					<xsl:apply-templates select="validationError[fieldName != 'externalmessage' and fieldName != 'externalmessage-attachments' and fieldName != 'internalmessage' and fieldName != 'internalmessage-attachments']"/>
				</div>
			</xsl:if>
			
			<form id="UpdateFlowInstanceStatusForm" method="POST" action="{/Document/requestinfo/uri}" enctype="multipart/form-data">
			
				<div class="section-full">
					<h2><xsl:value-of select="$i18n.CurrentStatus"/><xsl:text>&#160;</xsl:text><b><xsl:value-of select="FlowInstance/Status/name" /></b></h2>
					<article>
						<div class="heading-wrapper">
							<h2>Ny status:</h2>
						</div>
						<div class="clearfix"></div>
						
						<xsl:variable name="statusID">
							<xsl:choose>
								<xsl:when test="requestparameters/parameter[name = 'statusID']/value">
									<xsl:value-of select="requestparameters/parameter[name = 'statusID']/value" />
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="FlowInstance/Status/statusID"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						
						<xsl:apply-templates select="FlowInstance/Flow/Statuses/Status[contentType != 'NEW' and contentType != 'WAITING_FOR_MULTISIGN' and contentType != 'WAITING_FOR_PAYMENT']" mode="radiobutton">
							<xsl:with-param name="selectedID" select="$statusID" />
							<xsl:with-param name="currentID" select="FlowInstance/Status/statusID" />
						</xsl:apply-templates>
						
					</article>
				</div>
				
				<div id="new-message" class="section-full bigmargintop hidden">
				
					<div class="heading-wrapper">
					
						<h2><xsl:value-of select="$i18n.NewMessage" /></h2>
						
						<xsl:apply-templates select="FlowInstance/Flow" mode="messageTemplates">
							<xsl:with-param name="type" select="'EXTERNAL'"/>
						</xsl:apply-templates>	
						
					</div>
					
					<div>
					
						<xsl:apply-templates select="FlowInstance/Flow" mode="externalMessage"/>
						
					</div>
					
				</div>
				
				<div id="new-note" class="section-full bigmargintop hidden">
				
					<div class="heading-wrapper">
					
						<h2><xsl:value-of select="$i18n.NewInternalMessage" /></h2>
						
						<xsl:apply-templates select="FlowInstance/Flow" mode="messageTemplates">
							<xsl:with-param name="type" select="'INTERNAL'"/>
						</xsl:apply-templates>	
						
					</div>
					
					<div>
					
						<xsl:apply-templates select="FlowInstance/Flow" mode="internalMessage" />
						
					</div>
					
				</div>

				<div class="divider"/>
				<div class="section-full">
					<article class="buttons floatright">
							<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/overview/{FlowInstance/flowInstanceID}" class="btn btn-light btn-inline"><xsl:value-of select="$i18n.Cancel"/></a>
							<input type="submit" value="{$i18n.SaveChanges}" class="btn btn-green btn-inline"/>
					</article>
				</div>

				<xsl:if test="ExternalMessageVerifyAttachedFilesModal">
				
					<xsl:call-template name="createVerifyAttachedFilesModal" />
										
				</xsl:if>
				
			</form>
			
		</section>
	
	</xsl:template>
	
	<xsl:template match="UpdateFlowInstanceStatuses">
	
		<div>
		
			<h1>
				<xsl:value-of select="$i18n.UpdateFlowInstanceStatuses.Title"/>
				<xsl:text>:&#160;</xsl:text>
				<xsl:value-of select="Flow/name"/>
			</h1>
			
			<p class="nomargin">
				<xsl:value-of select="$i18n.UpdateFlowInstanceStatuses.description.1"/>
				<xsl:text> </xsl:text>
				<strong>
					<xsl:value-of select="count(FlowInstances/flowInstanceID)"/>
				</strong>
				<xsl:text> </xsl:text>
				<xsl:value-of select="$i18n.UpdateFlowInstanceStatuses.description.2"/>
			</p>
				
			<xsl:if test="validationError[fieldName != 'externalmessage' and fieldName != 'externalmessage-attachments' and fieldName != 'internalmessage' and fieldName != 'internalmessage-attachments']">
				<div class="section-full">
					<xsl:apply-templates select="validationError[fieldName != 'externalmessage' and fieldName != 'externalmessage-attachments' and fieldName != 'internalmessage' and fieldName != 'internalmessage-attachments']"/>
				</div>
			</xsl:if>
			
			<form id="UpdateFlowInstanceStatusesForm" method="POST" action="{/Document/requestinfo/uri}" enctype="multipart/form-data" data-form-submit-progress-url="{/Document/requestinfo/contextpath}/{/Document/fullAlias}/formsubmitprogress" data-form-submit-progress-heading="{$i18n.FormSubmitProgress.UpdateStatus.Heading}" data-form-submit-progress-text="{$i18n.FormSubmitProgress.UpdateStatus.Text}">
				
				<xsl:for-each select="FlowInstances/flowInstanceID">
					<xsl:call-template name="createHiddenField">
						<xsl:with-param name="name" select="'flowInstanceID'"/>
						<xsl:with-param name="value" select="."/>
					</xsl:call-template>
				</xsl:for-each>
				
				<article class="bigmargintop">
				
					<h2>Ny status:</h2>
					
					<div class="clearfix"/>
					
					<xsl:apply-templates select="Statuses/Status[contentType != 'NEW' and contentType != 'WAITING_FOR_MULTISIGN' and contentType != 'WAITING_FOR_PAYMENT']" mode="radiobutton" >
						<xsl:with-param name="selectedID" select="requestparameters/parameter[name = 'statusID']/value" />
					</xsl:apply-templates>
					
				</article>
				
				<div id="new-message" class="bigmargintop hidden">
					
					<div class="heading-wrapper">
					
						<h2><xsl:value-of select="$i18n.NewMessage" /></h2>

						<xsl:apply-templates select="Flow" mode="messageTemplates">
							<xsl:with-param name="type" select="'EXTERNAL'"/>
						</xsl:apply-templates>						
					</div>

					<div><xsl:value-of select="$i18n.UpdateFlowInstanceStatuses.attributeText" /></div>
					
					<div>
					
						<xsl:apply-templates select="Flow" mode="externalMessage">
							<xsl:with-param name="noContactWay" select="null" />
							<xsl:with-param name="validationErrors" select="ValidationErrors/validationError" />
							<xsl:with-param name="requestparameters" select="requestparameters" />
							<xsl:with-param name="formattedMaxFileSize" select="FormattedMaxFileSize" />
							<xsl:with-param name="allowedExternalMessageFileExtensions" select="AllowedExternalMessageFileExtensions" />
						</xsl:apply-templates>
						
					</div>
					
				</div>
			
				<div id="new-note" class="bigmargintop hidden">
					
					<div class="heading-wrapper">
					
						<h2><xsl:value-of select="$i18n.NewInternalMessage" /></h2>
						
						<xsl:apply-templates select="Flow" mode="messageTemplates">
							<xsl:with-param name="type" select="'INTERNAL'"/>
						</xsl:apply-templates>						
					</div>
					
					<div>
					
						<xsl:apply-templates select="Flow" mode="internalMessage">
							<xsl:with-param name="validationErrors" select="ValidationErrors/validationError" />
							<xsl:with-param name="requestparameters" select="requestparameters" />
							<xsl:with-param name="formattedMaxFileSize" select="FormattedMaxFileSize" />
							<xsl:with-param name="allowedInternalMessageFileExtensions" select="AllowedInternalMessageFileExtensions" />
						</xsl:apply-templates>
						
					</div>
					
				</div>
			
				<div class="floatright bigmargintop">
				
					<a class="btn btn-light btn-inline marginright" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}" title="{$i18n.Back}">
						<xsl:value-of select="$i18n.Back"/>
					</a>
					<input class="btn btn-green btn-inline" type="submit" value="{$i18n.UpdateFlowInstanceStatuses.Submit}"/>
				</div>

				<xsl:if test="ExternalMessageVerifyAttachedFilesModal">

					<xsl:call-template name="createVerifyAttachedFilesModal" />				
					
				</xsl:if>
			
			</form>
		</div>
		
	</xsl:template>
	
	<xsl:template match="Status" mode="radiobutton">
	
		<xsl:param name="selectedID"/>
		<xsl:param name="currentID"/>
	
		<div class="bigmarginleft">
			<input type="radio" value="{statusID}" id="status_{statusID}" name="statusID">
				
				<xsl:if test="$selectedID = statusID">
					<xsl:attribute name="checked"/>
				</xsl:if>
				
				<xsl:if test="noAccess">
					<xsl:attribute name="disabled">disabled</xsl:attribute>
				</xsl:if>
				
				<xsl:if test="$currentID != statusID and addExternalMessage = 'true' and not(hideSendExternalMessage)">
					<xsl:attribute name="data-add-external-message">true</xsl:attribute>
					<xsl:attribute name="data-default-external-message-template-id"><xsl:value-of select="defaultExternalMessageTemplateID" /></xsl:attribute>
				</xsl:if>
				
				<xsl:if test="$currentID != statusID and addInternalMessage = 'true' and not(hideSendInternalMessage)">
					<xsl:attribute name="data-add-internal-message">true</xsl:attribute>
					<xsl:attribute name="data-default-internal-message-template-id"><xsl:value-of select="defaultInternalMessageTemplateID" /></xsl:attribute>
				</xsl:if>
				
			</input>
				
			<label class="radio" for="status_{statusID}">
			
				<xsl:if test="noAccess">
					<xsl:attribute name="class">radio disabled</xsl:attribute>
				</xsl:if>
				
				<xsl:if test="description">
					<xsl:attribute name="title"><xsl:value-of select="description" /></xsl:attribute>
					<xsl:attribute name="data-icon-after">?</xsl:attribute>
				</xsl:if>
			
				<xsl:value-of select="name"/>
			</label>
		</div>
	
	</xsl:template>
	
	<xsl:template match="AddFlowInstanceManagers">
	
		<div>
		
			<h1>
				<xsl:value-of select="$i18n.AddFlowInstanceManagers.Title"/>
				<xsl:text>:&#160;</xsl:text>
				<xsl:value-of select="FlowName"/>
			</h1>
			
			<p class="nomargin">
				<xsl:value-of select="$i18n.AddFlowInstanceManagers.description.1"/>
				<xsl:text> </xsl:text>
				<strong>
					<xsl:value-of select="count(FlowInstances/flowInstanceID)"/>
				</strong>
				<xsl:text> </xsl:text>
				<xsl:value-of select="$i18n.AddFlowInstanceManagers.description.2"/>
			</p>
			<p>
				<xsl:value-of select="$i18n.AddFlowInstanceManagers.description.extra.1"/>
			</p>
			<p>
				<xsl:value-of select="$i18n.AddFlowInstanceManagers.description.extra.2"/>
			</p>
				
			<xsl:apply-templates select="ValidationErrors/validationError" />
			
			<form method="post" action="{/Document/requestinfo/uri}">
			
			
				<xsl:for-each select="FlowInstances/flowInstanceID">
					<xsl:call-template name="createHiddenField">
						<xsl:with-param name="name" select="'flowInstanceID'"/>
						<xsl:with-param name="value" select="."/>
					</xsl:call-template>
				</xsl:for-each>
				
				<article class="bigmargintop">
					
					<div class="bigpaddingbottom">
					
						<h3>
							<xsl:value-of select="$i18n.AddFlowInstanceManagers.Options"/>
						</h3>
						
						<div class="bigmarginleft">
							<input type="checkbox" value="true" id="removeExistingManagers" name="removeExistingManagers" />
								
							<label for="removeExistingManagers">
								<xsl:value-of select="$i18n.AddFlowInstanceManagers.RemoveExistingManagers"/>
							</label>
						</div>
						
						<div class="bigmarginleft">
							<input type="checkbox" value="true" id="removeExistingManagerGroups" name="removeExistingManagerGroups" />
								
							<label for="removeExistingManagerGroups">
								<xsl:value-of select="$i18n.AddFlowInstanceManagers.RemoveExistingManagerGroups"/>
							</label>
						</div>
						
					</div>
					
					<div class="bigmargintop paddingbottom user-group-list-container"  data-search-count="{AvailableManagerGroupsCount}">
					
						<h3>
							<xsl:value-of select="$i18n.AddFlowInstanceManagers.NewManagers"/>
						</h3>
						
						<xsl:call-template name="UserList">
							<xsl:with-param name="connectorURL">
								<xsl:value-of select="/Document/requestinfo/currentURI"/>
								<xsl:text>/</xsl:text>
								<xsl:value-of select="/Document/module/alias"/>
								<xsl:text>/users</xsl:text>
								<xsl:text>/</xsl:text>
								<xsl:value-of select="FlowID"/>
								<xsl:text>/</xsl:text>
								<xsl:value-of select="FlowInstances/flowInstanceID"/>
							</xsl:with-param>
							<xsl:with-param name="name" select="'managerID'"/>
							<xsl:with-param name="document" select="/Document" />
							<xsl:with-param name="showUsername" select="true()" />
							<xsl:with-param name="searchfieldclass" select="'form-control'"/>					
						</xsl:call-template>
						
					</div>
									
					<xsl:if test="ManagerGroups or alwaysListManagerGroups">
					
						<div class="bigmargintop user-group-list-container"  data-search-count="{AvailableManagersCount}">
						
							<h3>
								<xsl:value-of select="$i18n.AddFlowInstanceManagers.NewGroups"/>
							</h3>
							
							<xsl:call-template name="GroupList">
								<xsl:with-param name="connectorURL">
									<xsl:value-of select="/Document/requestinfo/currentURI"/>
									<xsl:text>/</xsl:text>
									<xsl:value-of select="/Document/module/alias"/>
									<xsl:text>/groups</xsl:text>
									<xsl:text>/</xsl:text>
									<xsl:value-of select="FlowID"/>
								</xsl:with-param>
								<xsl:with-param name="name" select="'managerGroupID'"/>
								<xsl:with-param name="document" select="/Document" />
								<xsl:with-param name="searchfieldclass" select="'form-control'"/>
							</xsl:call-template>
						
						</div>
						
					</xsl:if>
					
				</article>
			
				<div class="floatright bigmargintop">
				
					<a class="btn btn-light btn-inline marginright" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}" title="{$i18n.Back}">
						<xsl:value-of select="$i18n.Back"/>
					</a>
					<script>
						function updateManagerHandler(event) {
							event.stopPropagation();
							var removeExistingManagers = $("#removeExistingManagers").is(':checked');
							var removeExistingManagerGroups = $("#removeExistingManagerGroups").is(':checked');
							if(removeExistingManagers &amp;&amp; removeExistingManagerGroups) {
								return confirm('<xsl:value-of select="$i18n.cancelConfirmUserUpdate"/>? <xsl:value-of select="$i18n.cancelConfirmManagerAndManagerGroups"/>');
							} else if($("#removeExistingManagers").is(':checked')) {
								return confirm('<xsl:value-of select="$i18n.cancelConfirmUserUpdate"/>? <xsl:value-of select="$i18n.cancelConfirmManagers"/>');
							} else if($("#removeExistingManagerGroups").is(':checked')) {
								return confirm('<xsl:value-of select="$i18n.cancelConfirmUserUpdate"/>? <xsl:value-of select="$i18n.cancelConfirmManagerGroups"/>');
							} else {
								return confirm('<xsl:value-of select="$i18n.cancelConfirmUserUpdate"/>?');
							}
						};
					
					</script>
					<input class="btn btn-green btn-inline" type="submit" value="{$i18n.AddFlowInstanceManagers.Submit}" onclick="return updateManagerHandler(event);"/>
				</div>
			
			</form>
		</div>
		
	</xsl:template>
	
	<xsl:template name="createVerifyAttachedFilesModal">
	
		<div class="hidden">
		
			<div id="verifyAttachedFilesModal" class="contentitem">
			
				<div class="modal-content">
				
					<div class="modal-header">
						
						<h1><xsl:value-of select="$i18n.VerifyAttachedFiles" /></h1>
						
					</div>
					
					<div class="modal-body"></div>
					
					<div class="modal-buttons bigmargintop bigpaddingtop" style="text-align: right;">
					
						<a class="btn btn-light btn-inline" onclick="$.featherlight.close();"><xsl:value-of select="$i18n.Cancel" /></a>
						<a id="verifyAttachedFiles" class="btn btn-green btn-inline"><xsl:value-of select="$i18n.SubmitMessage" /></a>
						
					</div>
				
				</div>
				
			</div>
			
		</div>
	
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='MultipleFlowsSelected']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.MultipleFlowsSelected"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='MultipleFlowFamiliesSelected']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.MultipleFlowFamiliesSelected"/>
		</p>
	</xsl:template>

	<xsl:template match="validationError[messageKey='MultipleProfilesSelected']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.MultipleProfilesSelected"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='StatusNotFoundValidationError']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.StatusNotFound"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='InvalidStatusValidationError']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.InvalidStatus"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='OneOrMoreSelectedManagerUsersNotFoundError2']">
		<p class="error">
			<xsl:value-of select="$i18n.ValidationError.OneOrMoreSelectedManagerUsersNotFoundError"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[messageKey='OneOrMoreSelectedManagerGroupsNotFoundError2']">
		<p class="error">
			<xsl:value-of select="$i18n.ValidationError.OneOrMoreSelectedManagerGroupsNotFoundError"/>
		</p>
	</xsl:template>
	
	<xsl:template match="validationError[fieldName = 'managerID' and validationErrorType = 'RequiredField']">
		<p class="error">
			<xsl:value-of select="$i18n.Validation.NoManagerSelected"/>
		</p>
	</xsl:template>
	
</xsl:stylesheet>