package com.nordicpeak.flowengine.flowinstanceadmin2.flexjson;

import java.lang.reflect.Type;
import java.util.List;

import se.unlogic.standardutils.enums.Order;

import com.nordicpeak.flowengine.flowinstanceadmin2.beans.TableSettingsOrderEntry;

import flexjson.JSONException;
import flexjson.JsonNumber;
import flexjson.ObjectBinder;
import flexjson.ObjectFactory;

public class TableSettingOrderEntryObjectFactory implements ObjectFactory {

	@SuppressWarnings("rawtypes")
	@Override
	public Object instantiate(ObjectBinder context, Object value, Type targetType, Class targetClass) {

		if (value instanceof List) {

			List list = (List) value;

			if (list.size() >= 2 && list.get(0) instanceof JsonNumber && list.get(1) instanceof String) {

				JsonNumber columnIndex = (JsonNumber) list.get(0);
				String orderString = (String) list.get(1);
				Order order = null;

				if (orderString != null) {

					order = Order.valueOf(orderString.toUpperCase());
				}

				if (columnIndex != null && order != null) {

					return new TableSettingsOrderEntry(columnIndex.toInteger(), order);
				}
			}
		}

		throw new JSONException("Invalid value: " + value);
	}

}
