package com.nordicpeak.flowengine.flowinstanceadmin2.populators;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collections;

import se.unlogic.standardutils.dao.ChainedResultSetPopulator;

import com.nordicpeak.flowengine.beans.ExternalMessage;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.InternalMessage;

public class FlowInstanceChainedPopulator implements ChainedResultSetPopulator<FlowInstance> {
	
	private static final FlowInstanceChainedPopulator POPULATOR = new FlowInstanceChainedPopulator();

	public static FlowInstanceChainedPopulator getPopulator(){
		return POPULATOR;
	}

	@Override
	public void populate(FlowInstance flowInstance, ResultSet rs) throws SQLException {
		
		int externalMessageID = rs.getInt("externalMessageID");
		
		if (!rs.wasNull()) {
			
			ExternalMessage externalMessage = new ExternalMessage();
			externalMessage.setMessageID(externalMessageID);
			
			flowInstance.setExternalMessages(Collections.singletonList(externalMessage));
		}
		
		int internalMessageID = rs.getInt("internalMessageID");
		
		if (!rs.wasNull()) {
			
			InternalMessage internalMessage = new InternalMessage();
			internalMessage.setMessageID(internalMessageID);
			
			flowInstance.setInternalMessages(Collections.singletonList(internalMessage));
		}
	}
	
}
