var FlowInstanceAdmin2;

var dtInternalState = {};
var dtLastSavedState = {};
// Must not start with a hidden column. Default visibility is set in columnDefinitions
var defaultColumnOrder = ["coloredTag",
                          "events",
                          "select",
                          "extend", 
                          "instanceID",
                          "externalID",
                          "status",
                          "submitted",
                          "poster",
                          "flowName",
                          "version",
                          "description",
                          "category",
                          "siteProfile",
                          "managers",
                          "flowID",
                          "familyID",
                          "overviewURL",
                          "searchExtra"];
var columnDefinitions;
var userControlledColumns = [];
var userColumnOrder = [];
var userColumnVisible = {};
var openMode;
var managerDisplayMode;
var dateInterval;
var fromDate;
var toDate;



$(function() {

	

	if (FlowInstanceAdmin2 != undefined) {
		
		$("#table-settings-modal").find(".setting").each(function() {
			var setting = $(this);
			
			userControlledColumns.push(setting.find(".columnid").val());
		});
		
		var profiles = $("#profiles");
		
		columnDefinitions = [
			{ name: "instanceID" },
			{ name: "flowID", orderable: false, visible: false, searchable: false },
			{ name: "familyID", orderable: false, visible: false, searchable: false },
			{ name: "status", render: $.fn.dataTable.render.text()},
			{ name: "flowName", render: $.fn.dataTable.render.text()},
			{ name: "version", visible: false },
			{ name: "category", visible: false },
			{ name: "submitted" },
			{ name: "poster", render: $.fn.dataTable.render.text()},
			{ name: "managers", render: $.fn.dataTable.render.text()},
			{ name: "events", orderable: false, searchable: false, className: "events",
				render: function(data, type, row) {
				
					if (type == "display") {
				
						if (data != null) {
						
							var response = "";
							
							if (data.indexOf("b") !== -1) {
								response += '<span data-icon-before="*" />';
							}
							
							if (data.indexOf("m") !== -1) {
								response += '<span data-icon-before="M" />';
							}
							
							if (data.indexOf("i") !== -1) {
								response += '<span data-icon-before="i" />';
							}
							
							return response;
							
						} else {
						
							return "";
						}
					}
					
					return null;
				}
			},
			{ name: "siteProfile", visible: false,
				render: function(data, type, row) {
					
					if (type == "display" || type == "filter") {
				
						if (data != null) {
						
							return profiles.find("[data-profileid='" + data + "']").text();
							
						} else {
						
							return "";
						}
					}
					
					if (typeof data !== 'number') { // !Number.isInteger
						
						return parseInt(data);
					}
					
					return data;
				}
			},
			{ name: "description", render: $.fn.dataTable.render.text() },
			{ name: "externalID", visible: false, render: $.fn.dataTable.render.text() },
			{ name: "searchExtra", orderable: false, visible: false },
			{ name: "overviewURL", orderable: false, visible: false },
			{ name: "coloredTag", className: "colored-tag",	orderable: false,
				render: function(data, type, row) {
					
					if (data && data.hexColor && type === "display") {
						
						return $("<div/>").addClass("colored-tag-square").css("background-color", data.hexColor).prop("outerHTML");
					}
						
					if (!data || type === "display") {
						
						return "";
					}

					return data.tagID;
				},
				createdCell: function(cell, cellData, rowData, rowIndex, colIndex) {
					
					if (cellData.hexColor) {
						
						$(cell).css({
							"border-left": "7px solid " + cellData.hexColor,
							"border-right": "7px solid " + cellData.hexColor
						});
					}
				} 
			},
			{ name: "select", className: 'select-checkbox', orderable: false, searchable: false, responsivePriority: 0, data: null, defaultContent: "" },
			{ name: "extend", className: 'control', orderable: false, searchable: false, responsivePriority: 0, data: null, defaultContent: "" },
		];
		
		var removeColumnDefinition = function(columnDefinitions, colName) {
			
			for (var i=0, len = columnDefinitions.length; i < len; i++) {
	
				if (columnDefinitions[i].name == colName) {
					
					columnDefinitions.splice(i, 1);
					break;
				}
			}
		}
		
		if (!(FlowInstanceAdmin2.enableSiteProfileColumn)) {
			removeColumnDefinition(columnDefinitions, "siteProfile");
		}
		
		if (!(FlowInstanceAdmin2.enableDescriptionColumn)) {
			removeColumnDefinition(columnDefinitions, "description");
		}
		
		if (!(FlowInstanceAdmin2.adminFlowInstanceProviders)) {
			removeColumnDefinition(columnDefinitions, "overviewURL");
		}
		
		if (FlowInstanceAdmin2.enableExternalIDColumn) {
			
			var externalIDColumnIndex = getColumnDefinitionIndex(columnDefinitions, "externalID");
			var idColumn = getColumnDefinition(columnDefinitions, "instanceID");
			
			idColumn.render = function(data, type, row) {
				
				if (type == "display" || type == "filter") {
					
					if (userColumnVisible.externalID) {
						
						return data;
					}
					
					var externalID = row[externalIDColumnIndex];
					
					if (externalID != "") {
					
						return data + " / " + externalID;
						
					} else {
						
						return data;
					}
				}
				
				if (typeof data !== 'number') { // !Number.isInteger
					
					return parseInt(data);
				}
				
				return data;
			}
			
		} else {
			
			removeColumnDefinition(columnDefinitions, "externalID");
		}
		
		[
			{selector: "#flowFilter", type: "flowName"},
			{selector: "#statusFilter", type: "status"},
			
		].forEach(function(filter){
			
			$.fn.dataTable.ext.search.push(function(settings, data, dataIndex, rowData, counter) {

				var filterValue = $(settings.nTableWrapper).find(filter.selector).val();
				
				if (!filterValue) {
					
					return true;
				}
				
				return rowData[getColumnDefinitionIndex(columnDefinitions, filter.type)].toLowerCase() == filterValue.toLowerCase();
			});
		})
		
		if (FlowInstanceAdmin2.coloredTagProvider) {
			
			$.fn.dataTable.ext.search.push(function(settings, data, dataIndex, rowData, counter) {
				
				var filterTag = $(settings.nTableWrapper).find("#coloredTagFilter").attr("data-selected-color-id");
				
				if (!filterTag) {
					
					return true;
				}
				
				var cellData = rowData[getColumnDefinitionIndex(columnDefinitions, "coloredTag")];
				
				return cellData.name + cellData.hexColor == filterTag;
			});
			
		} else {
			
			removeColumnDefinition(columnDefinitions, "coloredTag");
		}
		
		var anyTableInitialized = false;
		
		var initTable = function(panel) {
			
			// Make local copy of column definitions
			var columns = $.extend(true, [], columnDefinitions);
			
			// Apply user settings
			if (!$.isEmptyObject(userColumnVisible)) {
				
				$.each(userColumnVisible, function(key, val) {
					
					var column = getColumnDefinition(columns, key);
					
					if (column != null && column.visible != val) {
						
						column.visible = val;
					}
				});
			}
			
			var columnOrder;
			
			if (userColumnOrder.length > 0) {
				
				columnOrder = userColumnOrder.slice();
				
				// Append hidden columns
				for (var i=0, len = defaultColumnOrder.length; i < len; i++) {
					
					var colName = defaultColumnOrder[i];
					var indexInUserOrdering = columnOrder.indexOf(colName);
					
					if (indexInUserOrdering == -1) { // Is hidden column, append after its default preceeding sibling
						
						var defaultPreceedingColumnIndex = defaultColumnOrder.indexOf(colName) - 1;
						var preceedingColumnName = defaultColumnOrder[defaultPreceedingColumnIndex];
						var preceedingColumnIndex = columnOrder.indexOf(preceedingColumnName);
						
						columnOrder.splice(preceedingColumnIndex + 1, 0, colName);
					}
				}
				
			} else {
				
				columnOrder = defaultColumnOrder.slice();
			}
			
			// Go from column names to indexes. Also remove unused columns
			for (var i=0, len = columnOrder.length; i < len; i++) {
				
				var colName = columnOrder[i];
				
				var index = null;
				
				for (var j=0, len2 = columns.length; j < len2; j++) {
		
					if (columns[j].name == colName) {
						
						index = j;
						break;
					}
				}
				
				if (index == null) {
					
					columnOrder.splice(i, 1);
					len--;
					i--;
					
				} else {
					
					columnOrder[i] = index;
				}
			}
			
			if (console != undefined && columnDefinitions.length != columnOrder.length) {
				console.error("columnDefinitions length " + columnDefinitions.length + " not equal to defaultColumnOrder length " + columnOrder.length);
			}
			
			var element = $(panel).find(".flowinstance-table");
			var stealFlowInstanceButton = element.parent().find(".stealflowinstance");
			var changeStatusButton = element.parent().find(".changestatus");
			var addManagersButton = element.parent().find(".addmanagers");
			
			var table = element.DataTable({
				ajax: {
					url: element.data("url"),
					dataSrc: 'rows',
					beforeSend: function(jqXHR, settings) {
						jqXHR.setRequestHeader('NoLoginRedirect', 'true');
					},
					error: function(jqXHR, textStatus, errorThrown) {
						
						if (jqXHR.status == 403) { // Access denied
							window.location.reload();
							
						} else {
							element.find("td.dataTables_empty").text(FlowInstanceAdmin2.i18n.fetchError);
							
							if (console != undefined) {
								console.error(errorThrown);
							}
						}
					}
				},
				columns: columns,
				colReorder: {
					realtime: false,
					order: columnOrder,
					fixedColumnsLeft: 99, // Disables drag and drop reordering
				},
				deferRender: true,
				order: [[ getColumnDefinitionIndex(columns, "submitted"), 'desc' ]],
				dom: '<"toolbar-extension">frtipl',
	//			responsive: true, // If enabled here Ajax loading message is not shown
				bAutoWidth: false,
				paging: true,
				pagingType: 'simple_numbers',
				pageLength: FlowInstanceAdmin2.pageLength,
				lengthMenu: [ 15, 25, 50, 100, 250, 500, 750, 1000 ],
				select: {
					style:    'multi',
					selector: 'td.select-checkbox'
				},
				language: {
					"decimal":        FlowInstanceAdmin2.i18n.decimal,
					"emptyTable":     FlowInstanceAdmin2.i18n.emptyTable,
					"info":           FlowInstanceAdmin2.i18n.info,
					"infoEmpty":      FlowInstanceAdmin2.i18n.infoEmpty,
					"infoFiltered":   FlowInstanceAdmin2.i18n.infoFiltered,
					"infoPostFix":    FlowInstanceAdmin2.i18n.infoPostFix,
					"thousands":      FlowInstanceAdmin2.i18n.thousands,
					"lengthMenu":     FlowInstanceAdmin2.i18n.lengthMenu,
					"loadingRecords": FlowInstanceAdmin2.i18n.loadingRecords,
					"processing":     FlowInstanceAdmin2.i18n.processing,
					"search":         FlowInstanceAdmin2.i18n.search,
					"zeroRecords":    FlowInstanceAdmin2.i18n.zeroRecords,
					paginate: {
						"first":      FlowInstanceAdmin2.i18n.paginate.first,
						"last":       FlowInstanceAdmin2.i18n.paginate.last,
						"next":       FlowInstanceAdmin2.i18n.paginate.next,
						"previous":   FlowInstanceAdmin2.i18n.paginate.previous
					},
					aria: {
						"sortAscending":  FlowInstanceAdmin2.i18n.aria.sortAscending,
						"sortDescending": FlowInstanceAdmin2.i18n.aria.sortDescending
					},
					select: {
						rows: {
							_: FlowInstanceAdmin2.i18n.select.rows.many,
							0: FlowInstanceAdmin2.i18n.select.rows.none,
							1: FlowInstanceAdmin2.i18n.select.rows.one
						}
					},
				},
				stateSave: true,
				stateSaveParams: function (settings, data) {
					
//					data.start = undefined;
//					data.length = undefined;
//					data.order = undefined;
					data.search = undefined;
					data.columns = undefined;
					data.ColReorder = undefined;
				
//					data.custom = {};
	//				data.custom.filterOnMyOrders = $("#table-filtermyorders").prop("checked");
				},
				stateSaveCallback: function (settings, data) {
					
					if (!anyTableInitialized) {
						return;
					}
					
					var dataNoTime = jQuery.extend({}, data);
					delete dataNoTime.time;
					dataNoTime = JSON.stringify(dataNoTime);
					
					var lastSavedData = dtLastSavedState[element.attr("id")];
					
					if (lastSavedData != undefined && dataNoTime == lastSavedData) {
						return;
					}
					
					$.ajax({
						url: FlowInstanceAdmin2.saveSettingsURL,
						type: "POST",
						dataType: "json",
						beforeSend: function(jqXHR, settings) {
							jqXHR.setRequestHeader('NoLoginRedirect', 'true');
						},
						data: {panelID: panel.attr("id"), tableSettings: JSON.stringify(data)},
						error: function() {
							location.reload();
						}
					});
					
					dtLastSavedState[element.attr("id")] = dataNoTime
				},
				stateLoadCallback: function (settings, callback) {
					var savedSettings = FlowInstanceAdmin2.TableSettings[panel.attr("id")];
					
					if (savedSettings == undefined || savedSettings == "") {
						return null;
					}
					
					var restoredSettings;
					
					try {
						restoredSettings = JSON.parse(savedSettings);
						
					} catch (error) {
					
						if (console != undefined) {
							console.warn("Invalid table settings, using default instead. " + error);
						}
						
						return null;
					}
					
					return restoredSettings;
				},
				stateLoadParams: function (settings, data) {
					
					if (data != undefined) {
					
//						data.start = undefined;
//						data.length = undefined;
//						data.order = undefined;
						data.search = undefined;
						data.columns = undefined;
						data.ColReorder = undefined;
					}
				},
				stateLoaded: function (settings, data) {
					
//					if (data != undefined && data.custom != undefined) {
//					
//	    				if (data.custom.filterOnMyOrders) {
//
//		    				var checkbox = $("#table-filtermyorders");
//		    				checkbox.prop("checked", true);
//	    				}
//					}
				},
				preDrawCallback: function(settings) {
					
					// Remove callback
					settings.aoPreDrawCallback.splice(0, 1);
					
					settings.oClasses.sPageButton = "btn btn-inline btn-light";
				},
				initComplete: function(settings, json) {
					
					dtInternalState[element.attr("id")] = settings;
					
					var api = this.api();
					
//					applyCustomFilters(api);
					
					// Must load responsive extension after init or else the ajax loading message is not shown
					new $.fn.dataTable.Responsive(api, {
						details: {
							display: $.fn.dataTable.Responsive.display.childRow,
							type: "column",
							target: "td.control"
						}
					});
					
					createColumnFilters(element, json);

					createRefreshButton(element, json);
					
					if (panel.prop("id") == "all") {
						
						createDateFilters(element);
					}
								
					anyTableInitialized = true;
				},
			});
			
			var filterDiv = element.closest(".dataTables_wrapper").find(".dataTables_filter");
			var filterInput = filterDiv.find("input");
			var filterLabel = filterDiv.find("label"); 
			filterInput.attr("placeholder", filterLabel.text());
			filterDiv.append(filterInput);
			filterLabel.remove();
			
			table.on('click', 'tbody td', function(event) {
			
				if (event.target.nodeName == "A") {
					return;
				}
				
				if (window.getSelection) {
					var selection = window.getSelection();
					
					if (selection != null && selection.type == "Range") {
						return;
					}
				}
				
				var td = $(this);
				var tr = td.parent();
				
				//If clicked on expanded responsive row, get the main row
				if (tr.hasClass("child")) {
					
					tr = tr.prev();
				}
				
				if (tr.children("td").first().hasClass("dataTables_empty") || td.hasClass("select-checkbox") || td.hasClass("control")) {
					return;
				}
				
				var flowID = table.cell(tr, "instanceID:name").data();
				var url = FlowInstanceAdmin2.showURL + flowID;
				
				if (FlowInstanceAdmin2.adminFlowInstanceProviders) {
					
					var overviewURL = table.cell(tr, "overviewURL:name").data();
					
					if (overviewURL != "") {
						url = overviewURL;
					}
				}
				
				var target = $(event.target);
				
				if (event.target.nodeName == "SPAN" && target.data("icon-before") == "M") {
					
					url += "#messages";
				
				} else if(FlowInstanceAdmin2.useHistoryTabAsDefaultTab) {
					
					url += "#history";
				}
				
				if (openMode === "CURRENT_TAB") { 
				
					location.href = url;
					
				} else {
				
					window.open(url);
				}
			});
			
			table.on('click', 'thead th.select-checkbox', function() {
				
				var visibleRows = table.rows({ page: 'current', filter: 'applied' });
				var selectedRows = table.rows({ page: 'current', filter: 'applied', selected: true});
				
				var allVisibleSelected = selectedRows.any() && visibleRows.indexes().length == selectedRows.indexes().length;
				
				if (allVisibleSelected) {
				
					visibleRows.deselect();
				
				} else {
				
					visibleRows.select();
				}
			});
			
			var updateHeaderSelect = function() {
				
				var visibleRows = table.rows({ page: 'current', filter: 'applied' });
				var selectedRows = table.rows({ page: 'current', filter: 'applied', selected: true});
				
				var allVisibleSelected = selectedRows.any() && visibleRows.indexes().length == selectedRows.indexes().length; 
				
				element.find("thead th.select-checkbox").toggleClass("selected", allVisibleSelected);
			}
			
			var isInternalSelection = function(selectedRows) {

				if (FlowInstanceAdmin2.adminFlowInstanceProviders) {
					
					if (selectedRows == undefined) {
						selectedRows = table.rows({ selected: true });
					}
					
					if (selectedRows.any()) {
						
						var overviewURLCells = table.cells(selectedRows.toArray()[0], "overviewURL:name");
						var data = overviewURLCells.data();
						var uniqueData = data.unique();
						
						if (uniqueData.count() > 1 || data.indexOf("") == -1) {
							return false;
						}
					}
				}
				
				return true;
			}
			
			// Export for plugins
			table.isInternalSelection = isInternalSelection;
			
			var isValidAddManagerSelection = function(){
				
				var validSelection = true;
				
				var rows = table.rows({ selected: true });
				
				if (rows.any()) {
					
					var rowsArray = rows.toArray()[0];
				
					{
						var versionCells = table.cells(rowsArray, "familyID:name");
						var data = versionCells.data();
						var uniqueData = data.unique();
						
						if (uniqueData.count() > 1) {
							validSelection = false;
						}
					}
					
					if (validSelection) {
						var versionCells = table.cells(rowsArray, "siteProfile:name");
						var data = versionCells.data();
						var uniqueData = data.unique();
						
						if (uniqueData.count() > 1) {
							validSelection = false;
						}
					}
					
					if (validSelection && !isInternalSelection(rows)) {
						validSelection = false;
					}
				}
				
				return validSelection;
			}
			
			var isValidChangeStatusSelection = function() {
			
				var validSelection = true;
				
				var rows = table.rows({ selected: true });
				
				if (rows.any()) {
					
					var rowsArray = rows.toArray()[0];
				
					{
						var versionCells = table.cells(rowsArray, "flowID:name");
						var data = versionCells.data();
						var uniqueData = data.unique();
						
						if (uniqueData.count() > 1) {
							validSelection = false;
						}
					}
					
					if (validSelection) {
						var versionCells = table.cells(rowsArray, "version:name");
						var data = versionCells.data();
						var uniqueData = data.unique();
						
						if (uniqueData.count() > 1) {
							validSelection = false;
						}
					}
					
					if (validSelection && !isInternalSelection(rows)) {
						validSelection = false;
					}
				}
				
				return validSelection;
			}
			
			var updateChangeStatusButton = function(){
				
				if (isValidChangeStatusSelection()) {
				
					changeStatusButton.removeClass("disabled");
				
				} else {
				
					changeStatusButton.addClass("disabled");
				}
			}
			
			var updateChangeAddManagerButton = function(){
				
				if (isValidAddManagerSelection()) {
				
					addManagersButton.removeClass("disabled");
				
				} else {
				
					addManagersButton.addClass("disabled");
				}
			}
			
			var updateStealFlowInstanceButton = function(){
				
				if (isInternalSelection()) {
				
					stealFlowInstanceButton.removeClass("disabled");
				
				} else {
				
					stealFlowInstanceButton.addClass("disabled");
				}
			}
			
			table.on('select.dt', function() {
				updateChangeStatusButton();
				updateChangeAddManagerButton();
				updateStealFlowInstanceButton();
				updateHeaderSelect();
			});
			
			table.on('deselect.dt', function() {
				updateChangeStatusButton();
				updateChangeAddManagerButton();
				updateStealFlowInstanceButton();
				updateHeaderSelect();
			});
			
			table.on('page.dt', function() {
				updateHeaderSelect();
			});
			
			table.on('length.dt', function() {
				updateHeaderSelect();
			});
			
			var clearSelection = function(){
				var rows = table.rows({ selected: true });
				rows.deselect();
				
				changeStatusButton.removeClass("disabled");
				addManagersButton.removeClass("disabled");
				stealFlowInstanceButton.removeClass("disabled");
			}
			
			table.on('search.dt', function() {
				clearSelection();
			});
			
			changeStatusButton.on("click", function() {
			
				var rows = table.rows({ selected: true });
				
				if (!rows.any()) {
	
					alert(FlowInstanceAdmin2.i18n.nothingSelected);
				
				} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !isInternalSelection(rows)) {
				
					alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
				
				} else if (!isValidChangeStatusSelection()) {
				
					alert(FlowInstanceAdmin2.i18n.multipleFlowsSelected);
				
				} else {
				
					var cells = table.cells(rows.toArray()[0], "instanceID:name");
					var selectedIDs = cells.data().toArray();
					
					submitSelection(selectedIDs, FlowInstanceAdmin2.updateStatusURL);
				}
			});
			
			addManagersButton.on("click", function() {
			
				var rows = table.rows({ selected: true });
				
				if (!rows.any()) {
	
					alert(FlowInstanceAdmin2.i18n.nothingSelected);
				
				} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !isInternalSelection(rows)) {
				
					alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
				
				} else if (!isValidAddManagerSelection()) {
				
					alert(FlowInstanceAdmin2.i18n.multipleFlowFamiliesOrProfilesSelected);
				
				} else {
				
					var cells = table.cells(rows.toArray()[0], "instanceID:name");
					var selectedIDs = cells.data().toArray();
					
					submitSelection(selectedIDs, FlowInstanceAdmin2.addManagersURL);
				}
			});
			
			stealFlowInstanceButton.on("click", function() {
				
				var rows = table.rows({ selected: true });
				
				if (!rows.any()) {
					
					alert(FlowInstanceAdmin2.i18n.nothingSelected);
					
				} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !isInternalSelection(rows)) {
				
					alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
				
				} else {
					
					var managerCells = table.cells(rows.toArray()[0], "managers:name");
					var managersCount = managerCells.data().toArray().filter(function(manager){ return manager }).length;
					
					if (managersCount && !confirm(FlowInstanceAdmin2.i18n.stealExistingManagers)) {
						
						return;
						
					} else if (!managersCount && !confirm(FlowInstanceAdmin2.i18n.steal)) {
						
						return;
					}
					
					var selectedIDs = table.cells(rows.toArray()[0], "instanceID:name").data().toArray();
					
					submitSelection(selectedIDs, FlowInstanceAdmin2.stealFlowInstanceURL);
				}
			});
			
			$(document).trigger( "initTable", {panel: $(panel), tableElement: element, table: table} );
		};
		
		var tabHeaders = $("#tabs .tabs li");
		
		if (FlowInstanceAdmin2.lastSavedTable != "") {
		
			var tabIndex = tabHeaders.find("a[href='#" + FlowInstanceAdmin2.lastSavedTable + "']").closest("li").index();
			
			if (tabIndex > 0) {
			
				$("#tabs").tabs("option", "active", tabIndex - 1);
			}
		}
		
		tabHeaders.filter(".ui-tabs-active").each(function() {
			var tabName = $(this).find("a").attr("href");
			initTable($(tabName));
		});
		
		$("#tabs").on("tabsbeforeactivate", function(event, ui) {
			
			var tab = ui.newPanel;
			var table = tab.find(".flowinstance-table");
			
			if (!table.hasClass("dataTable")) {
				
				initTable(tab);
				
			} else {
				
				$.ajax({
					url: FlowInstanceAdmin2.saveSettingsURL,
					type: "POST",
					dataType: "json",
					beforeSend: function(jqXHR, settings) {
						jqXHR.setRequestHeader('NoLoginRedirect', 'true');
					},
					data: {panelID: tab.attr("id")},
				});	
			}
		});
		
		$("#tabs").on("tabsactivate", function(event, ui) {
			
			var tab = ui.newPanel;
			var table = tab.find(".flowinstance-table");
			
			if (table.hasClass("dataTable")) {
				
				var api = table.DataTable();
				
				api.responsive.recalc();
			}
		});
	}
	
	if ($('#verifyAttachedFilesModal').length) {
		
		$('#new-message form, #UpdateFlowInstanceStatusesForm, #UpdateFlowInstanceStatusForm').on('submit', function(e){
			
			var $form = $(this);
			var $files = $form.find('ul.files');
			
			if (!$.featherlight.current() && $files.children().length) {
				
				e.stopImmediatePropagation();

				$.featherlight($('#verifyAttachedFilesModal'), {
					
					afterContent: function(){
						
						var $modal = this.$content;
						var $modalBody = $modal.find('.modal-body');
						
						$modal.removeClass('no-sections').parent().css("background", "#f5f5f5");
						$modalBody.find('div.progressbar').remove();
						$modalBody.append($files.clone());
						
						$modal.find('#verifyAttachedFiles').on("click", function(){
							
							$form.trigger("submit");
							$.featherlight.close();
						});
						
						$modalBody.find('ul.files li').each(function(){
							
							var $fileListEntry = $(this);
							
							$fileListEntry.find('a.progress').on("click", function(){
								
								$form.find('#' + $fileListEntry.prop('id') + ' a.progress').trigger("click");
								
								if ($fileListEntry.siblings().length) {
									
									$fileListEntry.remove();
									
								} else {
									
									$.featherlight.close();
								}
							});
							
							var $fileName = $fileListEntry.find('span.name');
							var $fileContainer = $fileName.parent();
							var fileList = $form.find('#' + $fileListEntry.prop('id').replace('qloader-file-', '')).prop('files');
							
							if (fileList.length) {
								
								$fileName.replaceWith(
										$('<a>', {
											'class': 'name bigmarginright',
											html: $fileName.html(),
											download: fileList[0].name,
											href: URL.createObjectURL(new Blob([fileList[0]]))
										})
								);
								
								var $fileLink = $fileContainer.children('a.name');
								
								for (var i = 1; i < fileList.length; i++) {
									
									$fileLink.after(
											$('<a>', {
												'class': 'additional-file hidden',
												download: fileList[i].name,
												href: URL.createObjectURL(new Blob([fileList[i]]))
											})
									);
								}
								
								$fileLink.on("click", function(){
									
									if (window.navigator.msSaveBlob) {
										
										Object.keys(fileList).forEach(function(i){
											
											window.navigator.msSaveBlob(fileList[i], fileList[i].name);
										});
										
										return false;
									}
									
									$(this).siblings('a.additional-file').each(function(){
										
										this.trigger("click");
									});
								});
							}
						});
					}
				});
				
				e.preventDefault();
			}
		});
	}
	
	if ($("#new-message").length > 0 || $("#new-note").length > 0) {
		
		$(".messageTemplates").on("change", function() {
			var select = $(this);
			var val = select.val();

			if (val != "") {
				select.closest("#new-message, #new-note").find("#message").val(val).trigger("keyup");
			}
		});
	}
	
	// updateStatus
	
	var $updateStatusForm = $('#UpdateFlowInstanceStatusForm, #UpdateFlowInstanceStatusesForm');
	
	if ($updateStatusForm.length) {
		
		// Messages
		
		var $newExternalMessage = $updateStatusForm.find('#new-message');
		var $externalMessageFields = $newExternalMessage.find('textarea#message, input[name="externalmessage-attachments"]');
		var $externalMessageTemplates = $newExternalMessage.find('.messageTemplates');

		var $newInternalMessage = $updateStatusForm.find('#new-note');
		var $internalMessageFields = $newInternalMessage.find('textarea#message, input[name="internalmessage-attachments"]');
		var $internalMessageTemplates = $newInternalMessage.find('.messageTemplates');
		
		var $statuses = $updateStatusForm.find('input[name="statusID"]');
		
		$statuses.on("change", function(){
			
			var shouldAddExternalMessage = !!this.dataset.addExternalMessage;
			$newExternalMessage.toggle(shouldAddExternalMessage);
			$externalMessageFields.prop('disabled', !shouldAddExternalMessage);
			
			if (shouldAddExternalMessage) {
				
				var $defaultTemplate = $externalMessageTemplates.find('option[data-template-id="' + this.dataset.defaultExternalMessageTemplateId + '"]');
				
				if ($defaultTemplate.length) {
					
					$defaultTemplate.prop('selected', true).trigger("change");
					
				} else {
					
					$newExternalMessage.find('#message').val("");
					$externalMessageTemplates.prop('selectedIndex', 0)
				}
			}
			
			var shouldAddInternalMessage = !!this.dataset.addInternalMessage;
			$newInternalMessage.toggle(shouldAddInternalMessage);
			$internalMessageFields.prop('disabled', !shouldAddInternalMessage);
			
			if (shouldAddInternalMessage) {
				
				var $defaultTemplate = $internalMessageTemplates.find('option[data-template-id="' + this.dataset.defaultInternalMessageTemplateId + '"]');
				
				if ($defaultTemplate.length) {
					
					$defaultTemplate.prop('selected', true).trigger("change");
					
				} else {
					
					$newInternalMessage.find('#message').val("");
					$internalMessageTemplates.prop('selectedIndex', 0)
				}
			}
			
		})
		
		var $selectedStatus = $statuses.filter(':checked');
		
		if (!$updateStatusForm.find('div.error').length) {
			
			$selectedStatus.trigger("change");
			
		} else {
			
			var shouldAddExternalMessage = !!$selectedStatus.data('addExternalMessage');
			$newExternalMessage.toggle(shouldAddExternalMessage);
			$externalMessageFields.prop('disabled', !shouldAddExternalMessage);
			
			var shouldAddInternalMessage = !!$selectedStatus.data('addInternalMessage');
			$newInternalMessage.toggle(shouldAddInternalMessage);
			$internalMessageFields.prop('disabled', !shouldAddInternalMessage);			
		}
		
		$updateStatusForm.find("label[title]").tooltip({
			position: {
				my: "left-40 bottom-5",
				at: "right top",
				collision: "flipfit"
			},
			track: false,
			content: function () {
	          return $(this).prop('title') + "<span class=\"marker\"></span>";
	      	},
	      	show: {
	      		effect: 'none'
	      	},
	      	hide: {
	      		effect: 'none'
	      	}
		});
	}
	
	var $coloredTagSelect = $("#coloredTagSelect");
	$coloredTagSelect.find("li a").on("click", function(e){
		
		e.stopPropagation();	
		
		var tagID = this.dataset.tagId;
		var name = this.dataset.name || "";
		var hexColor = this.dataset.hexColor || "";
		var url = $coloredTagSelect.data("url") + (tagID ? "/select/" + tagID : "/clear");
		
		$coloredTagSelect.removeClass("active");
		$coloredTagSelect.find(".submenu").hide();
		
		$.ajax({
			cache: false,
			url: url,
			dataType: "text",
			contentType: "application/x-www-form-urlencoded;charset=UTF-8",
			success: function(response) {
				
				$coloredTagSelect.find(".selected-tag").toggleClass("marginleft", !!name).text(name);
				$coloredTagSelect.css("background-color", hexColor);
			}
		});
			
	});
	
	/* Change managers scripts */
	
	var MAX_SEARCH_COUNT_EMPTY_SEARCH = 100;
	
	$('#managerGroupID-search, #managerID-search').each(function(){
		
		if ($(this).closest('.user-group-list-container').data('search-count') < MAX_SEARCH_COUNT_EMPTY_SEARCH) {
			
			$(this).on('focus', function(){
				
				var searchValue = this.value === '' ? ' ' : this.value;
				
				$(this).autocomplete('search', searchValue);
				
			});
			
			$(this).on('autocompleteclose', function(){
				
				$(this).is(':focus') && $(this).autocomplete('search', ' ');
				
			});
		}
	});
	
});

function getColumnDefinition(columnDefinitions, colName) {
	
	for (var i=0, len = columnDefinitions.length; i < len; i++) {

		var column = columnDefinitions[i];
		
		if (column.name == colName) {
			
			return column;
		}
	}
	
	return null;
}

function getColumnDefinitionIndex(columnDefinitions, colName) {
	
	for (var i=0, len = columnDefinitions.length; i < len; i++) {

		var column = columnDefinitions[i];
		
		if (column.name == colName) {
			
			return i;
		}
	}
	
	return null;
}

function submitSelection(selectedIDs, url) {
	
	var form = $("#dummyForm");
	form.attr("action", url);
	form.find("input[name != 'directFromInstanceList']").remove();
	
	for (var i = 0, len = selectedIDs.length; len > i; i++) {
		
		var field = $('<input/>');
		
		field.attr("type", "hidden");
		field.attr("name", "flowInstanceID");
		field.attr("value", selectedIDs[i]);
		
		form.append(field);
	}
	
	form.trigger("submit");
}

function toggleBookmark(e, trigger, uri) {
	
	if (e.preventDefault) {
		e.preventDefault();
	}
	
	var $toolsMenu = $("#tools-menu");
	
	$.ajax({
		cache: false,
		url: uri,
		dataType: "text",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		error: function (xhr, ajaxOptions, thrownError) { },
		success: function(response) {

			var $bookmark = $toolsMenu.find("#menubookmarktext");
			var $bookmarkIcon = $("#headingbookmarkicon");
			
			if (response == 1) {
			
				$bookmark.text($bookmark.data("unbookmark"));				
				$bookmarkIcon.find("a").attr("title", $bookmark.data("unbookmark"));
				$bookmarkIcon.find("span").removeClass("inactive");
				$bookmarkIcon.find("span").addClass("active");
				
			} else if (response == 0) {
				
				$bookmark.text($bookmark.data("bookmark"));
				$bookmarkIcon.find("a").attr("title", $bookmark.data("bookmark"));
				$bookmarkIcon.find("span").removeClass("active");
				$bookmarkIcon.find("span").addClass("inactive");
			}
		}
	});
	
	return false;	
}

function applyUserColumnOrder(api) {
	
	if (userColumnOrder.length > 0) {
	
		var tableElement = $(api.table().node());
		var tableID = tableElement.attr("id");
		var dtSettings = dtInternalState[tableID];
		
		var currentColumnOrder = [];
		
		for (var i=0, len = dtSettings.aoColumns.length; i < len; i++) {
			
			currentColumnOrder[i] = dtSettings.aoColumns[i].name;
		}
		
		var columnOrder = userColumnOrder.slice();
		
		// Append hidden columns
		for (var i=0, len = currentColumnOrder.length; i < len; i++) {
			
			var colName = currentColumnOrder[i];
			var indexInUserOrdering = columnOrder.indexOf(colName);
			
			if (indexInUserOrdering == -1) { // Is hidden column, append after its default preceeding sibling
				
				var defaultPreceedingColumnIndex = defaultColumnOrder.indexOf(colName) - 1;
				var preceedingColumnName = defaultColumnOrder[defaultPreceedingColumnIndex];
				var preceedingColumnIndex = columnOrder.indexOf(preceedingColumnName);
				
				columnOrder.splice(preceedingColumnIndex + 1, 0, colName);
			}
		}
		
		if (console != undefined && dtSettings.aoColumns.length != columnOrder.length) {
			
			console.error("columnDefinitions length " + dtSettings.aoColumns.length + " not equal to columnOrder length " + columnOrder.length);
			
		} else {
		
			var orderChanged = false;
			
			// Go from column names to indexes
			for (var i=0, len = columnOrder.length; i < len; i++) {
				
				var colName = columnOrder[i];
				var order = currentColumnOrder.indexOf(colName);
				columnOrder[i] = order;
				
				if (order != i) {
					orderChanged = true;
				}
			}
			
			if (orderChanged) {
				
				var dataTables = $("#tabs .flowinstance-table.dataTable");
				var allAPI = dataTables.DataTable();
				allAPI.colReorder.order(columnOrder, false);
			}
		}
	}
}

function openTableSettingsModal(button, event) {
	event.preventDefault();
	event.stopPropagation();
	
	var modal = $("#table-settings-modal");
	var modalContainer = modal.parent();
	var dataTables = $("#tabs .flowinstance-table.dataTable");
	var currentDataTable = $("#tabs .tab:visible .flowinstance-table.dataTable");
	var dtSettings = dtInternalState[currentDataTable.attr("id")]
	
	if (!dtSettings) {
		
		//Datatable not initialized yet
		return;
	}
	
	var api = currentDataTable.DataTable();
	var allAPI = dataTables.DataTable();
	
	// Load current configuration into modal
	modal.find(".setting").each(function() {
		
		var setting = $(this);
		var settingColumnID = setting.find(".columnid").val();
		
		var column = api.column(settingColumnID + ":name");
		
		setting.find(".enable").prop("checked", column.visible());

		// Get current column order as index of user controllable columns
		var order = 0;
		for (var i=0, len = dtSettings.aoColumns.length; i < len; i++) {
			
			var colName = dtSettings.aoColumns[i].name;
			
			if (settingColumnID == colName) {
				break;
				
			} else if (userControlledColumns.indexOf(colName) != -1) {
				order++;
			}
		}
		
		setting.find(".sortorder").val(order);
	});
	
	if (openMode) {
		
		modal.find("input[name='openMode'][value=" + openMode + "]").prop("checked", true);
		
	} else {
		
		modal.find("input[name='openMode'][value='NEW_TAB']").prop("checked", true);
	}
	
	if (managerDisplayMode) {
		
		modal.find("input[name='managerDisplayMode'][value=" + managerDisplayMode + "]").prop("checked", true);
		
	} else {
		
		modal.find("input[name='managerDisplayMode'][value='FULL_NAME']").prop("checked", true);
	}
	
	modal.find(".sortable").each(function(){
		
		sortAlternativesAfterSortOrder($(this));
	});
	
	var config = {
		otherClose: '.close',
		
		afterContent: function() {
			var feather = this;
			var content = feather.$content; 
			modal.detach();
			
			content.removeClass("no-sections");
			
			content.find(".sortable").sortable({ cursor: 'move', update: function(event, ui) {
				
				updateSortOrder($(this));
			}});
			
			content.find(".save").on("click", function() {
				
				userColumnOrder = [];
				userColumnVisible = {};
				
				content.find(".setting").each(function() {
					var setting = $(this);
					
					var columnID = setting.find(".columnid").val();
					var enabled = setting.find(".enable").prop("checked");
					var sortOrder = setting.find(".sortorder").val();
					
					userColumnOrder[sortOrder] = columnID;
					userColumnVisible[columnID] = enabled;
				});
				
				openMode = content.find("input[name ='openMode']:checked").val();
				managerDisplayMode = content.find("input[name ='managerDisplayMode']:checked").val();
				
				$.each(userColumnVisible, function(key, val) {
					
					var column = api.column(key + ":name");
					
					if (column.visible() != val) {
						
//						column.visible(val, false);
						allAPI.columns(key + ":name").visible(val, false);
					}
				});
				
				applyUserColumnOrder(api);
				
				$.ajax({
					url: FlowInstanceAdmin2.saveSettingsURL,
					type: "POST",
					data: {columnOrder: JSON.stringify(userColumnOrder), columnVisibility: JSON.stringify(userColumnVisible), openMode:openMode, managerDisplayMode:managerDisplayMode},
				});
				
				allAPI.ajax.reload();
				
				feather.close();
			});
			
			content.find(".reset").on("click", function() {
				
				content.find(".setting").each(function() {
					var setting = $(this);
					
					var columnID = setting.find(".columnid").val();
					
					var defaultSortOrder = 0;
					$.each(defaultColumnOrder, function(index, value) {
						
						if (columnID == value) {
							return false;
						}
						
						if (userControlledColumns.indexOf(value) != -1) {
							defaultSortOrder++
						}
					});
					
					setting.find(".sortorder").val(defaultSortOrder);
					
					var columnDef = getColumnDefinition(columnDefinitions, columnID);
					
					if (columnDef.visible != undefined) {
						
						setting.find(".enable").prop("checked", columnDef.visible);
						
					} else {
						
						setting.find(".enable").prop("checked", true);
					}
				});
				
				content.find(".sortable").each(function() {
					
					sortAlternativesAfterSortOrder($(this));
				});
				
				content.find("#openModeNewTab").prop("checked", true);
				content.find("#openModeSameTab").prop("checked", false);
				
				content.find("#managerDisplayModeFullName").prop("checked", true);
				content.find("#managerDisplayModeUsername").prop("checked", false);
			});
		},
		
		beforeClose: function() {
			var feather = this;
			
			modalContainer.append(modal);
		},
	};
	
	$.featherlight(modal, config);
}

function updateSortOrder(alternativesContainer) {
	
	alternativesContainer.children().each(function(i) {
		var alternative = $(this);
		alternative.find("input.sortorder").val(i);
	});
}

function sortAlternativesAfterSortOrder(alternativesContainer) {
	
	alternativesContainer.children().sort(function(a, b) {
		
		return parseInt($(a).find('input[type="hidden"].sortorder').val()) - parseInt($(b).find('input[type="hidden"].sortorder').val());
		
	}).appendTo(alternativesContainer);
}

function createRefreshButton($tableElement, json) {
	
	var $filterWrapper = $tableElement.closest(".dataTables_wrapper").find(".dataTables_filter");
	var tabType = $tableElement.prop("id").replace("flowinstances-", "");
	var $tab = $tableElement.closest("#tabs").find("li > a[href='#" + tabType + "']")
	var tabText = $tab.find(".tab-text").text();
	var $reloadIcon = $('<img id="reloadTable" title="' + FlowInstanceAdmin2.i18n.reloadTab + ' ' + tabText + '" class="icon reload floatleft" src="' + FlowInstanceAdmin2.imgPath + '/reload.png"/>');
	var $spinnerWrapper = $tab.find(".spinner-wrapper");
	
	$filterWrapper.prepend($reloadIcon);
	
	$reloadIcon.on("click", function(){
		
		refreshTab($tableElement, $spinnerWrapper);
	});
}

function refreshTab($tableElement, $spinnerWrapper) {
	
	var table = $tableElement.DataTable();

	if ($spinnerWrapper.hasClass("spinning")) {
		
		return;
	}
	
	$spinnerWrapper.addClass("spinning");
	
	if ($spinnerWrapper.hasClass("flow-instance-count")) {
		
		$spinnerWrapper.html("");
	}
	
	table.ajax.reload(function(json){
		
		if ($spinnerWrapper.hasClass("flow-instance-count")) {
			
			$spinnerWrapper.html(json.rows.length);
		}
		
		createColumnFilters($tableElement, json);
		
		$spinnerWrapper.removeClass("spinning");
	});
}

function createColumnFilters($tableElement, json) {

	var table = $tableElement.DataTable();
	var $toolbarExtension = $tableElement.closest(".dataTables_wrapper").find(".toolbar-extension");
	var searchValue = table.search();

	var $filterWrapper = $toolbarExtension.find(".column-filters");
	if (!$filterWrapper.length) {
		
		$filterWrapper = $("<div/>").addClass("column-filters").appendTo($toolbarExtension);
	}
	
	var selectedStatus;
	var $oldStatusFilter = $filterWrapper.find("#statusFilter");
	if ($oldStatusFilter.length) {
		
		selectedStatus = $oldStatusFilter.triggerHandler("getSelectedEntry");
		$oldStatusFilter.remove();
	}
	
	var selectedFlow;
	var $oldFlowFilter = $filterWrapper.find("#flowFilter");
	if ($oldFlowFilter.length) {
		
		selectedFlow = $oldFlowFilter.triggerHandler("getSelectedEntry");
		$oldFlowFilter.remove();
	}
	
	var selectedColoredTag;
	if (FlowInstanceAdmin2.coloredTagProvider) {

		var $oldColoredTagFilter = $filterWrapper.find("#coloredTagFilter");
		
		if ($oldColoredTagFilter.length) {
			
			selectedColoredTag = $oldColoredTagFilter.triggerHandler("getSelectedEntry");
			$oldColoredTagFilter.remove();
		}
	}	

	var anyOldFilterValue = !!(searchValue || selectedStatus || selectedFlow || selectedColoredTag);
	
	if (anyOldFilterValue) {
		
		table.search("");
	}
	
	var $coloredTagFilter;
	if (FlowInstanceAdmin2.coloredTagProvider) {

		$coloredTagFilter = createColumnFilter(
			table,
			$filterWrapper,
			json,
			$("#coloredTagFilter-template"), 
			"coloredTag",
			//addEntryCallback
			function(entries, newEntry) {
				
				for (var i = 0; i < entries.length; i++) {
					
					var entry = entries[i];
					
					if (entry.name === newEntry.name && entry.hexColor === newEntry.hexColor) {
						
						return;
					}
				}
				
				entries.push(newEntry);
			},
			//sortEntriesCallback
			function(a, b) {
				return a.name.toLowerCase().localeCompare(b.name.toLowerCase());
			},
			//appendFilterElementCallback
			function($filter, tag) {
				
				var $entry = $filter.find("li:first-child").clone();
				var $link = $entry.find("a");
				
				$entry.addClass("column-filter-entry");

				$link.attr({
					"data-color-id": tag.name + tag.hexColor,
					"data-name": tag.name,
					"data-hex-color": tag.hexColor
				});
				
				$link.find("span").text(tag.name);
				$link.find("div").css("background-color", tag.hexColor);
				
				$filter.find("ul").append($entry);
			},
			//createFilterListenerCallback
			function($filter, table, $filterWrapper, updateOtherFiltersCallback) {
				
				$filter.on("click", "li a", function(e) {
					
					e.stopPropagation();	
					
					$filter.trigger("selectEntry", $(this).attr("data-color-id"));
					
					updateOtherFiltersCallback($filter, $filterWrapper, table);
					
					table.draw();
				});
			},
			//entriesContainsCallback
			function(entries, filterEntry) {
				
				var colorID = $(filterEntry).find("a").attr("data-color-id");

				for (var i = 0; i < entries.length; i++) {
					
					var entry = entries[i];
					
					if (entry.name + entry.hexColor == colorID) {
						
						return true;
					}
				}
				
				return false;
			},
			//getSelectedEntryCallback
			function() {
				
				return $(this).attr("data-selected-color-id");
			},
			//selectEntryCallback
			function(colorID) {
				 
				var $filter = $(this);
				var $link = $filter.find("a[data-color-id='" + colorID + "']")
				
				$filter.attr("data-selected-color-id", $link.length ? colorID : "");
				$filter.find("#selectedTag").text($link.attr("data-name"));
				$filter.find("#selectedColor").css("background-color", $link.attr("data-hex-color"));
				
				$filter.removeClass("active");
				$filter.find(".submenu").hide();
			}
		);
	}
	
	var $flowFilter = createColumnFilter(table, $filterWrapper, json, $("#flowFilter-template"), "flowName");
	var $statusFilter = createColumnFilter(table, $filterWrapper, json, $("#statusFilter-template"), "status");
	
	if ($coloredTagFilter && selectedColoredTag) {
		
		$coloredTagFilter.trigger("selectEntry", selectedColoredTag);
		updateOtherFilters($coloredTagFilter, $filterWrapper, table);
	}
	
	if (selectedFlow) {
		
		$flowFilter.trigger("selectEntry", selectedFlow);
		updateOtherFilters($flowFilter, $filterWrapper, table);
	}
	
	if (selectedStatus) {
		
		$statusFilter.trigger("selectEntry", selectedStatus);
		updateOtherFilters($statusFilter, $filterWrapper, table);
	}
	
	if (anyOldFilterValue) {
		
		table.search(searchValue);
		table.draw();
	}
}

function createColumnFilter(table, $filterWrapper, json, $filterTemplate, columnName, addEntryCallback, sortEntriesCallback, appendFilterElementCallback, createFilterListenerCallback, entriesContainsCallback, getSelectedEntryCallback, selectEntryCallback) {

	var $filter = $filterTemplate.clone(true);
	
	var findInList = (function(list, value) {
		for (var i = 0; i < list.length; i++) {
			var listEntry = list[i];
			
			if (listEntry.toLowerCase() === value.toLowerCase()) {
				return listEntry;
			}
		}
		
		return undefined;
	});
	
	$filter.on("entriesContains", function(event, entries, filterEntry) {
		
		if (entriesContainsCallback) {
			
			return entriesContainsCallback.call(this, entries, filterEntry);
		}
		
		return findInList(entries, filterEntry.value);
	});
	
	$filter.on("getSelectedEntry", function() {
		
		if (getSelectedEntryCallback) {
			
			return getSelectedEntryCallback.call(this);
			
		}
			
		return this.value;
	});
	
	$filter.on("selectEntry", function(event, entry) {

		if (selectEntryCallback) {
			
			selectEntryCallback.call(this, entry);
			
		} else {
			
			if ($(this).find("option[value='" + entry + "']").length) {
				
				this.value = entry;
				
			} else {
				
				this.value = "";
			}
		}
	});
	
	$filter.on("addEntry", function(event, entries, data) {
		
		if (addEntryCallback) {
			
			addEntryCallback.call(this, entries, data);
			
		} else if (findInList(entries, data.toString()) === undefined) {
				
			entries.push(data.toString());
		}
	});
	
	$filter.prop("id", $filter.prop("id").split("-template")[0]);
	
	var entries = getFilterEntries(table, $filter, columnName);
	
	if (entries.length) {
		
		entries.sort(function(a, b){
			
			return sortEntriesCallback ? sortEntriesCallback(a, b) : a.toLowerCase().localeCompare(b.toLowerCase());
		});
		
		for (var key in entries) {
			
			var value = entries[key];
			
			if (appendFilterElementCallback) {
				
				appendFilterElementCallback($filter, value);
				
			} else {
				
				$filter.append('<option class="column-filter-entry" value="' + value.replace(/"/g, "&quot;") + '">' + value + "</option>");
			}
		}
		
		$filter.data("allEntries", $filter.find(".column-filter-entry"));
		
		if (createFilterListenerCallback) {
			
			createFilterListenerCallback($filter, table, $filterWrapper, updateOtherFilters);
			
		} else {
			
			$filter.on("change", function(){
				
				var $changedFilter = $(this);
				
				$(table.table().container()).find("#flowinstances-all_filter > input").val("");
				
				updateOtherFilters($changedFilter, $filterWrapper, table);
				
				table.draw();
			});
		}
		
		$filterWrapper.append($filter);
	}
	
	return $filter;
}

function updateOtherFilters($changedFilter, $filterWrapper, table) {
	
	$filterWrapper.find(".column-filter").not($changedFilter).each(function(){
		
		var $otherFilter = $(this);
			
		if ($changedFilter.data("type") == $otherFilter.data("parent-type")) {
			
			var parentFilterHasSelectedValue = !!$changedFilter.val();
			
			$otherFilter.toggleClass("hidden", !parentFilterHasSelectedValue);
			
			if (!parentFilterHasSelectedValue) {

				$otherFilter.val("");
				
				updateOtherFilters($otherFilter, $filterWrapper, table);
				
				return;
			}
		}
		
		var selectedValue = $otherFilter.triggerHandler("getSelectedEntry");

		$otherFilter.trigger("selectEntry", "");
		
		table.search("");

		var entries = getFilterEntries(table, $otherFilter, $otherFilter.data("type"));
		
		$otherFilter.find(".column-filter-entry").remove();

		var $rowFilterEntryContainer = $otherFilter.find(".column-filter-entry-container");

		if (!$rowFilterEntryContainer.length) {
			
			$rowFilterEntryContainer = $otherFilter;
		}
		
		$rowFilterEntryContainer.append($otherFilter.data("allEntries"));

		$otherFilter.find(".column-filter-entry").each(function(){
			
			if (!$otherFilter.triggerHandler("entriesContains", [entries, this])) {
				
				$(this).remove();
			}
		});

		$otherFilter.trigger("selectEntry", selectedValue);
	});
}

function getFilterEntries(table, $filter, columnName) {
	
	var dataIndex = getColumnDefinitionIndex(columnDefinitions, columnName);
	
	var entries = []; 
	
	table.rows( { search: 'applied' } ).data().each(function(row){
		
		var data = row[dataIndex];
		
		if (!data) {
			
			return;
		}
		
		if (typeof data === "object") {
			
			data = $.extend({}, data);
		}
		
		$filter.trigger("addEntry", [entries, data]);
	});
	
	return entries;
}

function createDateFilters($tableElement) {

	var tabType = $tableElement.prop("id").replace("flowinstances-", "");
	var $tab = $tableElement.closest("#tabs").find("li > a[href='#" + tabType + "']")
	var $spinnerWrapper = $tab.find(".spinner-wrapper");
	var $filterWrapper = $tableElement.closest(".dataTables_wrapper").find(".dataTables_filter");

	var $dateFilter = $("#dateFilter-template").clone().appendTo($filterWrapper);
	
	$dateFilter.prop("id", $dateFilter.prop("id").split("-template")[0]);
	
	if (dateInterval == "CUSTOM") {
		
		createCustomOption().appendTo($dateFilter);
	}

	$dateFilter.val(dateInterval);
	
	$dateFilter.on("change", function(e) {
		
		var selectedDateInterval = this.value;

		if (selectedDateInterval == "SELECT_CUSTOM") {
			
			this.value = dateInterval; //reset in case window is closed

			var $customDateIntervalContainer = createCustomDateIntervalModal();

			$.featherlight($customDateIntervalContainer, {
				"afterContent": function() {

					var featherlight = this;
					var $modal = featherlight.$content;
					var $modalContent = $modal.closest(".featherlight-content").addClass("contentitem date-filter-modal-content");
					$modal.closest(".featherlight").addClass("date-filter-modal");

					if (!Modernizr.inputtypes.date) {

						["fromDate", "toDate"].forEach(function(name) {

							$modal.find("input[name='" + name + "']").datepicker({
								showOn: "button",
								buttonImage: FlowInstanceAdmin2.imgPath + '/calendar_grid.png',
								buttonImageOnly: true,
								changeMonth: true,
								changeYear: true,
								showWeek: true,
								dateFormat: 'yy-mm-dd'
							});
						});
					}

					$modal.find(".save").on("click", function() {

						var selectedFromDate = $modal.find("input[name='fromDate']").val();
						var selectedToDate = $modal.find("input[name='toDate']").val();
						
						if (!selectedFromDate && !selectedToDate) {
							$modal.find("#info").text(FlowInstanceAdmin2.i18n.dateNotSet);
							return;
						}
						
						dateInterval = "CUSTOM";
						fromDate = selectedFromDate;
						toDate = selectedToDate;
						
						if(!testDateFormat(fromDate) || !testDateFormat(toDate)) {
							$modal.find("#info").text(FlowInstanceAdmin2.i18n.dateFormat);
							return;
						}

						$.ajax({
							url: FlowInstanceAdmin2.saveSettingsURL,
							type: "POST",
							dataType: "json",
							beforeSend: function(jqXHR, settings) {
								jqXHR.setRequestHeader('NoLoginRedirect', 'true');
							},
							data: {
								dateInterval: dateInterval,
								fromDate: fromDate,
								toDate: toDate
							},
							complete: function() {
								
								refreshTab($tableElement, $spinnerWrapper);

								$dateFilter.find("option[value='CUSTOM']").remove();

								createCustomOption().prop("selected", true).appendTo($dateFilter);
								
								featherlight.close();
							}
						});
					});
				}
			}).$content;

		} else {
			
			fromDate = null;
			toDate = null;
			dateInterval = selectedDateInterval;

			$.ajax({
				url: FlowInstanceAdmin2.saveSettingsURL,
				type: "POST",
				dataType: "json",
				beforeSend: function(jqXHR, settings) {
					jqXHR.setRequestHeader('NoLoginRedirect', 'true');
				},
				data: {
					dateInterval: dateInterval
				},
				complete: function() {

					refreshTab($tableElement, $spinnerWrapper);
					
					$dateFilter.find("option[value='CUSTOM']").remove();
				}
			});
		}
	});
}

function testDateFormat(date) {
	if(!date) {
		return true;
	}
	
	if(date.length<10) {
		return false;
	}
	
	return date.match(/^\d{4}-(0[1-9]|1[0-2])-(0[1-9]|[12][0-9]|3[01])$/);
}

function createCustomDateIntervalModal() {

	var $customDateIntervalContainer = $("<div/>");

	$("<h2/>").text(FlowInstanceAdmin2.i18n.customInterval).appendTo($customDateIntervalContainer);
	$("<p id='info' class='font_red'/>").text('').appendTo($customDateIntervalContainer);

	createDateFilter("fromDate", FlowInstanceAdmin2.i18n.fromDate, fromDate).appendTo($customDateIntervalContainer);
	createDateFilter("toDate", FlowInstanceAdmin2.i18n.toDate, toDate).appendTo($customDateIntervalContainer);

	$("<input/>", {
		"type": "button",
		"value": FlowInstanceAdmin2.i18n.saveDate,
		"class": "save btn btn-blue floatright"
	}).appendTo($customDateIntervalContainer);

	return $customDateIntervalContainer;
}

function createDateFilter(name, label, value) {

	var $dateFilterWrapper = $("<div/>", {
		"class": "date-filter"
	});

	$("<label/>", {
		"for": name
	}).text(label).appendTo($dateFilterWrapper);

	$("<input/>", {
		"type": "date",
		"name": name,
		"max" : "9999-12-31",
	}).val(value).appendTo($("<div/>").appendTo($dateFilterWrapper));

	return $dateFilterWrapper;
}

function createCustomOption() {
	
	var text;
	
	if (fromDate && toDate) {
		
		text = fromDate + " - " + toDate;
		
	} else if (fromDate) {
		
		text = FlowInstanceAdmin2.i18n.fromDate + " " + fromDate;
		
	} else if (toDate) {
		
		text = FlowInstanceAdmin2.i18n.toDate + " " + toDate;
	}
	
	return $("<option/>")
		.text(text)
		.val("CUSTOM");
}
