package com.nordicpeak.flowengine.flowinstanceadmin2.sendmessages;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

@XMLElement(name = "Status")
public class StatusCounts extends GeneratedElementable implements Comparable<StatusCounts> {
	
	@XMLElement(fixCase = true)
	public String name;
	
	@XMLElement(fixCase = true)
	public int flowInstanceCount;
	
	@XMLElement(fixCase = true)
	public Integer flowInstanceCountMultiSignNotSigned;
	
	@XMLElement(fixCase = true)
	public Integer flowInstanceCountMultiSignSigned;
	
	@XMLElement
	public int sortIndex;

	@Override
	public int compareTo(StatusCounts o) {
		int diff = sortIndex - o.sortIndex;
		
		if (diff == 0) {
			return name.compareTo(o.name);
		}
		
		return diff;
	}

	@Override
	public Element toXML(Document doc) {
		Element element =  super.toXML(doc);
		
		if (flowInstanceCountMultiSignNotSigned != null) {
			XMLUtils.appendNewElement(doc, element, "Multisigning");
		}
		
		return element;
	}

	@Override
	public String toString() {
		return getClass().getSimpleName() + " (name=" + name + ", flowInstanceCount=" + flowInstanceCount + ", flowInstanceCountMultiSignNotSigned=" + flowInstanceCountMultiSignNotSigned + ", flowInstanceCountMultiSignSigned=" + flowInstanceCountMultiSignSigned + ", sortIndex=" + sortIndex + ")";
	}
	
}
