package com.nordicpeak.flowengine.flowlistextension.beans;

import java.io.Serializable;

import se.unlogic.standardutils.annotations.RequiredIfSet;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.webutils.populators.StringHTTPURLPopulator;

@Table(name = "flowengine_flow_family_listextension_settings")
@XMLElement
public class FlowListExtensionSettings extends GeneratedElementable  implements Serializable{

	private static final long serialVersionUID = -7196741621029300739L;

	@DAOManaged
	@XMLElement
	@Key
	private Integer flowFamilyID;

	@WebPopulate
	@DAOManaged
	@XMLElement
	private boolean moduleEnabled;
	
	@WebPopulate(maxLength = 255, populator = StringHTTPURLPopulator.class)
	@DAOManaged
	@XMLElement
	@RequiredIfSet(paramNames = "externalLinkEnabled")
	private String externalLink;
	
	@WebPopulate(maxLength = 255)
	@DAOManaged
	@XMLElement
	private String customName;

	
	public Integer getFlowFamilyID() {
	
		return flowFamilyID;
	}

	
	public void setFlowFamilyID(Integer flowFamilyID) {
	
		this.flowFamilyID = flowFamilyID;
	}

	
	public boolean isModuleEnabled() {
	
		return moduleEnabled;
	}

	
	public void setModuleEnabled(boolean moduleEnabled) {
	
		this.moduleEnabled = moduleEnabled;
	}
	
	public String getExternalLink() {
	
		return externalLink;
	}

	
	public void setExternalLink(String externalLink) {
	
		this.externalLink = externalLink;
	}


	
	public String getCustomName() {
	
		return customName;
	}


	
	public void setCustomName(String customName) {
	
		this.customName = customName;
	}


	@Override
	public String toString() {

		return "FlowListExtensionSettings [flowFamilyID=" + flowFamilyID + ", moduleEnabled=" + moduleEnabled + ", externalLink=" + externalLink + "]";
	}
	
	
	
	
}