package com.nordicpeak.flowengine.voting;

import java.util.Collection;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.standardutils.rss.RSSChannel;
import se.unlogic.webutils.http.RequestUtils;

public class FlowFamilyVoteRSSChannel implements RSSChannel {

	private FlowFamilyVoteSettings setting;
	
	private Integer feedTTL;
	
	private String feedLanguage;
	
	private String link;
	
	private String feedLink;
	
	public FlowFamilyVoteRSSChannel(FlowFamilyVoteSettings setting, FlowVoteModule voteModule, HttpServletRequest req) {

		this.setting = setting;
		this.feedTTL = voteModule.getFeedTTL();
		this.feedLanguage = voteModule.getFeedLanguage();
		
		String baseURL = RequestUtils.getFullContextPathURL(req) + voteModule.getFullAlias();
		
		this.link = baseURL + "/rss/" + setting.getAlias();
		this.feedLink = baseURL + "/feed/" + setting.getAlias();
	}
	
	@Override
	public Date getPubDate() {

		return new Date();
	}

	@Override
	public Date getLastBuildDate() {
		
		return new Date();
	}

	@Override
	public Integer getTtl() {
		
		return feedTTL;
	}

	@Override
	public String getLanguage() {
		
		return feedLanguage;
	}

	@Override
	public String getCopyright() {
		
		return null;
	}

	@Override
	public String getWebmaster() {
		
		return null;
	}

	@Override
	public String getManagingEditor() {
		
		return null;
	}

	@Override
	public Integer getItemsPerChannel() {

		return null;
	}

	@Override
	public String getLink() {

		return link;
	}

	@Override
	public String getDescription() {

		return setting.getDescription();
	}

	@Override
	public String getTitle() {

		return setting.getTitle();
	}

	@Override
	public Collection<String> getCategories() {

		return null;
	}

	@Override
	public String getFeedLink() {
		
		return feedLink;
	}

}
