$(function() {

	 $("#votingActivated").on("change", function() {
		 
		 var $votingDays = $("#votingDays");
		 var $requiredVotes = $("#requiredVotes");
		 var $votePassedStatus = $("#votePassedStatus");
		 var $voteFailedStatus = $("#voteFailedStatus");
		 var $votingStatusLable = $("#votingStatusLable");
		 var $publishStatusLable = $("#publishStatusLable");
		 
		 if($(this).prop("checked")) {
			 
			 $votingDays.removeAttr("disabled").parent().parent().show();
			 $requiredVotes.removeAttr("disabled").parent().parent().show();
			 $votePassedStatus.removeAttr("disabled").parent().parent().show();
			 $voteFailedStatus.removeAttr("disabled").parent().parent().show();
			 $votingStatusLable.show();
			 $publishStatusLable.hide();
			 
		 } else {
			 
			 $votingDays.attr("disabled", "disabled").parent().parent().hide();
			 $requiredVotes.attr("disabled", "disabled").parent().parent().hide();
			 $votePassedStatus.attr("disabled", "disabled").parent().parent().hide();
			 $voteFailedStatus.attr("disabled", "disabled").parent().parent().hide();
			 $votingStatusLable.hide();
			 $publishStatusLable.show();
		 }
	 });

	 $("#additionalAttributes").on("change", function() {
		
		 if($(this).prop("checked")) {
			 
			 $("#extraAttributeContainer").show();
			 $("#extraAttributeContainer :input").removeAttr("disabled");
			 
			 
		 } else {
			
			 $("#extraAttributeContainer").hide();
			 $("#extraAttributeContainer :input").attr("disabled", "disabled");
		 }
	 });

	 $("#published-statuses-list").each(function(j){
		 var list = $(this);
		 var prefix = "published-statuses";
		 var url = list.find("input[name='connectorURL']").val();
		 
		 var searchInput = $( "#" + prefix + "-search");
		 
		 searchInput.autocomplete({
		 	source: function(request, response) {
		 		return searchFlows(request, response, url, searchInput);
			},
			select: function( event, ui ) {
				
				addPublishedEntry(ui.item, list, prefix);
				
				searchInput.val("");
				
				return false;
			},
			focus: function(event, ui) {
		        event.preventDefault();
		    }
		 });
		 
		 var template = getTemplate(prefix);
		 template.find("input").prop("disabled", true);
	 });
	 
	 $("#archived-statuses-list").each(function(j){
		 var list = $(this);
		 var prefix = "archived-statuses";
		 var url = list.find("input[name='connectorURL']").val();
		 
		 var searchInput = $( "#" + prefix + "-search");
		 
		 searchInput.autocomplete({
		 	source: function(request, response) {
		 		return searchFlows(request, response, url, searchInput);
			},
			select: function( event, ui ) {
				
				addArchivedEntry(ui.item, list, prefix);
				
				searchInput.val("");
				
				return false;
			},
			focus: function(event, ui) {
		        event.preventDefault();
		    }
		 });
		 
		 var template = getTemplate(prefix);
		 template.find("input").prop("disabled", true);
	 });
	 
	 $("#votePassedStatus, #voteFailedStatus").each(function(j){
		 var searchInput = $(this);
		 var url = $("input[name='connectorURL']").val();
		 
		 searchInput.autocomplete({
		 	source: function(request, response) {
		 		return searchFlows(request, response, url, searchInput);
			},
			select: function( event, ui ) {
				
				searchInput.val(ui.item.value);
				return false;
			},
			focus: function(event, ui) {
		        event.preventDefault();
		    }
		 });
	 });
	 
	 $("#votingActivated").trigger("change");
	 $("#additionalAttributes").trigger("change");
});

function searchFlows(request, response, searchURL, searchInput) {

	searchInput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : searchURL,
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		data : {
			q : encodeURIComponent(request.term)
		},
		success : function(data) {
			
			if (data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item,
						value : item,
					}
				}));
			} else {
				response(null);
			}
			
			searchInput.removeClass("ui-autocomplete-loading");
			
		},
		error : function() {
			
			searchInput.removeClass("ui-autocomplete-loading");
		}
	});
}

function getTemplate(prefix) {
	return $("#" + prefix + "-template");
}

function addPublishedEntry(item, list, prefix) {
	
	var exists = false;
	
	$("input[name='publishedStatus']").each(function(){
		if($(this).val() == item.value){
			exists = true;
			return false;
		}
	});
	
	if(exists){
		return;
	}
	
	var clone = getTemplate(prefix).clone();
	
	clone.find("h3").text(item.label);
	clone.find("input").prop("disabled", false);
	clone.find("input[name='publishedStatus']").val(item.value);

	clone.removeAttr("id");
	list.append(clone);
	clone.show();
}


function addArchivedEntry(item, list, prefix) {
	
	var exists = false;
	
	$("input[name='archivedStatus']").each(function(){
		if($(this).val() == item.value){
			exists = true;
			return false;
		}
	});
	
	if(exists){
		return;
	}
	
	var clone = getTemplate(prefix).clone();
	
	clone.find("h3").text(item.label);
	clone.find("input").prop("disabled", false);
	clone.find("input[name='archivedStatus']").val(item.value);

	clone.removeAttr("id");
	list.append(clone);
	clone.show();
}
