package com.nordicpeak.flowengine.queries.iconmapquery.beans;

import java.io.Serializable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.numbers.NumberStringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

@Table(name = "icon_map_query_instance_geometries")
@XMLElement
public class Geometry extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -4789836314307395263L;

	private static NumberStringyfier COORDINATE_STRINGIFYER = new NumberStringyfier(0, 0, false);

	@Key
	@DAOManaged(autoGenerated = true)
	@XMLElement
	private Integer geometryID;

	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private IconMapQueryInstance queryInstance;

	@DAOManaged(columnName = "mapIconID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private MapIcon mapIcon;

	@DAOManaged
	@XMLElement
	private String geometry;

	@DAOManaged
	@XMLElement(name = "index")
	private Integer labelIndex;

	@DAOManaged
	@XMLElement
	private String comment;

	@DAOManaged
	@XMLElement
	private String propertyUnitDesignation;

	private com.vividsolutions.jts.geom.Geometry printableGeometry;

	public Geometry() {

	}

	public Geometry(MapIcon mapIcon, String geometry, com.vividsolutions.jts.geom.Geometry printableGeometry, Integer labelIndex) {

		this.mapIcon = mapIcon;
		this.geometry = geometry;
		this.printableGeometry = printableGeometry;
		this.labelIndex = labelIndex;
	}

	public Integer getGeometryID() {

		return geometryID;
	}

	public void setGeometryID(Integer geometryID) {

		this.geometryID = geometryID;
	}

	public String getGeometry() {

		return geometry;
	}

	public void setGeometry(String geometry) {

		this.geometry = geometry;
	}

	public com.vividsolutions.jts.geom.Geometry getPrintableGeometry() {

		return printableGeometry;
	}

	public void setPrintableGeometry(com.vividsolutions.jts.geom.Geometry printableGeometry) {

		this.printableGeometry = printableGeometry;
	}

	public IconMapQueryInstance getQueryInstance() {

		return queryInstance;
	}

	public void setQueryInstance(IconMapQueryInstance queryInstance) {

		this.queryInstance = queryInstance;
	}

	public MapIcon getMapIcon() {

		return mapIcon;
	}

	public void setMapIcon(MapIcon mapIcon) {

		this.mapIcon = mapIcon;
	}

	public Integer getIndex() {

		return labelIndex;
	}

	public void setIndex(Integer labelIndex) {

		this.labelIndex = labelIndex;
	}

	public String getComment() {

		return comment;
	}

	public void setComment(String comment) {

		this.comment = comment;
	}

	public String getPropertyUnitDesignation() {

		return propertyUnitDesignation;
	}

	public void setPropertyUnitDesignation(String propertyUnitDesignation) {

		this.propertyUnitDesignation = propertyUnitDesignation;
	}

	@Override
	public Element toXML(Document doc) {

		Element element = super.toXML(doc);

		if (printableGeometry != null) {

			XMLUtils.appendNewElement(doc, element, "coordinates", COORDINATE_STRINGIFYER.format(printableGeometry.getCoordinate().x) + ", " + COORDINATE_STRINGIFYER.format(printableGeometry.getCoordinate().y));

		}

		return element;
	}

}
