package com.nordicpeak.flowengine.internalalternativelist.beans;

import java.lang.reflect.Field;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.alternativelist.provider.BaseAlternativeListEvent;

@Table(name = "internal_combined_list_events")
@XMLElement(name = "AlternativeListEvent")
public class InternalCombinedListEvent extends BaseAlternativeListEvent<InternalCombinedList, InternalCombinedListEvent> {
	
	public static final Field LIST_RELATION = ReflectionUtils.getField(InternalCombinedListEvent.class, "list");
	
	@DAOManaged(columnName = "combinedListID")
	@ManyToOne
	@XMLElement
	private InternalCombinedList list;
	
	public InternalCombinedListEvent() {
		super();
	}
	
	public InternalCombinedListEvent(InternalCombinedList list, Timestamp added, User poster, String message) {
		super(list, added, poster, message);
	}
	
	@Override
	public InternalCombinedList getList() {
		return list;
	}
	
	@Override
	public void setList(InternalCombinedList list) {
		this.list = list;
	}
	
}
