package com.nordicpeak.flowengine.queries.internalcontactdetails.beans;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.internaluserqueries.InternalUserQueriesAttributeDescriptor;
import com.nordicpeak.flowengine.queries.internaluserqueries.InternalUserQueriesSelectedAttribute;

@XMLElement
@Table(name = "internal_contact_detail_query_user_attributes")
public class SelectedUserAttribute extends InternalUserQueriesSelectedAttribute {
	
	private static final long serialVersionUID = 6653017890814168453L;
	
	@DAOManaged(columnName = "queryID")
	@Key
	@ManyToOne
	private InternalContactDetailQuery internalContactDetailQuery;
	
	public SelectedUserAttribute() {}
	
	public SelectedUserAttribute(String name, String displayName, Integer sortIndex) {
		super(name, displayName, sortIndex);
	}
	
	public SelectedUserAttribute(InternalUserQueriesAttributeDescriptor attributeDescriptor, Integer sortIndex) {
		
		this(attributeDescriptor.getName(), attributeDescriptor.getDisplayName(), sortIndex);
	}	
}
