<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/internaluserquery.js?v=2
	</xsl:variable>

	<xsl:variable name="links">
		/css/UserGroupList.css?v=1
	</xsl:variable>

	<xsl:template match="Document">
		
		<xsl:apply-templates select="ShowQueryValues"/>
		<xsl:apply-templates select="ShowQueryForm"/>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
		
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="InternalUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<article>
				
				<div class="heading-wrapper">
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="InternalUserQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="InternalUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:call-template name="createUpdateButton">
						<xsl:with-param name="queryID" select="InternalUserQueryInstance/InternalUserQuery/queryID" />
					</xsl:call-template>
					
				</div>
				
				<xsl:if test="InternalUserQueryInstance/InternalUserQuery/description">
					<span class="italic">
						<xsl:value-of select="InternalUserQueryInstance/InternalUserQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<div class="clearboth"/>
				
				<xsl:variable name="query" select="InternalUserQueryInstance/InternalUserQuery" />
				
				<fieldset>
				
					<xsl:if test="$query/showName = 'true'">
						
						<div class="split">
							<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
							<xsl:value-of select="InternalUserQueryInstance/firstname" />
							<xsl:text>&#160;</xsl:text>
							<xsl:value-of select="InternalUserQueryInstance/lastname" />
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showUsername = 'true'">
					
						<div class="split">
							<xsl:if test="$query/showName = 'true'">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
							<xsl:value-of select="InternalUserQueryInstance/username" />
						</div>
					
					</xsl:if>
					
					<xsl:if test="$query/showEmail = 'true'">
					
						<div class="split">
							<xsl:if test="($query/showName = 'true' or $query/showUsername = 'true') and not($query/showName = 'true' and $query/showUsername = 'true')">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
							<xsl:value-of select="InternalUserQueryInstance/email" />
						</div>
					
					</xsl:if>
					
					<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
						
						<div class="split">
							<xsl:if test="position() mod 2 = 0">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block"><xsl:value-of select="displayName" /></strong>
							<xsl:value-of select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
						</div>
					
					</xsl:for-each>
					
				</fieldset>
				
				<xsl:if test="$query/showManagerInfo = 'true'">
					
					<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
					
					<fieldset class="bigpaddingtop">
						
						<xsl:if test="$query/showManagerName = 'true'">
							
							<div class="split">
								<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
								<xsl:value-of select="InternalUserQueryInstance/managerFirstname" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="InternalUserQueryInstance/managerLastname" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerUsername = 'true'">
							
							<div class="split">
								<xsl:if test="$query/showManagerName = 'true'">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
								<xsl:value-of select="InternalUserQueryInstance/managerUsername" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerEmail = 'true'">
							
							<div class="split">
								<xsl:if test="($query/showManagerName = 'true' or $query/showManagerUsername = 'true') and not($query/showManagerName = 'true' and $query/showManagerUsername = 'true')">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
								<xsl:value-of select="InternalUserQueryInstance/managerEmail" />
							</div>
							
						</xsl:if>
						
						<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
							
							<div class="split">
								<xsl:if test="position() mod 2 = 0">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="displayName" /></strong>
								<xsl:value-of select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
							</div>
							
						</xsl:for-each>
					
					</fieldset>
					
				</xsl:if>
				
			</article>
			
		</div>
		
	</xsl:template>
	
	<xsl:template name="printValue">
		
		<xsl:param name="value" />
		
		<xsl:choose>
			<xsl:when test="$value">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>-</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryForm">
	
		<xsl:variable name="shortQueryID" select="concat('q', InternalUserQueryInstance/InternalUserQuery/queryID)" />
		<xsl:variable name="queryID" select="concat('query_', InternalUserQueryInstance/InternalUserQuery/queryID)" />
		<xsl:variable name="locked">
			<xsl:if test="ValidationErrors/validationError[messageKey = 'NoGroupFoundByAttribute'] or (InternalUserQueryInstance/InternalUserQuery/lockForOwnerUpdate = 'true' and RequestMetadata/manager = 'false' and RequestMetadata/flowInstanceIsSubmitted = 'true')" >
				true
			</xsl:if>
		</xsl:variable>
		
		<div id="{$queryID}">
			
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="EnableAjaxPosting"> enableAjaxPosting</xsl:if>
				<xsl:if test="InternalUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="{$queryID}" />
		
			<xsl:if test="ValidationErrors/validationError">
				<div id="{$queryID}-validationerrors" class="validationerrors">
				
					<xsl:if test="ValidationErrors/validationError">
						<div class="info-box error">
							<xsl:apply-templates select="ValidationErrors/validationError"/>
							<div class="marker"></div>
						</div>
					</xsl:if>
				</div>
			</xsl:if>
	
			<article>
			
				<xsl:if test="ValidationErrors/validationError">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
			
				<div class="heading-wrapper">
					
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="InternalUserQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="InternalUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:if test="InternalUserQueryInstance/InternalUserQuery/helpText">		
						<xsl:apply-templates select="InternalUserQueryInstance/InternalUserQuery/helpText" />
					</xsl:if>
				
				</div>
				
				<xsl:if test="InternalUserQueryInstance/InternalUserQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="InternalUserQueryInstance/InternalUserQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<xsl:variable name="query" select="InternalUserQueryInstance/InternalUserQuery" />
					
				<div class="ui-widget bigmarginbottom" data-url="{queryRequestURL}">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id">
							<xsl:value-of select="$query/queryID"/>
							<xsl:value-of select="'-search'" />
						</xsl:with-param>
						<xsl:with-param name="class">
							<xsl:text>full border-box</xsl:text>
						</xsl:with-param>
						<xsl:with-param name="width" select="''" />
						<xsl:with-param name="placeholder" select="$i18n.SearchUser" />
						<xsl:with-param name="disabled" select="$locked" />
					</xsl:call-template>
				</div>
				
				<fieldset class="bigpaddingtop">
					<xsl:if test="not(InternalUserQueryInstance/userID)">
						<xsl:attribute name="style">display: none;</xsl:attribute>
					</xsl:if>
					
					<xsl:call-template name="createHiddenField">
						<xsl:with-param name="id">
							<xsl:text>q</xsl:text>
							<xsl:value-of select="$query/queryID"/>
							<xsl:text>_user</xsl:text>
						</xsl:with-param>
						<xsl:with-param name="name">
							<xsl:text>q</xsl:text>
								<xsl:value-of select="$query/queryID"/>
							<xsl:text>_user</xsl:text>
						</xsl:with-param>
						<xsl:with-param name="value" select="InternalUserQueryInstance/userID" />
					</xsl:call-template>
				
					<xsl:if test="$query/showName = 'true'">
					
						<div class="split">
							<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
							<span id="{$shortQueryID}-name">
								<xsl:value-of select="InternalUserQueryInstance/firstname" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="InternalUserQueryInstance/lastname" />
							</span>
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showUsername = 'true'">
					
						<div class="split">
							<xsl:if test="$query/showName = 'true'">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
						
							<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
							<span id="{$shortQueryID}-username">
								<xsl:value-of select="InternalUserQueryInstance/username" />
							</span>
						</div>
					
					</xsl:if>
					
					<xsl:if test="$query/showEmail = 'true'">
					
						<div class="split">
							<xsl:if test="($query/showName = 'true' or $query/showUsername = 'true') and not($query/showName = 'true' and $query/showUsername = 'true')">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
							<span id="{$shortQueryID}-email">
								<xsl:value-of select="InternalUserQueryInstance/email" />
							</span>
						</div>
					
					</xsl:if>
					
					<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
						
						<div class="split">
							<xsl:if test="position() mod 2 = 0">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block"><xsl:value-of select="displayName" /></strong>
							<span id="{$shortQueryID}-{name}">
								<xsl:value-of select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
							</span>
						</div>
					
					</xsl:for-each>
				
				</fieldset>
				
				<xsl:if test="$query/showManagerInfo = 'true'">
					
					<div class="manager-info">
						<xsl:if test="not(InternalUserQueryInstance/managerUsername)">
							<xsl:attribute name="style">display: none;</xsl:attribute>
						</xsl:if>
						
						<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
						
						<fieldset class="bigpaddingtop">
							
							<xsl:if test="$query/showManagerName = 'true'">
							
								<div class="split">
									<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
									<span id="{$shortQueryID}-manager-name">
										<xsl:value-of select="InternalUserQueryInstance/managerFirstname" />
										<xsl:text>&#160;</xsl:text>
										<xsl:value-of select="InternalUserQueryInstance/managerLastname" />
									</span>
								</div>
								
							</xsl:if>
							
							<xsl:if test="$query/showManagerUsername = 'true'">
							
								<div class="split">
									<xsl:if test="$query/showManagerName = 'true'">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
								
									<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
									<span id="{$shortQueryID}-manager-username">
										<xsl:value-of select="InternalUserQueryInstance/managerUsername" />
									</span>
								</div>
							
							</xsl:if>
							
							<xsl:if test="$query/showManagerEmail = 'true'">
							
								<div class="split">
									<xsl:if test="($query/showManagerName = 'true' or $query/showManagerUsername = 'true') and not($query/showManagerName = 'true' and $query/showManagerUsername = 'true')">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
									
									<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
									<span id="{$shortQueryID}-manager-email">
										<xsl:value-of select="InternalUserQueryInstance/managerEmail" />
									</span>
								</div>
							
							</xsl:if>
							
							<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
								
								<div class="split">
									<xsl:if test="position() mod 2 = 0">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
									
									<strong class="block"><xsl:value-of select="displayName" /></strong>
									<span id="{$shortQueryID}-manager-{name}">
										<xsl:value-of select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
									</span>
								</div>
							
							</xsl:for-each>
						
						</fieldset>
						
					</div>
					
				</xsl:if>
				
				<script type="text/javascript">initInternalUserQuery('<xsl:value-of select="$query/queryID" />');</script>
				
			</article>
		
		</div>
		
	</xsl:template>	
	
	<xsl:template match="validationError[validationErrorType = 'RequiredField']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ValidationError.Required"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[validationErrorType = 'InvalidFormat']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ValidationError.InvalidUser"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'NoCitizenIdentifierFound']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ValidationError.NoCitizenIdentifierFound"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UnableToGetManagerDetails']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.UnableToGetManagerDetails"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'ManagerDoesNotHaveRequiredFieldsForSigning']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.ManagerDoesNotHaveRequiredFieldsForSigning"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'NoGroupFoundByAttribute']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:choose>
					<xsl:when test="../../InternalUserQueryInstance/InternalUserQuery/noGroupFoundByAttributeErrorDescription">
						<xsl:value-of select="../../InternalUserQueryInstance/InternalUserQuery/noGroupFoundByAttributeErrorDescription"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.Error.noGroupFoundByAttributeErrorDescription.Default"/>
					</xsl:otherwise>
				</xsl:choose>
			</strong>
		</span>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'InactiveAccountSelected']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Error.InactiveAccountSelected"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MayNotSelectPoster']">
		
		<span>
			<strong data-icon-before="!">
			<xsl:value-of select="$i18n.ValidationError.MayNotSelectPoster" />
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ValidationError.UnknownValidationError"/>
			</strong>
		</span>
		
	</xsl:template>	
		
</xsl:stylesheet>