
package net.opengis.gml._3;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.bind.annotation.XmlType;

import se.lantmateriet.namespace.distribution.produkter.registerbeteckning.v4.BeteckningType;
import se.lantmateriet.namespace.distribution.produkter.registerbeteckning.v4.RegisterbeteckningResponseType;


/**
 * The basic feature model is given by the gml:AbstractFeatureType.
 *         The content model for gml:AbstractFeatureType adds the gml:boundedBy property, which describes an envelope that
 *         encloses the entire feature instance, and is
 *         primarily useful for supporting rapid searching for features that occur in a particular location.
 * 
 * 
 * <p>Java class for AbstractFeatureType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="AbstractFeatureType">
 *   &lt;complexContent>
 *     &lt;extension base="{http://www.opengis.net/gml/3.2}AbstractGMLType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.opengis.net/gml/3.2}boundedBy" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AbstractFeatureType", propOrder = {
    "boundedBy"
})
@XmlSeeAlso({
    RegisterbeteckningResponseType.class,
    BeteckningType.class
})
public abstract class AbstractFeatureType
    extends AbstractGMLType
{

    @XmlElement(nillable = true)
    protected BoundingShapeType boundedBy;

    /**
     * Gets the value of the boundedBy property.
     * 
     * @return
     *     possible object is
     *     {@link BoundingShapeType }
     * 
     */
    public BoundingShapeType getBoundedBy() {
        return boundedBy;
    }

    /**
     * Sets the value of the boundedBy property.
     * 
     * @param value
     *     allowed object is
     *     {@link BoundingShapeType }
     * 
     */
    public void setBoundedBy(BoundingShapeType value) {
        this.boundedBy = value;
    }

}
