package com.nordicpeak.lmsearch.beans;

import com.vividsolutions.jts.geom.Point;

import se.unlogic.standardutils.json.JsonNode;
import se.unlogic.standardutils.json.JsonObject;

public class PlaceName extends BaseLMResponse {

	private final Long placeNameID;
	private final String name;
	private final String municipality;
	private final Point point;

	public PlaceName(Long placeNameID, String name, String municipality, Point point) {
		
		this.placeNameID = placeNameID;
		this.name = name;
		this.municipality = municipality;
		this.point = point;
	}

	public Long getPlaceNameID() {

		return placeNameID;
	}

	public String getName() {

		return name;
	}

	public String getMunicipality() {

		return municipality;
	}

	public Point getPoint() {

		return point;
	}

	@Override
	public JsonNode toJson() {

		JsonObject jsonNode = new JsonObject();

		jsonNode.putField("geometry", getJSONForGeometry(getPoint()));

		JsonObject propertiesNode = new JsonObject();

		propertiesNode.putField("id", getPlaceNameID());
		propertiesNode.putField("name", getName());
		propertiesNode.putField("municipality", getMunicipality());

		jsonNode.putField("properties", propertiesNode);
		jsonNode.putField("type", "Feature");
		
		return jsonNode;
	}

}
