package com.nordicpeak.lmsearch.beans;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.geom.impl.CoordinateArraySequence;

import flexjson.JsonNumber;
import flexjson.ObjectBinder;
import flexjson.ObjectFactory;
import se.unlogic.standardutils.reflection.ReflectionUtils;

public class PointTypeJsonFactory implements ObjectFactory {
	
	private static final GeometryFactory JTS_GEOMETRY_FACTORY = new GeometryFactory();
	
	public PointTypeJsonFactory() {}
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	public Object instantiate(ObjectBinder context, Object value, Type targetType, Class targetClass) {
		
		ReflectionUtils.printFields(context, 1);
		
		Map<String, Object> map = (Map<String, Object>) value;
		
		String type = (String) map.get("type");
		
		if (!"Point".equals(type)) {
			
			throw new RuntimeException("Wrong geometry type");
		}
		
		List<JsonNumber> coordinateValues = (List<JsonNumber>) map.get("coordinates");
		
		Coordinate coordinate = new Coordinate(coordinateValues.get(0).doubleValue(), coordinateValues.get(1).doubleValue(), coordinateValues.get(2).doubleValue());
		
		CoordinateArraySequence coordinateSequence = new CoordinateArraySequence(new Coordinate[] { coordinate });
		
		Point point = new Point(coordinateSequence, JTS_GEOMETRY_FACTORY);
		
		return context.bindIntoObject((Map) value, point, targetType);
	}
	
}
