$(function() {

	$("#flow-status-filter").on("change", function() {
		
		var $this = $(this);
		
		$("#flowlist tbody tr").removeClass("status-filtered").hide();
		
		if($this.val() == "published") {
			
			$("#flowlist tbody tr.published").addClass("status-filtered").show();
			
		} else if($this.val() == "unpublished") {
			
			$("#flowlist tbody tr:not(.published)").addClass("status-filtered").show();
			
		} else {
			
			$("#flowlist tbody tr").addClass("status-filtered").show();
		}
		
		$("input[type='text'].flow-filter-input").trigger("keyup");
		
	});
	
	$("input[type='text'].flow-filter-input").on("keyup", function() {
		
		var $this = $(this);
		var val = $.trim($this.val()).replace(/ +/g, ' ').toLowerCase();
	    
		$("#flowlist").find(".status-filtered").show().filter(function() {
	        var text = $(this).text().replace(/\s+/g, ' ').toLowerCase();
	        return !~text.indexOf(val);
	    }).hide();
	
		$("#flowlist").trigger("change");
		
	});
	
	$("#flow-status-filter").trigger("change");
	
	if ($("#flowversionlist").length > 0) {
		
		var rebuildLinks = function() {
			var usePreview = $("input[name='preview']:checked").val() == "true";
			
			$("#flowversionlist a").each(function(){
				var a = $(this);
				var href = a.prop("href");
				
				href = href.substring(0, href.indexOf("?") + 1)
				
				if (usePreview) {
					href += "preview=true";
				}
				
				a.prop("href", href);
			});
		}
		
		$("input[name='preview']").on("change", rebuildLinks);
		
		// Backing in chrome keeps selected radio but resets links to default
		$(window).on("pageshow", rebuildLinks);
	}
});