<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="ManualCheckboxQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{ManualCheckboxQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="ManualCheckboxQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<p>
				<xsl:apply-templates select="ManualCheckboxQueryInstance/Alternatives/CheckboxAlternative" mode="show"/>
		
				<xsl:if test="ManualCheckboxQueryInstance/freeTextAlternativeValue">
					<br/><xsl:value-of select="ManualCheckboxQueryInstance/freeTextAlternativeValue"/>
				</xsl:if>
			</p>
			
			<p>
				<xsl:apply-templates select="ManualCheckboxQueryInstance/ManualCheckboxQuery/Alternatives/CheckboxAlternative" mode="form"/>
	
				<xsl:if test="ManualCheckboxQueryInstance/ManualCheckboxQuery/freeTextAlternative">
				
					<div>
					
						<xsl:attribute name="class">
							<xsl:text>marginbottom</xsl:text>
							<xsl:choose>
								<xsl:when test="ManualCheckboxQueryInstance/ManualCheckboxQuery/columns = 'TWO'"> floatleft fifty</xsl:when>
								<xsl:when test="ManualCheckboxQueryInstance/ManualCheckboxQuery/columns = 'THREE'"> floatleft thirty</xsl:when>
								<xsl:otherwise> full</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
					
						<div class="floatleft" style="border: 1px solid #808080; height: 16px; width: 16px;">
							<xsl:text>&#160;</xsl:text>
						</div>
				
						<span class="floatleft bigmarginleft">
							<xsl:value-of select="ManualCheckboxQueryInstance/ManualCheckboxQuery/freeTextAlternative" />
						</span>
						
					</div>
				
					<div class="clearboth bigmarginbottom padding bigpaddingbottom" style="border: 1px solid #808080; padding-top: 0;">
						<xsl:call-template name="rowsLoop">
							<xsl:with-param name="rows" select="4"/>
						</xsl:call-template>
					</div>
					
				</xsl:if>
				
				<div class="clearboth"/>
			</p>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="CheckboxAlternative" mode="form">

		<div>
		
			<xsl:attribute name="class">
				<xsl:text>bigmarginbottom</xsl:text>
				<xsl:choose>
					<xsl:when test="../../columns = 'TWO'"> floatleft fifty</xsl:when>
					<xsl:when test="../../columns = 'THREE'"> floatleft thirty</xsl:when>
					<xsl:otherwise> full display-table</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>

			<div class="floatleft" style="border: 1px solid #808080; height: 16px; width: 16px;">
				<xsl:choose>
					<xsl:when test="checked = 'true'"><span style="padding-left: 5px;">x</span></xsl:when>
					<xsl:otherwise>&#160;</xsl:otherwise>
				</xsl:choose>
			</div>
	
			<span class="floatleft bigmarginleft" style="padding-top: 1px;">
				<xsl:value-of select="name" />
			</span>
	
		</div>
	
	</xsl:template>

	<xsl:template name="rowsLoop">
		<xsl:param name="rows"/>
		
		<div class="full" style="line-height: 2; border-bottom: 1px dashed #bbb;">
			<xsl:text>&#160;</xsl:text>
		</div>
		
		<xsl:if test="$rows > 1">
			<xsl:call-template name="rowsLoop">
				<xsl:with-param name="rows" select="$rows -1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>