<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="ManualTextAreaQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{ManualTextAreaQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="ManualTextAreaQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<xsl:variable name="rows">
				<xsl:choose>
					<xsl:when test="ManualTextAreaQueryInstance/ManualTextAreaQuery/rows">
						
						<xsl:value-of select="ManualTextAreaQueryInstance/ManualTextAreaQuery/rows"/>
						
					</xsl:when>
					<xsl:otherwise>
					
						<xsl:text>4</xsl:text>
						
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<div class="bigmarginbottom padding bigpaddingbottom" style="border: 1px solid #808080; padding-top: 0;">
				<xsl:call-template name="rowsLoop">
					<xsl:with-param name="rows" select="$rows"/>
				</xsl:call-template>
			</div>
					
		</div>
		
	</xsl:template>
	
	<xsl:template name="rowsLoop">
		<xsl:param name="rows"/>
		
		<div class="full" style="line-height: 2; border-bottom: 1px dashed #bbb;">
			<xsl:text>&#160;</xsl:text>
		</div>
		
		<xsl:if test="$rows > 1">
			<xsl:call-template name="rowsLoop">
				<xsl:with-param name="rows" select="$rows -1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>