package com.nordicpeak.flowengine.evaluators.internalaccount;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "matching_internal_account_query_state_evaluators")
@XMLElement
public class MatchingInternalAccountQueryStateEvaluator extends BaseQueryStateEvaluator{

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean inclusive;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean requireEnabledAccount;
	
	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>(1);
		
		inclusive = xmlParser.getPrimitiveBoolean("inclusive");
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
	}
	
	public boolean isInclusive() {
		
		return inclusive;
	}
	
	public void setInclusive(boolean inclusive) {
		
		this.inclusive = inclusive;
	}

	public boolean isRequireEnabledAccount() {
		return requireEnabledAccount;
	}

	public void setRequireEnabledAccount(boolean requireEnabledAccount) {
		this.requireEnabledAccount = requireEnabledAccount;
	}

	@Override
	public boolean requiresInitialization() {
		
		return true;
	}
}
