package com.nordicpeak.flowengine.evaluators.officialaddressquerystateevaluator;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "official_address_query_state_evaluators")
@XMLElement
public class OfficialAddressQueryStateEvaluator extends BaseQueryStateEvaluator {

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean invert;

	private boolean initialized;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);

		List<ValidationError> errors = new ArrayList<ValidationError>(1);

		invert = xmlParser.getPrimitiveBoolean("invert");

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	public boolean isInverted() {

		return invert;
	}

	public void setInvert(boolean invert) {

		this.invert = invert;
	}

	@Override
	public boolean requiresInitialization() {

		return true;
	}

	public boolean isInitialized() {

		return initialized;
	}

	public void setInitialized(boolean initialized) {

		this.initialized = initialized;
	}

}
