package com.nordicpeak.flowengine.paymentlog.listeners;

import java.sql.SQLException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.xml.ElementableListener;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.paymentlog.AccountModule;
import com.nordicpeak.flowengine.paymentlog.beans.ChartOfAccounts;

public class ChartInUseElementableListener implements ElementableListener<ChartOfAccounts> {
	
	private final AccountModule accountModule;
	
	public ChartInUseElementableListener(AccountModule accountModule) {
		super();
		this.accountModule = accountModule;
	}
	
	@Override
	public void elementGenerated(Document doc, Element element, ChartOfAccounts chart) {
		
		try {
			if (accountModule.isChartInUse(chart)) {
				XMLUtils.appendNewElement(doc, element, "inUse", true);
			}
		} catch (SQLException e) {
			throw new RuntimeException(e);
		}
	}
	
}
