<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PersonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{PersonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PersonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</xsl:if>
			
			<div class="full display-table bigmarginbottom">
				
				<div class="floatleft full bigmarginbottom">
					<strong><xsl:value-of select="$i18n.CitizenID" /></strong><br/>
					<xsl:value-of select="PersonQueryInstance/citizenID" />
				</div>	
				
				<div class="floatleft full bigmarginbottom">
					<strong><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong><br/>
					<xsl:value-of select="PersonQueryInstance/firstname" /><xsl:text>&#160;</xsl:text><xsl:value-of select="PersonQueryInstance/lastname" />
				</div>
				
				<xsl:if test="PersonQueryInstance/careOf">
					
					<div class="floatleft full bigmarginbottom">
						<strong><xsl:value-of select="$i18n.CareOf" /></strong><br/>
						<xsl:call-template name="printValue">
							<xsl:with-param name="value" select="PersonQueryInstance/careOf" />
						</xsl:call-template>
					</div>
				
				</xsl:if>
				
				<div class="floatleft fifty bigmarginbottom">
					<strong><xsl:value-of select="$i18n.Address" /></strong><br/>
					<xsl:call-template name="printValue">
						<xsl:with-param name="value" select="PersonQueryInstance/address" />
					</xsl:call-template>
				</div>
				
				<div class="floatleft fifty bigmarginbottom">
					<strong><xsl:value-of select="$i18n.ZipCodeAndPostalAddress" /></strong><br/>
					<xsl:call-template name="printValue">
						<xsl:with-param name="value" select="PersonQueryInstance/zipCode" />
					</xsl:call-template>
					<xsl:text>&#160;</xsl:text>
					<xsl:call-template name="printValue">
						<xsl:with-param name="value" select="PersonQueryInstance/postalAddress" />
					</xsl:call-template>
				</div>
				
				<xsl:if test="PersonQueryInstance/PersonQuery/useForMultipartSigning = 'true'">
					
					<div class="floatleft fifty bigmarginbottom">
						<strong><xsl:value-of select="$i18n.Email" /></strong><br/>
						<xsl:call-template name="printValue">
							<xsl:with-param name="value" select="PersonQueryInstance/email" />
						</xsl:call-template>
					</div>
					
					<div class="floatleft fifty bigmarginbottom">
						<strong><xsl:value-of select="$i18n.Phone" /></strong><br/>
						<xsl:call-template name="printValue">
							<xsl:with-param name="value" select="PersonQueryInstance/phone" />
						</xsl:call-template>
					</div>
					
				</xsl:if>
				
			</div>
			
		</div>
		
	</xsl:template>

	<xsl:template name="printValue">
		
		<xsl:param name="value" />
		
		<xsl:choose>
			<xsl:when test="$value">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>-</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>