$(function() {
	
	setQueryRequiredFunctions["PersonQueryInstance"] = makePersonQueryRequired;
});

function initPersonQuery(queryID) {
	
	var shortQueryID = "q" + queryID;
	var query = $("#query_" + queryID); 
	
	query.find("input.input-error").parent().addClass("input-error");
	
	var searchInput = query.find("input[name='" + shortQueryID + "_citizenID']");
	var searchURL = query.find("input[name='connectorURL']").val();
	 
	if(query.find(".name").text() != "") {
		query.find(".person-wrapper").show();
	}
	
	searchInput.on("change", function() {
		
		searchInput.siblings("i, .error").remove();
		searchInput.removeClass("input-error").parent().removeClass("input-error");
		 
		var val = searchInput.val();
		
		if (val == "") {
			
			query.find(".name").text("-");
			query.find(".address").text("-");
			query.find(".postal").text("-");
			query.find(".careof").text("-");
			query.find(".person-wrapper").hide();
			
			if (query.hasClass("enableAjaxPosting")) {
				var parameters = {};
				parameters[searchInput.attr("name")] = val;
				runQueryEvaluators(queryID, parameters);
			}
			
			return;
		}
		
		if (val.length != 12 || !/^[0-9]+$/.test(val)) {
			
			searchInput.addClass("input-error").parent().addClass("input-error");
			searchInput.parent().append(query.find(".template-invalid-format").clone());
			return;
		}
		
		if (!searchInput.hasClass("ui-autocomplete-loading")) {
		
			searchInput.addClass("ui-autocomplete-loading");
			
			$.ajax({
				url : searchURL,
				dataType : "json",
				contentType: "application/x-www-form-urlencoded;charset=UTF-8",
				data : {
					q : encodeURIComponent(val)
				},
				success : function(data) {
					
					if (data.error != undefined) {
					
						if (data.error == "invalid format") {
							
							searchInput.addClass("input-error").parent().addClass("input-error");
							searchInput.parent().append(query.find(".template-invalid-format").clone());
							
						} else if (data.error == "block poster selection") {
							
							searchInput.parent().append(query.find(".template-block-poster-selection").clone());
							
						} else if (data.error == "not found") {
							
							searchInput.parent().append(query.find(".template-not-found").clone());
							
						} else if (data.error == "provider error") {
							
							searchInput.parent().append(query.find(".template-provider-error").clone());
						
						} else if (data.error == "max lookups reached") {
								
							searchInput.parent().append(query.find(".template-max-lookups-reached").clone());
							
						} else {
							
							searchInput.parent().append(query.find(".template-unknown-error").clone());
						}
						
						query.find(".person-wrapper").hide();
						
					} else {
						
						var formatVal = function(val) {
							if (val == "" || val == null) return "-";
							return val;
						}
						
						query.find(".name").text(formatVal(data.firstname + " " + data.lastname));
						query.find(".address").text(formatVal(data.address));
						query.find(".postal").text(formatVal(data.postalCode + " " + data.postalAddress));
						
						var careof = formatVal(data.careOf);
						var $carof = query.find(".careof");
						$carof.text(careof);
						
						if(careof == "-") {
							$carof.closest("fieldset").hide();
						} else {
							$carof.closest("fieldset").show();
						}
						
						query.find(".person-wrapper").show();
					}
					
					if (query.hasClass("enableAjaxPosting")) {
						var parameters = {};
						parameters[searchInput.attr("name")] = val;
						runQueryEvaluators(queryID, parameters);
					}
					
					searchInput.removeClass("ui-autocomplete-loading");
				},
				error : function() {
					
					searchInput.removeClass("ui-autocomplete-loading");
				}
			});
		}
	});
}

function makePersonQueryRequired(queryID) {
	
	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
	
}