package com.nordicpeak.flowengine.queries.plotquery;

import javax.servlet.http.HttpSessionEvent;
import javax.sql.DataSource;

import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.listeners.SessionListener;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.hierarchy.foregroundmodules.AnnotatedForegroundModule;
import se.unlogic.webutils.http.SessionUtils;

public class AbortedPlotListenerModule extends AnnotatedForegroundModule implements SessionListener {

	@InstanceManagerDependency
	private PlotQueryProviderModule plotQueryProviderModule;

	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {

		super.init(moduleDescriptor, sectionInterface, dataSource);

		if (systemInterface.getSessionListenerHandler() != null) {

			systemInterface.getSessionListenerHandler().addListener(this);

		} else {

			log.warn("No session listener handler available, unable to listen for expired sessions");
		}
	}

	@Override
	public void unload() throws Exception {

		if (systemInterface.getSessionListenerHandler() != null) {

			systemInterface.getSessionListenerHandler().removeListener(this);
		}

		super.unload();
	}

	@Override
	public void sessionCreated(HttpSessionEvent event) {}

	@Override
	public void sessionDestroyed(HttpSessionEvent event) {

		Integer objectID = (Integer) SessionUtils.getAttribute(PlotIntegrationConstants.LOCKED_OBJECT_ID, event.getSession());

		if (plotQueryProviderModule != null && objectID != null) {

			plotQueryProviderModule.abortPlotBooking(objectID);
		}
	}

}
