<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
		
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PlotQueryInstance/PlotQuery/hideBackground = 'true'"> noborder</xsl:if>
				<xsl:if test="PlotQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{PlotQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PlotQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>				
			</xsl:if>
			
			<p>
				<strong><xsl:value-of select="$i18n.ObjectID" /></strong>
				<br/>
				<xsl:value-of select="PlotQueryInstance/objectID" />
			</p>				

			<p>
				<strong><xsl:value-of select="$i18n.PropertyUnitDesignation" /></strong>
				<br/>
				<xsl:value-of select="PlotQueryInstance/propertyUnitDesignation" />
			</p>				

			<p>
				<strong><xsl:value-of select="$i18n.Address" /></strong>
				<br/>
				<xsl:value-of select="PlotQueryInstance/address" />
			</p>				

			<p>
				<strong><xsl:value-of select="$i18n.Area" /></strong>
				<br/>
				<xsl:value-of select="PlotQueryInstance/area" />
			</p>				

			<p>
				<strong><xsl:value-of select="$i18n.ConnectionFee" /></strong>
				<br/>
				<xsl:choose>
					<xsl:when test="PlotQueryInstance/connectionFee"><xsl:value-of select="PlotQueryInstance/connectionFee" /></xsl:when>
					<xsl:otherwise><xsl:value-of select="$i18n.NoConnectionFee" /></xsl:otherwise>
				</xsl:choose>
			</p>				

			<p>
				<strong><xsl:value-of select="$i18n.Price" /></strong>
				<br/>
				<xsl:value-of select="PlotQueryInstance/price" />
			</p>				
			
		</div>
		
	</xsl:template>

</xsl:stylesheet>