<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PriceTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{PriceTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PriceTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>			
			
			<xsl:if test="Description">
				
				<xsl:choose>
					<xsl:when test="isHTMLDescription = 'true'">
						<xsl:value-of select="Description" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<p>
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</p>
					</xsl:otherwise>
				</xsl:choose>
				
			</xsl:if>
			
			<table class="full bigmarginbottom">
				
					<thead>
						<tr>
						
							<th class="paddingright" style="width: 40%;">
								<xsl:value-of select="PriceTableQueryInstance/PriceTableQuery/rowsLabel"/>
							</th>
							<th class="paddingright" style="width: 1%;">
								<xsl:value-of select="$i18n.Column.Count"/>
							</th>
							<th class="paddingright" style="width: 1%;">
								<xsl:value-of select="$i18n.Column.Sum"/>
							</th>
							<th/>
							<xsl:if test="PriceTableQueryInstance/PriceTableQuery/showComments = 'true'">
								<th class="paddingright">
									<xsl:value-of select="$i18n.Column.Comment"/>
								</th>
							</xsl:if>
							
						</tr>
					</thead>
					
					<tbody>
					
						<xsl:apply-templates select="PriceTableQueryInstance/PriceTableQuery/Rows/Row" mode="tbody-show" />
						
					</tbody>
					
					<tfoot>
						<tr>
							
							<td class="paddingright"><strong><xsl:value-of select="$i18n.Summary"/></strong></td>
									
							<td class="padding"/>

							<td class="padding">
								<span class="floatright paddingright">
									<xsl:value-of select="PriceTableQueryInstance/sum"/>
								</span>
							</td>

							<td class="padding"/>
							
							<xsl:if test="PriceTableQueryInstance/PriceTableQuery/showComments = 'true'">
								<td class="padding"/>
							</xsl:if>
							
						</tr>
					</tfoot>
					
				</table>
				
		</div>
		
	</xsl:template>
	
	<xsl:template match="Row" mode="tbody-show">
	
		<xsl:variable name="rowID" select="rowID"/>

		<xsl:variable name="value" select="../../../Values/RowValue[Row/rowID = $rowID]/formattedValue"/>
		
		<xsl:if test="(../../../PriceTableQuery/hideEmptyRows = 'true' and $value != 0) or ../../../PriceTableQuery/hideEmptyRows = 'false'">
			
			<tr>
			
				<td class="paddingright">
					<strong>
						<xsl:value-of select="label"/>
					</strong>
					<span class="marginleft">
						<xsl:value-of select="formattedPrice"/>
						<xsl:text>&#160;</xsl:text>
						<xsl:text>kr</xsl:text>
					</span>
				</td>
				
				<td class="padding text-align-right bigpaddingright">
					
					<xsl:choose>
						<xsl:when test="$value">
							<xsl:value-of select="$value"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>&#160;</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				
				<td class="padding text-align-right bigpaddingright">
					<xsl:variable name="value" select="sum"/>
					
					<xsl:choose>
						<xsl:when test="$value">
							<xsl:value-of select="$value"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>&#160;</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				
				<td/>
				
				<xsl:if test="../../../PriceTableQuery/showComments = 'true'">
					
					<td class="padding">
						<xsl:variable name="value" select="../../../Values/RowValue[Row/rowID = $rowID]/comment"/>
						
						<xsl:choose>
							<xsl:when test="$value">
								<xsl:value-of select="$value"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>&#160;</xsl:text>
							</xsl:otherwise>
						</xsl:choose>
					</td>
					
				</xsl:if>
				
			</tr>
		</xsl:if>
		
	</xsl:template>
	
</xsl:stylesheet>