package com.nordicpeak.flowengine.queue.beans;

import java.io.Serializable;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.contactdetailquery.ContactDetailQueryInstance;

@Table(name = "queue_slot_manual_contacts")
@XMLElement
public class ManualContact extends BaseContact implements Serializable {

	private static final long serialVersionUID = 7634780772195411125L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer queueSlotID;

	@DAOManaged
	@OneToOne
	@XMLElement
	private QueueSlot queueSlot;

	public ManualContact() {}

	public ManualContact(User user) {

		super(user);
	}

	public ManualContact(ContactDetailQueryInstance contactDetailQueryInstance) {

		super(contactDetailQueryInstance, null);
	}

	public Integer getQueueSlotID() {

		return queueSlotID;
	}

	public void setQueueSlotID(Integer queueSlotID) {

		this.queueSlotID = queueSlotID;
	}

}
