<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
	</xsl:variable>

	<xsl:template match="Document">	
		
		<div id="QueueQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateQueueQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateQueueQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="QueueQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateQueueQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="QueueQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">

				<label for="queueID">
					<xsl:value-of select="$i18n.Queue" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'queueID'" />
						<xsl:with-param name="name" select="'queueID'" />
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'queueID'" />
						<xsl:with-param name="element" select="Queues/Queue" />
						<xsl:with-param name="width" select="'50%'" />
						<xsl:with-param name="selectedValue" select="QueueQuery/Queue/queueID" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="acceptText" class="floatleft clearboth"><xsl:value-of select="$i18n.AcceptText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'acceptText'"/>
					<xsl:with-param name="name" select="'acceptText'"/>
					<xsl:with-param name="value" select="QueueQuery/acceptText"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="acceptText" class="floatleft clearboth"><xsl:value-of select="$i18n.InvoiceLineText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'invoiceLineText'"/>
					<xsl:with-param name="name" select="'invoiceLineText'"/>
					<xsl:with-param name="value" select="QueueQuery/invoiceLineText"/>
				</xsl:call-template>
			</div>
												
			<div class="floatleft full marginbottom">
			
				<label for="paymentRequiredText" class="full nomargin">
					<xsl:value-of select="$i18n.PaymentRequired" />
				</label>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="name" select="'paymentRequiredText'" />
					<xsl:with-param name="id" select="'paymentRequiredText'" />
					<xsl:with-param name="value" select="QueueQuery/paymentRequiredText" />
					<xsl:with-param name="placeholder" select="$i18n.PaymentRequired.DefaultText" />
				</xsl:call-template>
			</div>
															
			<div class="floatleft full marginbottom">
			
				<label for="alreadyMemberText" class="full nomargin">
					<xsl:value-of select="$i18n.AlreadyMember" />
				</label>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="name" select="'alreadyMemberText'" />
					<xsl:with-param name="id" select="'alreadyMemberText'" />
					<xsl:with-param name="value" select="QueueQuery/alreadyMemberText" />
					<xsl:with-param name="placeholder" select="$i18n.AlreadyMember.DefaultText" />
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showCommentField'"/>
					<xsl:with-param name="name" select="'showCommentField'"/>
					<xsl:with-param name="element" select="QueueQuery" />					
				</xsl:call-template>	
					
				<label for="showCommentField"><xsl:value-of select="$i18n.ShowCommentField" /></label>
			
			</div>			
			
			<div class="floatleft full marginbottom">

				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'hideTitle'" />
					<xsl:with-param name="name" select="'hideTitle'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="QueueQuery" />
				</xsl:call-template>
				
				<label for="hideTitle">
					<xsl:value-of select="$i18n.HideTitle" />
				</label>

			</div>			
			
			<div class="floatleft full marginbottom">

				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowNextStepIfAlreadyMember'" />
					<xsl:with-param name="name" select="'allowNextStepIfAlreadyMember'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="QueueQuery" />
				</xsl:call-template>
				
				<label for="allowNextStepIfAlreadyMember">
					<xsl:value-of select="$i18n.AllowNextStepIfAlreadyMember" />
				</label>

			</div>			
						
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedQueueQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.QueueQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'queueID'">
				<xsl:value-of select="$i18n.Queue" />
			</xsl:when>
			<xsl:when test="$fieldName = 'acceptText'">
				<xsl:value-of select="$i18n.AcceptText" />
			</xsl:when>
			<xsl:when test="$fieldName = 'invoiceLineText'">
				<xsl:value-of select="$i18n.InvoiceLineText" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>