package com.nordicpeak.flowengine.randomevent;

import se.unlogic.standardutils.annotations.RequiredIfSet;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.PercentageStringIntegerPopulator;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "random_event_generator_settings")
@XMLElement
public class RandomEventSettings extends GeneratedElementable {

	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean enabled;

	@DAOManaged
	@WebPopulate(required = true, populator = PercentageStringIntegerPopulator.class)
	@XMLElement
	private Integer chance;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String eventDescription;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean addExternalMessage;
	
	@DAOManaged
	@WebPopulate(maxLength = 65535)
	@RequiredIfSet(paramNames="addExternalMessage")
	@XMLElement
	private String externalMessageText;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean overrideSubmittedMessage;

	@DAOManaged
	@WebPopulate(maxLength = 65535)
	@RequiredIfSet(paramNames="overrideSubmittedMessage")
	@XMLElement
	private String submittedMessageHeading;
	
	@DAOManaged
	@WebPopulate(maxLength = 65535)
	@RequiredIfSet(paramNames="overrideSubmittedMessage")
	@XMLElement
	private String submittedMessageText;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean setAsAttribute;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@RequiredIfSet(paramNames = "setAsAttribute")
	@XMLElement
	private String attributeName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@RequiredIfSet(paramNames = "setAsAttribute")
	@XMLElement
	private String attributeValue;

	public boolean isPopulated() {

		if (chance != null || eventDescription != null || attributeName != null || attributeName != null) {

			return true;
		}

		return false;
	}
	
	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public Integer getChance() {

		return chance;
	}

	public void setChance(Integer chance) {

		this.chance = chance;
	}

	public String getEventDescription() {

		return eventDescription;
	}

	public void setEventDescription(String eventDescription) {

		this.eventDescription = eventDescription;
	}

	public boolean isSetAsAttribute() {

		return setAsAttribute;
	}

	public void setSetAsAttribute(boolean setAsAttribute) {

		this.setAsAttribute = setAsAttribute;
	}

	public String getAttributeName() {

		return attributeName;
	}

	public void setAttributeName(String attributeName) {

		this.attributeName = attributeName;
	}

	public String getAttributeValue() {

		return attributeValue;
	}

	public void setAttributeValue(String attributeValue) {

		this.attributeValue = attributeValue;
	}

	
	public boolean isAddExternalMessage() {
	
		return addExternalMessage;
	}

	
	public void setAddExternalMessage(boolean addExternalMessage) {
	
		this.addExternalMessage = addExternalMessage;
	}

	
	public String getExternalMessageText() {
	
		return externalMessageText;
	}

	
	public void setExternalMessageText(String externalMessageText) {
	
		this.externalMessageText = externalMessageText;
	}

	
	public boolean isOverrideSubmittedMessage() {
		
		return overrideSubmittedMessage;
	}

	
	public String getSubmittedMessageText() {
	
		return submittedMessageText;
	}

	
	public String getSubmittedMessageHeading() {
	
		return submittedMessageHeading;
	}
	
	
}
