<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>

	<xsl:template match="Document">

		<div id="RemoteInfoQueryProvider" class="contentitem">

			<xsl:apply-templates select="validationError" />
			<xsl:apply-templates select="UpdateRemoteInfoQuery" />

		</div>

	</xsl:template>

	<xsl:template match="UpdateRemoteInfoQuery">

		<h1>
			<xsl:value-of select="$i18n.UpdateQuery" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="RemoteInfoQuery/QueryDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form id="updateRemoteInfoQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="RemoteInfoQuery" />
			</xsl:call-template>

			<div class="floatleft hugemarginright">
				<div>
					<label for="endpointID" class="floatleft clearboth"><xsl:value-of select="$i18n.EndpointHeading"></xsl:value-of></label>
				</div>
				<div>
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'endpointID'" />
						<xsl:with-param name="name" select="'endpointID'" />
						<xsl:with-param name="title" select="$i18n.EndpointTitle"/>
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'endpointID'" />
						<xsl:with-param name="element" select="RemoteInfoQueryEndpoint" />
			 			<xsl:with-param name="class" select="'marginright'" />
			 			<xsl:with-param name="addEmptyOption" select="$i18n.EndpointEmptyOption" />
			 			<xsl:with-param name="selectedValue" select="RemoteInfoQuery/RemoteInfoQueryEndpoint/endpointID" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">
				<label for="endpointErrorText" class="floatleft clearboth"><xsl:value-of select="$i18n.EndpointErrorText" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'endpointErrorText'"/>
						<xsl:with-param name="name" select="'endpointErrorText'"/>
						<xsl:with-param name="title" select="$i18n.EndpointErrorText"/>
						<xsl:with-param name="element" select="RemoteInfoQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideTitle'" />
						<xsl:with-param name="name" select="'hideTitle'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="RemoteInfoQuery" />
					</xsl:call-template>
					
					<label for="hideTitle">
						<xsl:value-of select="$i18n.HideTitle" />
					</label>
				</div>

			</div>

			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideBackground'" />
						<xsl:with-param name="name" select="'hideBackground'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="RemoteInfoQuery" />
					</xsl:call-template>
					
					<label for="hideBackground">
						<xsl:value-of select="$i18n.HideBackground" />
					</label>
				</div>

			</div>
			
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideOnEmptyResponse'" />
						<xsl:with-param name="name" select="'hideOnEmptyResponse'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="RemoteInfoQuery" />
					</xsl:call-template>
					
					<label for="hideOnEmptyResponse">
						<xsl:value-of select="$i18n.HideOnEmptyResponse" />
					</label>
				</div>

			</div>			
			
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'dontSetPopulated'" />
						<xsl:with-param name="name" select="'dontSetPopulated'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="RemoteInfoQuery" />
					</xsl:call-template>
					
					<label for="dontSetPopulated">
						<xsl:value-of select="$i18n.DontSetPopulated" />
					</label>
				</div>

			</div>			

			<div class="floatleft full bigmarginbottom">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>

			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="RemoteInfoQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.SetAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.AttributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.AttributeName"/>
						<xsl:with-param name="element" select="RemoteInfoQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>

			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedRemoteInfoQueryNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.RemoteInfoQueryNotFound" />
		</p>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = ''">
			</xsl:when>
			<xsl:when test="$fieldName = 'endpointID'">
				<xsl:value-of select="$i18n.endpointID" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>