package com.nordicpeak.flowengine.restrictedflowadmin;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import se.unlogic.hierarchy.core.interfaces.AccessInterface;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flow_family_restricted_flow_admin_access")
@XMLElement
public class FlowFamilyRestrictedSettings extends GeneratedElementable implements Serializable, AccessInterface {
	
	private static final long serialVersionUID = 7195827633619267170L;
	
	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;
	
	@DAOManaged
	@OneToMany(autoGet = true, autoAdd = true, autoUpdate = true)
	@SimplifiedRelation(table = "flow_family_restricted_flow_admin_access_users", remoteValueColumnName = "userID")
	@WebPopulate(paramName = "restrictedadminuser")
	@XMLElement(childName = "userID")
	private List<Integer> allowedRestrictedAdminUserIDs;
	
	@DAOManaged
	@OneToMany(autoGet = true, autoAdd = true, autoUpdate = true)
	@SimplifiedRelation(table = "flow_family_restricted_flow_admin_access_groups", remoteValueColumnName = "groupID")
	@WebPopulate(paramName = "restrictedadmingroup")
	@XMLElement(childName = "groupID")
	private List<Integer> allowedRestrictedAdminGroupIDs;
	
	public Integer getFlowFamilyID() {
		
		return flowFamilyID;
	}
	
	public void setFlowFamilyID(Integer flowFamilyID) {
		
		this.flowFamilyID = flowFamilyID;
	}
	
	public List<Integer> getAllowedRestrictedAdminGroupIDs() {
		return allowedRestrictedAdminGroupIDs;
	}
	
	public void setAllowedRestrictedAdminGroupIDs(List<Integer> allowedRestrictedAdminGroupIDs) {
		this.allowedRestrictedAdminGroupIDs = allowedRestrictedAdminGroupIDs;
	}
	
	public List<Integer> getAllowedRestrictedAdminUserIDs() {
		return allowedRestrictedAdminUserIDs;
	}
	
	public void setAllowedRestrictedAdminUserIDs(List<Integer> allowedRestrictedAdminUserIDs) {
		this.allowedRestrictedAdminUserIDs = allowedRestrictedAdminUserIDs;
	}

	@Override
	public boolean allowsAdminAccess() {
		return false;
	}

	@Override
	public boolean allowsUserAccess() {
		return false;
	}

	@Override
	public boolean allowsAnonymousAccess() {
		return false;
	}

	@Override
	public Collection<Integer> getAllowedGroupIDs() {
		return getAllowedRestrictedAdminGroupIDs();
	}

	@Override
	public Collection<Integer> getAllowedUserIDs() {
		return getAllowedRestrictedAdminUserIDs();
	}
	
}
