package com.nordicpeak.flowengine.queries.ssbt;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
public class CompanyDetails extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 127379015192386731L;

	//UD0001
	@XMLElement
	private String companyName;

	//UD0003
	@XMLElement
	private String legalEntityAddress;

	@XMLElement
	private String legalEntityCOAddress;

	@XMLElement
	private String legalEntityZip;

	@XMLElement
	private String legalEntityPostalAddress;

	//UD0004
	@XMLElement
	private String email;
	
	//UD0006
	@XMLElement
	private String phone;

	//UD0023
	@XMLElement
	private String civilRegistrationAddress;

	@XMLElement
	private String civilRegistrationCOAddress;

	@XMLElement
	private String civilRegistrationZip;

	@XMLElement
	private String civilRegistrationPostalAddress;

	//UD0029
	@DAOManaged
	@XMLElement
	private String fTaxRegistered;
	
	//UD0031
	@DAOManaged
	@XMLElement
	private String vatRegistered;
	
	//UD0033
	@DAOManaged
	@XMLElement
	private String employerRegistration;
	
	//UD0045
	@XMLElement
	private String signing;

	//UD0046
	@XMLElement
	private String businessDescription;

	//UD0047
	@XMLElement
	private String officers;

	//UD0048
	@XMLElement
	private String shares;

	public String getCompanyName() {

		return companyName;
	}

	public void setCompanyName(String companyName) {

		this.companyName = companyName;
	}

	public String getLegalEntityAddress() {

		return legalEntityAddress;
	}

	public void setLegalEntityAddress(String legalEntityAddress) {

		this.legalEntityAddress = legalEntityAddress;
	}

	public String getLegalEntityCOAddress() {

		return legalEntityCOAddress;
	}

	public void setLegalEntityCOAddress(String legalEntityCOAddress) {

		this.legalEntityCOAddress = legalEntityCOAddress;
	}

	public String getLegalEntityZip() {

		return legalEntityZip;
	}

	public void setLegalEntityZip(String legalEntityZip) {

		this.legalEntityZip = legalEntityZip;
	}

	public String getLegalEntityPostalAddress() {

		return legalEntityPostalAddress;
	}

	public void setLegalEntityPostalAddress(String legalEntityPostalAddress) {

		this.legalEntityPostalAddress = legalEntityPostalAddress;
	}

	public String getEmail() {

		return email;
	}

	public void setEmail(String email) {

		this.email = email;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getCivilRegistrationAddress() {

		return civilRegistrationAddress;
	}

	public void setCivilRegistrationAddress(String civilRegistrationAddress) {

		this.civilRegistrationAddress = civilRegistrationAddress;
	}

	public String getCivilRegistrationCOAddress() {

		return civilRegistrationCOAddress;
	}

	public void setCivilRegistrationCOAddress(String civilRegistrationCOAddress) {

		this.civilRegistrationCOAddress = civilRegistrationCOAddress;
	}

	public String getCivilRegistrationZip() {

		return civilRegistrationZip;
	}

	public void setCivilRegistrationZip(String civilRegistrationZip) {

		this.civilRegistrationZip = civilRegistrationZip;
	}

	public String getCivilRegistrationPostalAddress() {

		return civilRegistrationPostalAddress;
	}

	public void setCivilRegistrationPostalAddress(String civilRegistrationPostalAddress) {

		this.civilRegistrationPostalAddress = civilRegistrationPostalAddress;
	}

	public String getSigning() {

		return signing;
	}

	public void setSigning(String signing) {

		this.signing = signing;
	}

	public String getBusinessDescription() {

		return businessDescription;
	}

	public void setBusinessDescription(String businessDescription) {

		this.businessDescription = businessDescription;
	}

	public String getOfficers() {

		return officers;
	}

	public void setOfficers(String officers) {

		this.officers = officers;
	}

	public String getShares() {

		return shares;
	}

	public void setShares(String shares) {

		this.shares = shares;
	}

	
	public String getfTaxRegistered() {
	
		return fTaxRegistered;
	}

	
	public void setfTaxRegistered(String fTaxRegistered) {
	
		this.fTaxRegistered = fTaxRegistered;
	}

	
	public String getVatRegistered() {
	
		return vatRegistered;
	}

	
	public void setVatRegistered(String vatRegistered) {
	
		this.vatRegistered = vatRegistered;
	}

	
	public String getEmployerRegistration() {
	
		return employerRegistration;
	}

	
	public void setEmployerRegistration(String employerRegistration) {
	
		this.employerRegistration = employerRegistration;
	}
}
