package com.nordicpeak.flowengine.queries.ssbt;

import java.io.Serializable;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;
import com.nordicpeak.flowengine.queries.ssbt.enums.CompanyType;

@XMLElement
public class CompanyTypeAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable {

	private static final long serialVersionUID = 4743563197621997249L;
	@XMLElement
	private final CompanyType companyType;
	
	public CompanyTypeAlternative(CompanyType companyType) {
		super();
		this.companyType = companyType;
	}

	@Override
	public Integer getAlternativeID() {

		return companyType.ordinal();
	}

	@Override
	public String getName() {

		return companyType.toString();
	}

	@Override
	public String getExportXMLValue() {

		return companyType.toString();
	}

	@Override
	public String getAttributeValue() {

		return null;
	}
}
