<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetPUDFromCitizenAddressEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetPUDFromCitizenAddressEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetPUDFromCitizenAddressEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetPUDFromCitizenAddressEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="noPUDFoundMessage" class="floatleft full">
					<xsl:value-of select="$i18n.noPUDFoundMessage" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'noPUDFoundMessage'" />
						<xsl:with-param name="name" select="'noPUDFoundMessage'" />
						<xsl:with-param name="element" select="SetPUDFromCitizenAddressEvaluator" />
					</xsl:call-template>
				</div>
			</div>		

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'noPUDFoundMessage'">
				<xsl:value-of select="$i18n.noPUDFoundMessage" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>