package com.nordicpeak.flowengine.integration.sokigo.beans;

import java.util.List;
import java.util.Map;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.childrelationprovider.Child;
import com.nordicpeak.childrelationprovider.exceptions.ChildRelationProviderException;
import com.nordicpeak.flowengine.integration.sokigo.SokigoSchoolTransportIntegrationProviderModule;
import com.nordicpeak.flowengine.interfaces.ImmutableFlow;
import com.nordicpeak.flowengine.queries.childquery.filterapi.FilterAPIChild;
import com.nordicpeak.flowengine.queries.childquery.interfaces.ChildQueryFilterEndpoint;
import com.nordicpeak.flowengine.queries.childquery.interfaces.ChildQueryFilterProvider;

@XMLElement(name = "ChildQueryFilterEndpoint")
public class SokigoSchoolTransportChildQueryFilterEndpoint extends GeneratedElementable implements ChildQueryFilterEndpoint {

	@XMLElement
	private final String name;

	@XMLElement(fixCase = true)
	private final List<String> fields;

	private final SokigoSchoolTransportIntegrationProviderModule adminModule;

	public SokigoSchoolTransportChildQueryFilterEndpoint(String name, List<String> fields, SokigoSchoolTransportIntegrationProviderModule adminModule) {
		super();
		this.name = name;
		this.fields = fields;
		this.adminModule = adminModule;
	}

	@Override
	public String toString() {
		return name;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public List<String> getFields() {
		return fields;
	}

	@Override
	public Map<String, FilterAPIChild> getChildren(Map<String, Child> navetChildMap, User user, String parentCitizenID, ImmutableFlow flow, AttributeHandler attributeHandler) throws ChildRelationProviderException {
		return adminModule.getChildren(this, navetChildMap, user, parentCitizenID, flow);
	}

	@Override
	public ChildQueryFilterProvider getProvider() {
		return adminModule;
	}

}
