<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:template match="Document">

		<div class="contentitem errands-wrapper">

			<xsl:apply-templates select="UpdateTableAttributeEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateTableAttributeEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="TableAttributeEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="TableAttributeEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="columnID" class="marginbottom">
					<xsl:value-of select="$i18n.Column" />
				</label>

				<div class="full">

					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'columnID'" />
						<xsl:with-param name="name" select="'columnID'" />
						<xsl:with-param name="selectedValue" select="TableAttributeEvaluator/columnID" />
						<xsl:with-param name="element" select="Columns/Column" />
						<xsl:with-param name="labelElementName" select="'label'" />
						<xsl:with-param name="valueElementName" select="'columnID'" />
						<xsl:with-param name="addEmptyOption" select="$i18n.Column.Select" />
					</xsl:call-template>

				</div>

			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="attributeName" class="floatleft clearboth">
					<xsl:value-of select="$i18n.AttributeName" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'" />
						<xsl:with-param name="name" select="'attributeName'" />
						<xsl:with-param name="title" select="$i18n.AttributeName" />
						<xsl:with-param name="element" select="TableAttributeEvaluator" />
						<xsl:with-param name="maxlength" select="'255'" />
					</xsl:call-template>
				</div>

			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'columnID'">
				<xsl:value-of select="$i18n.Column" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.AttributeName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>