package com.nordicpeak.flowengine.targetgroupflowbrowser;

import java.util.List;

import se.unlogic.standardutils.annotations.NoDuplicates;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "targetgroupflowbrowser_targetgroups")
@XMLElement
public class TargetGroup extends GeneratedElementable implements Comparable<TargetGroup> {

	@Key
	@DAOManaged(autoGenerated = true)
	@XMLElement
	private Integer targetGroupID;

	@DAOManaged
	@WebPopulate(maxLength = 255, required = true)
	@XMLElement
	private String name;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "targetgroupflowbrowser_targetgroup_flowfamilies", remoteValueColumnName = "flowFamilyID")
	@XMLElement(childName = "flowFamilyID")
	@NoDuplicates
	@WebPopulate(paramName = "flowFamilyID")
	private List<Integer> flowFamilyIDs;

	public Integer getTargetGroupID() {

		return targetGroupID;
	}

	public void setTargetGroupID(Integer targetGroupID) {

		this.targetGroupID = targetGroupID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public List<Integer> getFlowFamilyIDs() {

		return flowFamilyIDs;
	}

	public void setFlowFamilyIDs(List<Integer> flowFamilyIDs) {

		this.flowFamilyIDs = flowFamilyIDs;
	}

	@Override
	public int compareTo(TargetGroup other) {

		return name.toLowerCase().compareTo(other.getName().toLowerCase());
	}

	@Override
	public int hashCode() {

		final int prime = 31;
		int result = 1;
		result = prime * result + ((targetGroupID == null) ? 0 : targetGroupID.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		TargetGroup other = (TargetGroup) obj;
		if (targetGroupID == null) {
			if (other.targetGroupID != null) {
				return false;
			}
		} else if (!targetGroupID.equals(other.targetGroupID)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {

		return StringUtils.toLogFormat(name, 30) + " (targetGroupID: " + targetGroupID + ")";
	}

}
