package com.nordicpeak.flowengine.targetgroupflowbrowser;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.nordicpeak.flowengine.FlowBrowserModule;

import se.unlogic.hierarchy.backgroundmodules.AnnotatedBackgroundModule;
import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.TextFieldSettingDescriptor;
import se.unlogic.hierarchy.core.beans.SimpleBackgroundModuleResponse;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.BackgroundModuleResponse;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;

public class TargetGroupSearchBackgroundModule extends AnnotatedBackgroundModule {

	@ModuleSetting(allowsNull = true)
	@TextFieldSettingDescriptor(name = "Flow info module alias", description = "Full alias of the flow info module (related from contextpath)", required = false)
	protected String flowInfoModuleAlias;
	
	@InstanceManagerDependency
	private FlowBrowserModule flowBrowserModule;

	@Override
	protected BackgroundModuleResponse processBackgroundRequest(HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		Document doc = XMLUtils.createDomDocument();
		Element document = doc.createElement("Document");

		doc.appendChild(document);

		XMLUtils.appendNewElement(doc, document, "searchHints", flowBrowserModule.getSearchHints());
		XMLUtils.appendNewElement(doc, document, "flowInfoModuleURI", req.getContextPath() + flowInfoModuleAlias);

		if(flowBrowserModule.isSaveSearchInSession()) {
			XMLUtils.appendNewElement(doc, document, "lastSearchEnabled", true);
		}
		
		return new SimpleBackgroundModuleResponse(doc);
	}

}
