var lastSearchEnabled = false;
var useCategorySorting = true;

$(function() {
	
	var $bgSearchField = $("#bg-search-field");
	
	$bgSearchField.on("keyup", function () {
		$(this).parent().removeClass("searching");
		searchAjaxFlow($(this));
    }).on("keydown", function() {
    	$(this).parent().addClass("searching");
    }).on('focus blur', function() {
    	$(this).parent().toggleClass('focus');
	});
	
	$(".search-wrapper .search-btn").on("click", function(e) {
		e.preventDefault();
		searchAjaxFlow($bgSearchField);
		return false;
	});
	
	$(".search-wrapper .search-close-btn").on("click", function(e) {
		e.preventDefault();
		$(".search-result-wrapper").slideUp("fast").removeClass("active");
		$bgSearchField.parent().removeClass("search-active");
		$bgSearchField.val("");
		$.removeCookie("lastSearch");
		return false;
	});
	
	$("nav").before($(".search-result-wrapper"));
	
	searchAjaxFlow = function($searchField) {
		
		$searchField.parent().addClass("search-active");
		
		var searchStr = $searchField.val();

		var $searchResultWrapper = $(".search-result-wrapper");
		var $column1 = $searchResultWrapper.find(".column-1");
		var $column2 = $searchResultWrapper.find(".column-2");
		var $searchResultList = $searchResultWrapper.find(".category-list");
		var $searchResultTitle = $searchResultWrapper.find(".search-results-title");
		var $singleFlowList = $("<ul class='flow-list' />");
		
		if(searchStr != "") {
			
			if(lastSearchEnabled && $(".flow-wrapper").length > 0) {
				$.cookie("lastSearch", searchStr, {});
			}
			
			$.ajax({
				
				cache: false,
				url: $searchField.data("searchmoduleuri") + "/search/json",
				data : {
					q : encodeURIComponent(searchStr)
				},
				dataType: "json",
				contentType: "application/x-www-form-urlencoded;charset=UTF-8",
				error: function (xhr, ajaxOptions, thrownError) { },
				success: function(response) {

					var result = response;
					
					$searchResultList.find(".category").remove();
					$searchResultList.find(".flow-list").remove();
					
					var hitCount = 0;
					
					if(result.Flows.length > 0) {
						
						var categories = {};
						
						$.each(result.Flows, function(key, flow) {
							
							hitCount++;
							
							var $flow = $("<li id='flow_'" + flow.ID + " data-flowid='" + flow.ID + "' data-flowname='" + flow.Name + "'>" + 
												"<div class='flow'>" + 
													"<figure><img alt='' src='" + flow.Icon + "' /></figure>" +
													"<div>" +
														"<a title='Visa e-tjänst' href='" + flow.URL + "'><h2>" + flow.Name + "</h2></a>" + 
														"<div class='description'>" + flow.ShortDescription + "</div>" +
													"</div>" +
													"<a title='Visa e-tjänsten' href='" + flow.URL + "' class='btn btn-blue btn-inline only-desktop-tablet'>Till tjänsten</a>" + 
												"</div>" + 
											"</li>");
							
							if(useCategorySorting) {
							
								var $categoryFlows = categories[flow.Category];
								
								if($categoryFlows == undefined) {
									
									$categoryFlows = $("<ul class='flow-list' />");
									
								}
								
								$categoryFlows.append($flow);
								
								categories[flow.Category] = $categoryFlows;
							
							} else {
								
								$singleFlowList.append($flow);
								
							}
							
						});
						
						if(useCategorySorting) {
						
							var colCount = Math.round((Object.keys(categories).length / 2));
							
							$.each(categories, function(key, $flows) {
								
								var $category = $("<div class='category'><h3>" + key + "</h3></div>")
								
								$category.append($flows);
								
								if(colCount > 0) {
									$column1.append($category);
								} else {
									$column2.append($category);
								}
								
								colCount--;
							});
						
						} else {
							
							$searchResultList.append($singleFlowList);
							
						}
						
					}
					
					if($column2.find(".category").length == 0) {
						$column1.addClass("full");
						$column2.hide();
					} else {
						$column1.removeClass("full");
						$column2.show();
					}
					
					$searchResultTitle.find(".title").text(searchStr);
			        $searchResultTitle.find(".hits").text(hitCount);
			        
			        $searchResultWrapper.addClass("active");
			        $searchResultWrapper.show();
					
				}
				
			});
	        
	    } else {
	    	
	    	$searchField.parent().removeClass("search-active");
	    	$searchResultTitle.find(".title").text("");
	    	$searchResultTitle.find(".hits").text(0);
	    	$searchResultWrapper.removeClass("active");
	    	$searchResultWrapper.hide();
	    	$searchResultList.find(".category").remove();
	 
    		$.removeCookie("lastSearch");
	    	
	    }
		
	};
	
	if(lastSearchEnabled && $(".flow-wrapper").length > 0) {
		
		var lastSearch = $.cookie("lastSearch");
		
		if(lastSearch != undefined && lastSearch != "") {
			$bgSearchField.val(lastSearch);
			searchAjaxFlow($bgSearchField);			
		}
				
	} else {
		$.removeCookie("lastSearch");
	}
	
});