package com.nordicpeak.flowengine.integration.treserva.beans;

import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.object.ObjectUtils;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.integration.base.beans.BaseIntegrationEndpoint;

@Table(name = "treserva_integration_endpoints")
@XMLElement(name = "Endpoint")
public class IntegrationEndpoint extends BaseIntegrationEndpoint {

	@DAOManaged
	@OneToMany
	private List<IntegrationSettings> settings;

	@DAOManaged
	@XMLElement
	private String ekonomisktBistandHmacID;

	@DAOManaged
	@XMLElement
	private String ekonomisktBistandHmacKey;

	@DAOManaged
	@XMLElement
	private String ekonomisktBistandAPIBaseURL;

	@DAOManaged
	@XMLElement
	private String ekonomisktBistandHmacBaseURL;

	@DAOManaged
	@XMLElement
	private String minaIFOArendeHmacID;

	@DAOManaged
	@XMLElement
	private String minaIFOArendeHmacKey;

	@DAOManaged
	@XMLElement
	private String minaIFOArendeAPIBaseURL;

	@DAOManaged
	@XMLElement
	private String minaIFOArendeHmacBaseURL;

	@Override
	public Element toXML(Document doc) {

		Element element = super.toXML(doc);

		if (hasMinaIFOArendeConfiguration()) {

			XMLUtils.appendNewElement(doc, element, "hasMinaIFOArendeConfiguration", true);
		}

		return element;
	}

	public boolean hasMinaIFOArendeConfiguration() {

		return !ObjectUtils.containsNull(minaIFOArendeHmacID, minaIFOArendeHmacKey, minaIFOArendeAPIBaseURL, minaIFOArendeHmacBaseURL);
	}

	public List<IntegrationSettings> getSettings() {

		return settings;
	}

	public void setSettings(List<IntegrationSettings> settings) {

		this.settings = settings;
	}

	public String getEkonomisktBistandHmacID() {

		return ekonomisktBistandHmacID;
	}

	public void setEkonomisktBistandHmacID(String ekonomisktBistandHmacID) {

		this.ekonomisktBistandHmacID = ekonomisktBistandHmacID;
	}

	public String getEkonomisktBistandHmacKey() {

		return ekonomisktBistandHmacKey;
	}

	public void setEkonomisktBistandHmacKey(String ekonomisktBistandHmacKey) {

		this.ekonomisktBistandHmacKey = ekonomisktBistandHmacKey;
	}

	public String getEkonomisktBistandAPIBaseURL() {

		return ekonomisktBistandAPIBaseURL;
	}

	public void setEkonomisktBistandAPIBaseURL(String ekonomisktBistandAPIBaseURL) {

		this.ekonomisktBistandAPIBaseURL = ekonomisktBistandAPIBaseURL;
	}

	public String getEkonomisktBistandHmacBaseURL() {

		return ekonomisktBistandHmacBaseURL;
	}

	public void setEkonomisktBistandHmacBaseURL(String ekonomisktBistandHmacBaseURL) {

		this.ekonomisktBistandHmacBaseURL = ekonomisktBistandHmacBaseURL;
	}

	public String getMinaIFOArendeHmacID() {

		return minaIFOArendeHmacID;
	}

	public void setMinaIFOArendeHmacID(String minaIFOArendeHmacID) {

		this.minaIFOArendeHmacID = minaIFOArendeHmacID;
	}

	public String getMinaIFOArendeHmacKey() {

		return minaIFOArendeHmacKey;
	}

	public void setMinaIFOArendeHmacKey(String minaIFOArendeHmacKey) {

		this.minaIFOArendeHmacKey = minaIFOArendeHmacKey;
	}

	public String getMinaIFOArendeAPIBaseURL() {

		return minaIFOArendeAPIBaseURL;
	}

	public void setMinaIFOArendeAPIBaseURL(String minaIFOArendeAPIBaseURL) {

		this.minaIFOArendeAPIBaseURL = minaIFOArendeAPIBaseURL;
	}

	public String getMinaIFOArendeHmacBaseURL() {

		return minaIFOArendeHmacBaseURL;
	}

	public void setMinaIFOArendeHmacBaseURL(String minaIFOArendeHmacBaseURL) {

		this.minaIFOArendeHmacBaseURL = minaIFOArendeHmacBaseURL;
	}
}
