package com.nordicpeak.flowengine.integration.treservaddecision.beans;

import java.util.Base64;
import java.util.List;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import flexjson.JSON;

@XMLElement(name = "Document")
public class DecisionDocument extends GeneratedElementable {

	private static final String CONTENT_FILE_TYPE = ".pdf";

	@JSON(name = "beslutNumber")
	@XMLElement
	private Integer decisionNumber;

	@JSON(name = "doc")
	private String content;

	@Override
	public String toString() {

		return "(decisionNumber=" + decisionNumber + ")";
	}

	public Integer getDecisionNumber() {

		return decisionNumber;
	}

	public void setDecisionNumber(Integer decisionNumber) {

		this.decisionNumber = decisionNumber;
	}

	public String getContent() {

		return content;
	}

	public void setContent(String content) {

		this.content = content;
	}

	public String getDocumentFileName() {

		return decisionNumber + CONTENT_FILE_TYPE;
	}

	public byte[] getDecodedContent() {

		return Base64.getDecoder().decode(content);
	}

	public static DecisionDocument getValidDecisionDocument(List<DecisionDocument> decisionDocuments, String decisionNumber) {

		for (DecisionDocument decisionDocument : decisionDocuments) {

			if (decisionDocument.getContent() != null && decisionDocument.getDecisionNumber() != null && decisionDocument.getDecisionNumber().toString().equals(decisionNumber)) {

				return decisionDocument;
			}
		}

		return null;
	}

}
