var i18n = {
	LoadingDecisions: "LOADING DECISIONS",
	ErrorGettingDecisions: "ERROR GETTING DECISIONS",
};

$(function() {
	
	var $tab = $("a[href='#treserva-decision']");

	$tab.on("click", function(){
		
		getTabContent();
	});
	
	$(window).on("load", function(){
		
		if (window.location.hash === "#treserva-decision") {
			
			getTabContent();
		}
	});
	
	function getTabContent(){
		
		var $info = $("#treserva-decision-info");
		var $content = $("#treserva-decision-content");
		
		$info.html(i18n.LoadingDecisions).removeClass("error").closest(".spinner-wrapper").removeClass("hidden").addClass("spinning");
		
		$content.empty();

		$.get($content.data("url"), function(data) {
			
			$info.removeClass("error").closest(".spinner-wrapper").removeClass("spinning").addClass("hidden");
			
			$content.html(data);
			
			initTabContent();
			
		}).fail(function(){
			
			$info.html(i18n.ErrorGettingDecisions).addClass("error").closest(".spinner-wrapper").removeClass("hidden spinning");	
			
			$content.empty();
		});
	}
	
	function initTabContent() {
		
		var $form = $("#treserva-decision-form");
		var $table = $("#treserva-decision-table");
		var $rowSelects = $table.find("input[type='checkbox'][name='decisionID']");
		var $preview = $("#treserva-decision-form-preview-button");
		var $filter = $("#treserva-decision-month-filter");

		$filter.on("change", function(){
			
			var selectedMonth = this.value;

			$form.toggle(!!selectedMonth);
			
			if (selectedMonth) {
				
				$table.find("tr").each(function(){
					
					var intendedMonth = this.dataset.intendedMonth;
					
					$(this).toggle(!intendedMonth || intendedMonth.indexOf(selectedMonth) == 0);
				});
			}		
			
			$table.find("tr:not(:first):visible:even").removeClass("odd").addClass("even");
			$table.find("tr:not(:first):visible:odd").removeClass("even").addClass("odd");
			
			$rowSelects.prop("checked", false).trigger("change");
		});
		
		$rowSelects.on("change", function(){
			
			$preview.prop("disabled", !$rowSelects.is(":checked"));
			
			$(this).closest("tr").find("input[type='hidden']").prop("disabled", !this.checked);
			
		}).trigger("change");
		
		$preview.featherlight("#treserva-preview-decisions-modal", {
			
			afterContent: function() {
				
				var $modal = this.$content.removeClass("no-sections");
				
				$rowSelects.filter(":checked").each(function(){
					
					var $row = $(this).closest("tr");
					
					var number = $row.data("number");
					var message = $row.data("message");
					var name = $row.data("name");
					
					var $decisionPreview = $modal.find("#treserva-preview-decision-template").clone();
					
					$decisionPreview.removeClass("hidden");
					$decisionPreview.removeAttr("id");
					
					$decisionPreview.find("#treserva-preview-decision-template-name").removeAttr("id").html(name);
					$decisionPreview.find("#treserva-preview-decision-template-number").removeAttr("id").html(number);
					$decisionPreview.find("#treserva-preview-decision-template-message").removeAttr("id").val(message);
					
					$modal.find(".modal-body").append($decisionPreview);
					
				});
				
				$modal.find("#treserva-preview-decisions-modal-submit-button").on("click", function(){
					
					$form.trigger("submit");
				});
			}
		});
	}
	
});