package com.nordicpeak.flowengine.evaluators.setdropdownalternativeparameter;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

import com.nordicpeak.flowengine.beans.QueryModification;
import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;
import com.nordicpeak.flowengine.interfaces.EvaluationCallback;
import com.nordicpeak.flowengine.interfaces.EvaluationEventListener;
import com.nordicpeak.flowengine.interfaces.EvaluationHandler;
import com.nordicpeak.flowengine.interfaces.ParameterEvaluator;
import com.nordicpeak.flowengine.interfaces.QueryInstance;

@Table(name = "set_dropdown_alternative_param_evaluators")
@XMLElement
public class SetDropDownAlternativeParameterEvaluator extends BaseEvaluator implements EvaluationEventListener, ParameterEvaluator {

	private static final long serialVersionUID = 1129410235430246625L;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement(cdata = true)
	private String paramName;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean setAlternativeBasedOnID;

	private boolean initialized;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<>();

		paramName = XMLValidationUtils.validateParameter("paramName", xmlParser, false, 1, 255, StringPopulator.getPopulator(), errors);
		setAlternativeBasedOnID = xmlParser.getPrimitiveBoolean("setAlternativeBasedOnID");

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	@Override
	public String toString() {

		return evaluatorDescriptor.toString();
	}

	@Override
	public boolean forceAjaxPosting() {

		return true;
	}

	@Override
	public boolean requiresInitialization() {

		return true;
	}

	@Override
	public String getParamName() {

		return paramName;
	}

	public void setParamName(String expression) {

		this.paramName = expression;
	}

	public boolean isSetAlternativeBasedOnID() {

		return setAlternativeBasedOnID;
	}

	public void setSetAlternativeBasedOnID(boolean setAlternativeBasedOnID) {

		this.setAlternativeBasedOnID = setAlternativeBasedOnID;
	}

	@Override
	public boolean supportsEvent(Object event) {

		return false;
	}

	@Override
	public List<QueryModification> processEvent(Object event, QueryInstance queryInstance, User user, User poster, EvaluationCallback callback, EvaluationHandler evaluationHandler) {

		return null;
	}

	public boolean isInitialized() {

		return initialized;
	}

	public void setInitialized(boolean initialized) {

		this.initialized = initialized;
	}
}
