package com.nordicpeak.flowengine.queries.unsecuremultisignquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

public class UnsecureMultiSignQueryCRUD extends BaseQueryCRUD<UnsecureMultiSignQuery, UnsecureMultiSignQueryProviderModule> {
	
	protected AnnotatedDAOWrapper<UnsecureMultiSignQuery, Integer> queryDAO;
	
	public UnsecureMultiSignQueryCRUD(AnnotatedDAOWrapper<UnsecureMultiSignQuery, Integer> queryDAO, BeanRequestPopulator<UnsecureMultiSignQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, UnsecureMultiSignQueryProviderModule callback) {
		
		super(UnsecureMultiSignQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
		
		this.queryDAO = queryDAO;
	}
	
	@Override
	protected UnsecureMultiSignQuery populateFromUpdateRequest(UnsecureMultiSignQuery bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {
		
		UnsecureMultiSignQuery query = super.populateFromUpdateRequest(bean, req, user, uriParser);
		
		List<ValidationError> validationErrors = new ArrayList<ValidationError>();
		
		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);
		
		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}
		
		return query;
	}
	
}
