<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">

			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="UserListQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{UserListQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="UserListQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<div class="full bigmarginbottom">
			
				<table class="full">
					<thead>
						<tr>
							<th>
								<xsl:value-of select="$i18n.Column.Firstname"/>
							</th>
							<th>
								<xsl:value-of select="$i18n.Column.Lastname"/>
							</th>
							
							<xsl:if test="UserListQueryInstance/UserListQuery/showUsername = 'true'">
								<th>
									<xsl:value-of select="$i18n.Column.Username"/>
								</th>
							</xsl:if>
							
							<xsl:if test="UserListQueryInstance/UserListQuery/showCitizenIdentifier = 'true'">
								<th>
									<xsl:value-of select="$i18n.Column.SocialSecurityNumber"/>
								</th>
							</xsl:if>
							
							<xsl:if test="UserListQueryInstance/UserListQuery/showContactInformation = 'true'">
								<th>
									<xsl:value-of select="$i18n.Column.Email"/>
								</th>
								<th>
									<xsl:value-of select="$i18n.Column.Phone"/>
								</th>
							</xsl:if>
						</tr>
						
					</thead>
					<tbody>
					
						<xsl:apply-templates select="UserListQueryInstance/Users/user" mode="show">
							<xsl:with-param name="showUsername" select="UserListQueryInstance/UserListQuery/showUsername"/>
							<xsl:with-param name="showCitizenIdentifier" select="UserListQueryInstance/UserListQuery/showCitizenIdentifier"/>
							<xsl:with-param name="showContactInformation" select="UserListQueryInstance/UserListQuery/showContactInformation"/>
						</xsl:apply-templates>
					
					</tbody>
				</table>
						
			</div>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="user" mode="show">
		<xsl:param name="showUsername" select="false()"/>
		<xsl:param name="showCitizenIdentifier" select="null"/>
		<xsl:param name="showContactInformation" select="null"/>
	
		<tr>
			<td>
				<xsl:value-of select="firstname" />
			</td>
			<td>
				<xsl:value-of select="lastname" />
			</td>
			
			<xsl:if test="$showUsername = 'true'">
				<td>
					<xsl:value-of select="username" />	
				</td>
			</xsl:if>			
			
			<xsl:if test="$showCitizenIdentifier = 'true'">
				<td>
					<xsl:value-of select="citizenIdentifier" />	
				</td>
			</xsl:if>
			
			<xsl:if test="$showContactInformation = 'true'">
				<td>
					<xsl:value-of select="email" />
				</td>
				<td>
					<xsl:value-of select="phone" />
				</td>	
			</xsl:if>
		</tr>
	</xsl:template>
		
</xsl:stylesheet>