package com.nordicpeak.flowengine.evaluators.dynamicweightquerystateevaluator;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;

@Table(name = "dynamic_weight_query_state_evaluators_values")
@XMLElement
public class DynamicWeightQueryStateEvaluatorValues extends GeneratedElementable implements XMLParserPopulateable, Serializable {

	private static final long serialVersionUID = 3417430939090738323L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer valueID;

	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private Integer fromValue;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private Integer toValue;

	
	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	private DynamicWeightQueryStateEvaluator weightQueryStateEvaluator;

	public Integer getValueID() {

		return valueID;
	}

	public void setValueID(Integer valueID) {

		this.valueID = valueID;
	}

	public Integer getFromValue() {

		return fromValue;
	}

	public void setFromValue(Integer fromValue) {

		this.fromValue = fromValue;
	}

	public Integer getToValue() {

		return toValue;
	}

	public void setToValue(Integer toValue) {

		this.toValue = toValue;
	}

	
	public DynamicWeightQueryStateEvaluator getWeightQueryStateEvaluator() {
	
		return weightQueryStateEvaluator;
	}

	
	public void setWeightQueryStateEvaluator(DynamicWeightQueryStateEvaluator weightQueryStateEvaluator) {
	
		this.weightQueryStateEvaluator = weightQueryStateEvaluator;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> validationErrors = new ArrayList<>();
		
		valueID = xmlParser.getInteger("valueID");
		
		fromValue = xmlParser.getInteger("fromValue");

		toValue = xmlParser.getInteger("toValue");
		
		if(fromValue == null) {
			validationErrors.add(new ValidationError("FromValueNotSet"));
		}
		if(toValue == null) {
			validationErrors.add(new ValidationError("ToValueNotSet"));
		}
		
		if(!CollectionUtils.isEmpty(validationErrors)) {
			throw new ValidationException(validationErrors);
		}

	}
}
