package com.nordicpeak.flowengine.evaluators.setattributefromweightevaluator;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SetAttributeFromWeightEvaluatorCRUD extends BaseEvaluatorCRUD<SetAttributeFromWeightEvaluator, SetAttributeFromWeightEvaluationProviderModule> {
	
	private static final AnnotatedRequestPopulator<SetAttributeFromWeightEvaluator> POPULATOR = new AnnotatedRequestPopulator<SetAttributeFromWeightEvaluator>(SetAttributeFromWeightEvaluator.class);
	
	public SetAttributeFromWeightEvaluatorCRUD(Class<SetAttributeFromWeightEvaluator> beanClass, AnnotatedDAOWrapper<SetAttributeFromWeightEvaluator, Integer> evaluatorDAO, SetAttributeFromWeightEvaluationProviderModule callback) {
		
		super(beanClass, evaluatorDAO, POPULATOR, "SetAttributeFromWeightEvaluator", "set attribute from weight evaluator", null, callback);
	}
	
	@Override
	protected void validateUpdatePopulation(SetAttributeFromWeightEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {
		
		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		if (bean.getFromValue() != null && bean.getToValue() != null && bean.getFromValue() > bean.getToValue()) {
			
			errors.add(new ValidationError("FromValueBiggerThanToValue"));
		}
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
		
		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
	}
	
}
