package com.nordicpeak.flowengine.evaluators.setweightbyageevaluator;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SetWeightByAgeEvaluatorCRUD extends BaseEvaluatorCRUD<SetWeightByAgeEvaluator, SetWeightByAgeEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<SetWeightByAgeEvaluator> POPULATOR = new AnnotatedRequestPopulator<SetWeightByAgeEvaluator>(SetWeightByAgeEvaluator.class);

	public SetWeightByAgeEvaluatorCRUD(Class<SetWeightByAgeEvaluator> beanClass, AnnotatedDAOWrapper<SetWeightByAgeEvaluator, Integer> evaluatorDAO, SetWeightByAgeEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SetWeightByAgeEvaluator", "set weight by age evaluator", null, callback);
	}

	@Override
	protected void validateUpdatePopulation(SetWeightByAgeEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		List<ValidationError> errors = new ArrayList<ValidationError>();

		if (bean.getMinAge() != null && bean.getMaxAge() != null && bean.getMinAge() > bean.getMaxAge()) {

			errors.add(new ValidationError("MinAgeBiggerThanMaxAge"));
		}

		if (bean.getMinAge() == null && bean.getMaxAge() == null) {

			errors.add(new ValidationError("NoAgeRangeSpecified"));
		}

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}

		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
	}

}
