package com.nordicpeak.flowengine.evaluators.setweightbycontactfieldevaluator;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.object.ObjectUtils;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

@Table(name = "set_weight_by_contact_field_evaluator_values")
@XMLElement(name = "Value")
public class SetWeightByContactFieldEvaluatorValue extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -336493853396860255L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer valueID;

	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	@Key
	private SetWeightByContactFieldEvaluator evaluator;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String matchedValue;

	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private Integer weight;

	public SetWeightByContactFieldEvaluatorValue() {

		super();
	}

	public SetWeightByContactFieldEvaluatorValue(SetWeightByContactFieldEvaluator evaluator, String matchedValue, Integer weight) {

		super();
		this.evaluator = evaluator;
		this.matchedValue = matchedValue;
		this.weight = weight;
	}

	public Integer getValueID() {

		return valueID;
	}

	public void setValueID(Integer valueID) {

		this.valueID = valueID;
	}

	public SetWeightByContactFieldEvaluator getEvaluator() {

		return evaluator;
	}

	public void setEvaluator(SetWeightByContactFieldEvaluator evaluator) {

		this.evaluator = evaluator;
	}

	public String getMatchedValue() {

		return matchedValue;
	}

	public void setMatchedValue(String matchedValue) {

		this.matchedValue = matchedValue;
	}

	public Integer getWeight() {

		return weight;
	}

	public void setWeight(Integer weight) {

		this.weight = weight;
	}

	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<>();

		matchedValue = XMLValidationUtils.validateParameter("matchedValue", xmlParser, false, 1, 255, StringPopulator.getPopulator(), errors);
		weight = XMLValidationUtils.validateParameter("weight", xmlParser, true, IntegerPopulator.getPopulator(), errors);

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	public boolean isConfigured() {

		return !ObjectUtils.containsNull(weight, matchedValue);
	}

}
