<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>	

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetWeightByDateEvaluator" />

		</div>

	</xsl:template>

	<xsl:template match="UpdateSetWeightByDateEvaluator">
	
		<xsl:variable name="evaluator" select="SetWeightByDateEvaluator" />

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.Title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="$evaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />
		
		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="$evaluator" />
			</xsl:call-template>

			<div class="clearboth floatleft marginbottom">
	
				<label class="floatleft full">
					<xsl:value-of select="$i18n.Date.Month.Title" />
					<span class="required">*</span>
				</label>
			
				<xsl:value-of select="$i18n.Date.Month.Description" />
				
			</div>
			
			<xsl:call-template name="monthCheckboxes" >
				<xsl:with-param name="evaluator" select="$evaluator"/>
			</xsl:call-template>

			<div class="clearboth floatleft marginbottom">
	
				<label class="floatleft full">
					<xsl:value-of select="$i18n.Date.DayOfMonth.Title" />
					<span class="required">*</span>
				</label>
			
				<br/>
			
				<xsl:value-of select="$i18n.Date.DayOfMonth.Description" />
				
			</div>
			
			<div class="clearboth floatleft marginbottom twenty">
			
				<xsl:value-of select="$i18n.Date.DayOfMonth.Min" />
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'minDayOfMonth'" />
					<xsl:with-param name="name" select="'minDayOfMonth'" />
					<xsl:with-param name="element" select="$evaluator" />
				</xsl:call-template>
				
			</div>
		
			<div class="clearboth floatleft marginbottom twenty">
			
				<xsl:value-of select="$i18n.Date.DayOfMonth.Max" />
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'maxDayOfMonth'" />
					<xsl:with-param name="name" select="'maxDayOfMonth'" />
					<xsl:with-param name="element" select="$evaluator" />
				</xsl:call-template>
				
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.WeightType" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="$evaluator" />
					</xsl:call-template>
				</div>
				
			</div>
			
			<div class="clearboth floatleft marginbottom twenty">
			
				<xsl:value-of select="$i18n.Weight" />
				<span class="required">*</span>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'weight'" />
					<xsl:with-param name="name" select="'weight'" />
					<xsl:with-param name="element" select="$evaluator" />
				</xsl:call-template>
				
			</div>
					
			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>
		
	<xsl:template name="monthCheckboxes">
		<xsl:param name="evaluator" />
	
		<div class="floatleft full bigmarginbottom">
		
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'JANUARY'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.January" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'FEBRUARY'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.February" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'MARCH'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.March" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'APRIL'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.April" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'MAY'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.May" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'JUNE'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.June" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'JULY'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.July" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'AUGUST'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.August" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'SEPTEMBER'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.September" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'OCTOBER'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.October" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'NOVEMBER'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.November" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
			<xsl:call-template name="monthCheckbox">
				<xsl:with-param name="value" select="'DECEMBER'" />
				<xsl:with-param name="text" select="$i18n.Date.Month.December" />
				<xsl:with-param name="evaluator" select="$evaluator" />
			</xsl:call-template>
			
		</div>
				
	</xsl:template>
	
	<xsl:template name="monthCheckbox">
		<xsl:param name="value" />
		<xsl:param name="text" />
		<xsl:param name="evaluator" />
	
		<div>
		
			<label>
			
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="name" select="'months'"/>
					<xsl:with-param name="element" select="$evaluator" />
					<xsl:with-param name="value" select="$value" />
					<xsl:with-param name="valueElementName" select="'month'" />
				</xsl:call-template>
				
				<xsl:value-of select="$text" />
				
			</label>
		
		</div>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MinDayOfMonthBiggerThanMaxDayOfMonth']">

		<p class="error">
			<xsl:value-of select="$i18n.Validation.MinDayOfMonthBiggerThanMaxDayOfMonth" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'NoAgeRangeSpecified']">

		<p class="error">
			<xsl:value-of select="$i18n.Validation.NoDayOfMonthRangeSpecified" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.WeightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'weight'">
				<xsl:value-of select="$i18n.Weight" />
			</xsl:when>
			<xsl:when test="$fieldName = 'months'">
				<xsl:value-of select="$i18n.Date.Month.Title" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minDayOfMonth'">
				<xsl:value-of select="$i18n.Date.DayOfMonth.Min" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxDayOfMonth'">
				<xsl:value-of select="$i18n.Date.DayOfMonth.Max" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>