<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateWeightCalculatedQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
			
		<div class="floatleft full bigmarginbottom">

			<label for="weightType" class="floatleft full">
				<xsl:value-of select="$i18n.expression" />
				<span class="required">*</span>
			</label>
			
			<p><xsl:value-of select="$i18n.expressionDescription" /><br/><xsl:value-of select="$i18n.expressionDescription2" /></p>

			<div class="floatleft full">
				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'expression'" />
					<xsl:with-param name="name" select="'expression'" />
					<xsl:with-param name="element" select="WeightCalculatedQueryStateEvaluator" />
				</xsl:call-template>
			</div>
		</div>
			
		<label class="floatleft full">
			<xsl:value-of select="$i18n.weight.title" />
		</label>
		
		<div class="clearboth floatleft marginbottom">
			<xsl:value-of select="$i18n.weight.description" />
		</div>
		
		<div class="clearboth floatleft marginbottom twenty">
			<xsl:value-of select="$i18n.from" />
			<span class="required">*</span>
			<xsl:call-template name="createTextField">
				<xsl:with-param name="id" select="'fromValue'" />
				<xsl:with-param name="name" select="'fromValue'" />
				<xsl:with-param name="element" select="$queryStateEvaluator" />
			</xsl:call-template>
		</div>
	
		<div class="clearboth floatleft marginbottom twenty">
			<xsl:value-of select="$i18n.to" />
			<xsl:call-template name="createTextField">
				<xsl:with-param name="id" select="'toValue'" />
				<xsl:with-param name="name" select="'toValue'" />
				<xsl:with-param name="element" select="$queryStateEvaluator" />
			</xsl:call-template>
		</div>
		
	</xsl:template>

	<xsl:template match="UpdateWeightCalculatedQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="WeightCalculatedQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'FromValueBiggerThanToValue']">
	
		<p class="error">
			<xsl:value-of select="$i18n.FromValueBiggerThanToValue" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'queryState'">
				<xsl:value-of select="$i18n.queryState" />
			</xsl:when>
			<xsl:when test="$fieldName = 'toValue'">
				<xsl:value-of select="$i18n.to" />
			</xsl:when>
			<xsl:when test="$fieldName = 'fromValue'">
				<xsl:value-of select="$i18n.from" />
			</xsl:when>
			<xsl:when test="$fieldName = 'expression'">
				<xsl:value-of select="$i18n.expression" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>